﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b);
    }
    else
    {
        return (binpow(n, p - 1) * n);
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

struct kht
{
    struct Line
    {
        ld k, b;
        ld operator&(const Line& oth)
        {
            return (oth.b - b) / (ld)(k - oth.k);
        }
        ld operator()(ld x)
        {
            return k * x + b;
        }
    };
    vector<Line> lines;
    vector<ld> points{-LINF};
    void add(ld k, ld b)
    {
        Line a{ k,b };
        while (lines.size() > 1 &&
            (points.back()) >= (a & lines[lines.size()-2]))
        {
            lines.pop_back();
            points.pop_back();
        }
        if (points.empty()) points.push_back(-LINF);
        if(!lines.empty()) points.push_back(lines.back() & a);
        lines.push_back(a);
    }
    ld get(ll x)
    {
        auto it = lower_bound(points.begin(), points.end(), x);
        int i = it - points.begin() - 1;
        return lines[i](x);
    }
};

int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    int n; ld m, c;
    cin >> n >> m >> c;
    kht k;
    k.add(0, 0);
    for (int i = 0; i < n; i++)
    {
        ld x, t;
        cin >> x >> t;
        ld dp = (k.get(x) + x*x/c);
        k.add(-2 * x/c, x * x/c + t + dp);
    }
    cout << fixed << k.get(m) + m * m / c;
}