﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
constexpr int INF = 1e9 + 7;
constexpr ll LINF = 1e18 + 7;
constexpr int MOD = 998244353;
constexpr int SZ = 1e5 + 1;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b);
    }
    else
    {
        return (binpow(n, p - 1) * n);
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<int>cnt_crash(SZ);
    vector<map<int, int>>cols(n);
    vector<int>cnt_edges(SZ);
    vector<bool>good(SZ, 1);
    int res = 0;
    while (q--) {
        char t;
        cin >> t;
        int u, v, c;
        cin >> u >> v >> c;
        --u; --v; --c;
        if (t == '+') {
            cols[u][c]++;
            cols[v][c]++;
            if (good[c])++res;
            if (cols[u][c] == 2) {
                cnt_crash[c]++;
            }
            if (cols[v][c] == 2) {
                cnt_crash[c]++;
            }
            cnt_edges[c]++;
            if (cnt_crash[c] && good[c]) {
                res -= cnt_edges[c];
                good[c] = 0;
            }
            
            

        }
        else {
            cols[u][c]--;
            cols[v][c]--;
            if (good[c])--res;
            if (cols[u][c] == 1) {
                cnt_crash[c]--;
            }
            if (cols[v][c] == 1) {
                cnt_crash[c]--;
            }
            cnt_edges[c]--;
            if (!cnt_crash[c] && !good[c]) {
                res += cnt_edges[c];
                good[c] = 1;
            }
            
        }
        cout << res << "\n";

    }
}