﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;
const int SZ = 3e5 + 1;
const ll P1 = 17, P2 = 37, P3 = 43;
const ll MOD1 = 1e9 + 7, MOD2 = 988244353, MOD3 = 1e9 + 1;
vector<ll>p1, p2, p3; 

ll binpow(ll s, ll n, ll mod) {
    if (n == 0) return 1;
    if (n % 2 == 1) return binpow(s, n - 1, MOD) * s % MOD;
    ll d = binpow(s, n / 2, mod);
    return d * d % mod;
}
struct Hash {
    vector<ll> h1, h2, h3;
    Hash(const vector<int>& a) {
        int n = a.size();
        h1.resize(n + 1);
        h2.resize(n + 1);
        h3.resize(n + 1);
        for (int i = 0; i < n; ++i) {
            h1[i + 1] = (h1[i] * P1 % MOD1 + a[i]+1) % MOD1;
            h2[i + 1] = (h2[i] * P2 % MOD2 + a[i]+1) % MOD2;
            h3[i + 1] = (h3[i] * P3 % MOD3 + a[i]+1) % MOD3;
        }
    }
    tuple <ll, ll, ll>hash_on_seg(int l, int r) {
        return { (h1[r] - ((h1[l] * p1[r - l]) % MOD1) + MOD1) % MOD1, 
           (h2[r] - ((h2[l] * p2[r - l]) % MOD2) + MOD2) % MOD2,
           (h3[r] - ((h3[l] * p3[r - l]) % MOD3) + MOD3) % MOD3 };
    }
};

bool is_equal(Hash& a, Hash& b, int l1, int r1, int l2, int r2) {
    auto x = a.hash_on_seg(l1, r1), y = b.hash_on_seg(l2, r2);
    return x == y;
}
vector<vector<pair<int,int>>>g;
vector<int> top;
vector<int> topused;
void dfs(int v)
{
    topused[v] = true;
    for (auto [u, c] : g[v])
    {
        if (!topused[u])
        {
            dfs(u);
        }
    }
    top.push_back(v);
}
void solve() {
    
    int n, m, k;
    cin >> n >> m >> k;
    vector<int>p(n), s(m), perm_pos(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> p[i]; --p[i];
        perm_pos[p[i]] = i;
    }
    for (int i = 0; i < m; ++i) {
        cin >> s[i];
        s[i]--;
    }
    g.assign(n+1, {});
    Hash hash_p(p), hash_s(s);
    /*while (true) {
        int l1, int r1, int l2, int r2
    }*/
    for (int i = 0; i < k; ++i) {
        int l_s, r_s; cin >> l_s >> r_s; --l_s;
        int len = r_s - l_s;
        int l_p = perm_pos[s[l_s]];
        bool kw = false;
        //check full_in
        if (l_p + len <= n) {
            if (is_equal(hash_p, hash_s, l_p, l_p + len, l_s, r_s)) {
                g[l_p].push_back({ l_p + len,i });
                kw = true;
            }
        }
        if (kw)continue;
        //check part_in
        //prefix p
        l_p = 0;int r_p = perm_pos[s[r_s - 1]] + 1;
        int lh_s = r_s - (r_p - l_p);
        if (lh_s >= 0) {
            if (is_equal(hash_p, hash_s, l_p, r_p, lh_s, r_s)) {
                g[l_p].push_back({ r_p,i });
            }
        }
        //suffix p
        r_p = n, l_p = perm_pos[s[l_s]];
        int rh_s = l_s + (r_p - l_p);
        if (rh_s <= m) {
            if (is_equal(hash_p, hash_s, l_p, r_p, l_s, rh_s)) {
                g[l_p].push_back({ r_p,i });
            }
        }
    }
    top.clear();
    topused.assign(g.size(), false);
    dfs(0);
    reverse(top.begin(), top.end());
    vector<set<tuple<int, int, int, int>>> fst(g.size());
    fst[0].insert({ 0,-1,-1,-1 });
    //len,rt,ind,fst
    for(int v : top)
    {
        for (auto [u, c] : g[v]) {

            for (auto [d, p, f, pr] : fst[v])
            {
                if(f!=c) fst[u].insert({ d + 1,v,f == -1 ? c : f, c });
            }
            set< tuple<int, int, int, int>> temp = fst[u];
            fst[u].clear();
            set<int> uf;
            for (auto [d, p, f, pr] : temp)
            {
                if (!uf.contains(f))
                {
                    fst[u].insert({ d,p,f,pr });
                }
                if (fst[u].size() >= 2) break;
            }
        }
    }
    int v = g.size()-1;
    //cout << "!!!";
    if (fst[v].empty())
    {
        cout << -1 << '\n';
        return;
    }
    int c = get<2>(*fst[g.size() - 1].begin());
    vector<int> ans;
    while (v != 0)
    {
        for (auto [d, p, f,pr] : fst[v])
        {
            if (f == c)
            {
                ans.push_back(pr);
                v = p;
                break;
            }
        }
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for (int x : ans) cout << x + 1 << ' ';
    cout << '\n';
}
int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    p1.resize(SZ);
    p2.resize(SZ);
    p3.resize(SZ);
    p1[0] = p2[0] = p3[0] = 1;

    for (int i = 1; i < SZ; ++i) {
        p1[i] = p1[i - 1] * P1 % MOD1;
        p2[i] = p2[i - 1] * P2 % MOD2;
        p3[i] = p3[i - 1] * P3 % MOD3;
    }
    int _; cin>>_;
    while (_--) {
        solve();
    }

}