#include <iostream>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

struct Vector {
    ld x, y;
    ll v1, v2;
    ld operator ^ (const Vector& other) const {
        return v1 * other.v2 - v2 * other.v1;
    }
    Vector operator - (const Vector& other) const {
        return {x - other.x, y - other.y, v1 - other.v1, v2 - other.v2};
    }
    static ld dist(const Vector& a, const Vector& b) {
        return sqrt((b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y));
    }
    ld distL(const Vector& a, const Vector& b) const {
        return abs((a - *this) ^ (b - *this)) / dist(a, b);
    }
};


istream& operator >> (istream &in, Vector &a) {
    in >> a.v1 >> a.v2;
    a.x = a.v1;
    a.y = a.v2;
    return in;
}

ostream& operator << (ostream &out, Vector &a) {
    out << a.v1 << " " << a.v2;
    return out;
}

int main()
{
    Vector a, b, c;
    cin >> a >> b >> c;
    ld x, y, z;
    x = a.distL(b, c);
    y = b.distL(a, c);
    z = c.distL(a, b);

    if (x <= y && x <= z) {
        cout << b << " " << c;
    } else {
        if (y <= x && y <= z) {
            cout << a << " " << c;
        } else {
            if (z <= y && z <= x) {
                cout << a << " " << b;
            }
        }
    }
    return 0;
}
