#include <iostream>
#include <cmath>
#include <vector>
#include <iomanip>

using namespace std;


double distance(double x1, double y1, double x2, double y2) {
    return sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
}

int main() {
  
    double x0, y0, x1, y1;
    cin >> x0 >> y0 >> x1 >> y1;

    int n;
    cin >> n;

    vector<int> jumps(n);
    double total_distance = 0;
    for (int i = 0; i < n; ++i) {
        cin >> jumps[i];
        total_distance += jumps[i];
    }

 
    double target_distance = distance(x0, y0, x1, y1);

  
    if (total_distance < target_distance || fmod(total_distance - target_distance, 2) != 0) {
        cout << "Impossible" << endl;
        return 0;
    }

    vector<pair<double, double>> points;
    double current_x = x0, current_y = y0;

    for (int i = 0; i < n; ++i) {
       
        double remaining_distance = distance(current_x, current_y, x1, y1);
        double remaining_jumps = total_distance - jumps[i];

    
        double jump_x, jump_y;
        if (remaining_jumps >= remaining_distance) {
            double direction_x = (x1 - current_x) / remaining_distance;
            double direction_y = (y1 - current_y) / remaining_distance;
            jump_x = current_x + direction_x * jumps[i];
            jump_y = current_y + direction_y * jumps[i];
        } else {
          
            jump_x = current_x + jumps[i];
            jump_y = current_y;
        }

        points.emplace_back(jump_x, jump_y);
        current_x = jump_x;
        current_y = jump_y;
        total_distance -= jumps[i];
    }

    if (distance(current_x, current_y, x1, y1) > 1e-4) {
        cout << "Impossible" << endl;
        return 0;
    }

        cout << "Possible" << endl;
    for (const auto& point : points) {
        cout << fixed << setprecision(8) << point.first << " " << point.second << endl;
    }

    return 0;
}
