import math

def solve_jumper(x0, y0, x1, y1, jumps):
    n = len(jumps)
    dx, dy = x1 - x0, y1 - y0
    required_distance = math.sqrt(dx**2 + dy**2)
    total_jump_distance = sum(jumps)
    
    # Проверка, можно ли достичь точки при данной сумме прыжков
    if abs(total_jump_distance - required_distance) > 1e-6:
        print("Impossible")
        return
    
    # Начинаем с начальной точки и поэтапно вычисляем промежуточные координаты
    result = [(x0, y0)]
    current_x, current_y = x0, y0
    for jump_length in jumps:
        
        # Находим направление
        direction_x = dx / required_distance
        direction_y = dy / required_distance
        
        # Следующая точка после текущего прыжка
        new_x = current_x + jump_length * direction_x
        new_y = current_y + jump_length * direction_y
        
        # Обновляем текущие координаты
        current_x, current_y = new_x, new_y
        result.append((new_x, new_y))
        
        # Пересчитываем оставшееся расстояние
        dx, dy = x1 - new_x, y1 - new_y
        required_distance = math.sqrt(dx**2 + dy**2)
    
    # Проверка, достигли ли мы цели
    if abs(current_x - x1) < 1e-4 and abs(current_y - y1) < 1e-4:
        print("Possible")
        for x, y in result:
            print(f"{x:.8f} {y:.8f}")
    else:
        print("Impossible")

# Пример вызова функции
x0, y0 = 1, 6
x1, y1 = 5, 3
jumps = [2, 4, 1]
solve_jumper(x0, y0, x1, y1, jumps)
