def arrange_cards(n, a, b):
    # Создаем список пар (a[i], b[i])
    cards = list(zip(a, b))

    # Сортируем карточки сначала по a, а потом по b
    cards.sort()

    # Проверяем, можно ли расположить по возрастанию слева и справа
    left = [cards[i][0] for i in range(n)]
    right = [cards[i][1] for i in range(n)]

    # Проверяем, находятся ли обе стороны в порядке возрастания
    if all(left[i] < left[i + 1] for i in range(n - 1)) and all(right[i] < right[i + 1] for i in range(n - 1)):
        return left, right
    else:
        return -1

# Чтение данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение задачи
result = arrange_cards(n, a, b)

# Вывод результата
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
