import math

def triangle_area(c, h):
    # Check if the triangle is valid
    if 2 * h > c or h <= 0 or c <= 0:
        return -1

    # Iterate over possible integer lengths of one leg (a)
    for a in range(1, c):
        b_squared = c**2 - a**2
        if b_squared <= 0:
            continue
        b = math.sqrt(b_squared)
        if b.is_integer() and (a * b) / c == h:
            # If valid triangle found, calculate and return the area
            return round((c * h) / 2, 6)

    # If no valid triangle is found
    return -1

# Read inputs
c = int(input("Enter the hypotenuse length (c): "))
h = int(input("Enter the height (h): "))

# Output the result
result = triangle_area(c, h)
print(result)
