import math

def solve(x0, y0, x1, y1, n, jumps):
    # Разница между конечной и начальной точкой
    delta_x = x1 - x0
    delta_y = y1 - y0
    total_distance = math.sqrt(delta_x ** 2 + delta_y ** 2)
    
    # Проверяем, возможно ли пройти все прыжки
    total_jump_length = sum(jumps)
    
    if total_jump_length != total_distance:
        print("Impossible")
        return
    
    # Массив для хранения точек
    points = [(x0, y0)]
    
    # Нормализуем вектор от старта к финишу
    direction_x = delta_x / total_distance
    direction_y = delta_y / total_distance
    
    # Текущая позиция
    current_x, current_y = x0, y0
    
    # Выполняем прыжки
    for i in range(n):
        jump_length = jumps[i]
        current_x += direction_x * jump_length
        current_y += direction_y * jump_length
        points.append((current_x, current_y))
    
    # Если мы достигли конечной точки, выводим решение
    if math.isclose(current_x, x1, abs_tol=1e-4) and math.isclose(current_y, y1, abs_tol=1e-4):
        print("Possible")
        for point in points[1:]:
            print(f"{point[0]:.8f} {point[1]:.8f}")
    else:
        print("Impossible")

# Чтение входных данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
jumps = list(map(int, input().split()))

# Вызов функции для решения задачи
solve(x0, y0, x1, y1, n, jumps)
