import heapq

def solve(n, m, c, stations):
    # Добавляем начальную точку (0, 0) и конечную точку (m, 0) в список
    stations = [(0, 0)] + stations + [(m, 0)]  # Места заправок, включая старт и финиш
    
    # dp[i] - минимальное время для достижения точки i
    dp = [float('inf')] * (n + 2)
    dp[0] = 0  # Начинаем с времени 0 в Санкт-Петербурге
    
    # Очередь с приоритетом для нахождения минимального времени
    heap = [(0, 0)]  # (время, индекс станции)
    
    while heap:
        current_time, i = heapq.heappop(heap)
        
        # Если время больше текущего минимального, пропускаем
        if current_time > dp[i]:
            continue
        
        # Для каждой заправки после текущей
        for j in range(i + 1, n + 2):
            x_i, _ = stations[i]
            x_j, t_j = stations[j]
            
            # Расстояние между станциями
            dist = x_j - x_i
            
            # Проверяем, можем ли мы проехать это расстояние без заправки
            if dist > c:
                continue  # Если не хватает топлива, пропускаем
            
            # Время на заправке
            new_time = current_time + dist + t_j  # Расстояние и время на заправке
            if new_time < dp[j]:
                dp[j] = new_time
                heapq.heappush(heap, (new_time, j))
    
    # Ответ - время для достижения Москвы
    print(f"{dp[n+1]:.10f}")

# Чтение входных данных
n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)]

# Решение задачи
solve(n, m, c, stations)
