from collections import defaultdict

def solve(n, q, queries):
    # Для каждого цвета отслеживаем сколько рёбер подключено к вершинам и сколько всего рёбер этого цвета
    edge_count = defaultdict(int)  # Сколько рёбер этого цвета всего
    vertex_edges = defaultdict(lambda: defaultdict(int))  # Сколько рёбер этого цвета на каждой вершине
    
    total_beauty = 0  # Общая красота

    # Для каждого запроса
    results = []
    for query in queries:
        qtype, v, u, c = query

        if qtype == '+':
            # Добавляем ребро (v, u) цвета c
            vertex_edges[c][v] += 1
            vertex_edges[c][u] += 1
            edge_count[c] += 1
            
            # Проверяем, стал ли цвет c превосходным
            if vertex_edges[c][v] == 2:  # Если вершина v теперь соединена двумя рёбрами цвета c
                edge_count[c] -= 1
            if vertex_edges[c][u] == 2:  # Если вершина u теперь соединена двумя рёбрами цвета c
                edge_count[c] -= 1
            
        elif qtype == '-':
            # Удаляем ребро (v, u) цвета c
            vertex_edges[c][v] -= 1
            vertex_edges[c][u] -= 1
            edge_count[c] -= 1
            
            # Проверяем, стал ли цвет c превосходным после удаления
            if vertex_edges[c][v] == 1:  # Если вершина v теперь соединена только одним ребром цвета c
                edge_count[c] += 1
            if vertex_edges[c][u] == 1:  # Если вершина u теперь соединена только одним ребром цвета c
                edge_count[c] += 1
        
        # Подсчитаем общую красоту всех превосходных цветов
        total_beauty = 0
        for color in edge_count:
            if edge_count[color] > 0:
                total_beauty += edge_count[color]
        
        # Выводим результат для этого запроса
        results.append(total_beauty)

    return results

# Чтение входных данных
n, q = map(int, input().split())
queries = []

for _ in range(q):
    query = input().split()
    query[1], query[2], query[3] = map(int, query[1:])
    queries.append(tuple(query))

# Решение задачи
results = solve(n, q, queries)

# Вывод результата
for result in results:
    print(result)
