def main():
    import sys

    def query(dx, dy):
        """
        Отправляет запрос к судейской программе.
        :param dx: смещение по горизонтали.
        :param dy: смещение по вертикали.
        :return: '+' если ход успешен, '-' если нет.
        """
        print(f"? {dx} {dy}", flush=True)
        return sys.stdin.readline().strip()

    def solve():
        """
        Алгоритм нахождения начальной позиции слона.
        """
        x, y = 4, 4  # Начнем с центральной точки доски

        # Максимум 7 попыток
        for attempt in range(7):
            response = query(0, 0)  # Пытаемся определить начальную точку
            if response == "+":
                print(f"! {x} {y}", flush=True)
                return

            # Если неудача, изменяем стратегию поиска
            x, y = (x + 1) % 8, (y + 1) % 8

        # Если не удалось определить
        print("Не удалось определить позицию", flush=True)

    solve()
