Python 3.7.4 (tags/v3.7.4:e09359112e, Jul  8 2019, 20:34:20) [MSC v.1916 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license()" for more information.
>>> from itertools import product

def generate_n_minos(n):
    # Функция для генерации всех уникальных n-миношек
    def dfs(x, y, cells):
        # Рекурсивный поиск
        if len(cells) == n:
            result.add(normalize(cells))
            return

        for dx, dy in [(-1, 0), (1, 0), (0, -1), (0, 1)]:
            nx, ny = x + dx, y + dy
            if (nx, ny) not in cells and 0 <= nx < n and 0 <= ny < n:
                dfs(nx, ny, cells | {(nx, ny)})

    def normalize(cells):
        # Нормализует фигуру (сортирует и приводит к каноническому виду)
        shapes = []
        for reflect_x in [False, True]:
            for reflect_y in [False, True]:
                for rotate in range(4):
                    shape = set()
                    for x, y in cells:
                        if reflect_x:
                            x = -x
                        if reflect_y:
                            y = -y
                        for _ in range(rotate):
                            x, y = y, -x
                        shape.add((x, y))
                    min_x = min(p[0] for p in shape)
                    min_y = min(p[1] for p in shape)
                    shapes.append(frozenset((x - min_x, y - min_y) for x, y in shape))
        return min(shapes)

    result = set()
    for x, y in product(range(n), repeat=2):
        dfs(x, y, {(x, y)})

    return list(result)

def solve(n):
    if n > 100:
        print(-1)
        return

    n_minos = generate_n_minos(n)
    if len(n_minos) < n:
        print(-1)
        return

    grid = [[0] * n for _ in range(n)]
    for i, shape in enumerate(n_minos[:n], start=1):
        for x, y in shape:
            grid[x][y] = i

    for row in grid:
        print(' '.join(map(str, row)))

# Пример ввода
n = int(input())
solve(n)
