#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    
    unordered_map<int, unordered_map<int, int>> degree;
    unordered_map<int, int> edge_count;
    unordered_set<int> non_excellent_colors;
    int total_beauty = 0;
    vector<int> answers;

    for (int i = 0; i < q; ++i) {
        char operation;
        int a, b, c;
        cin >> operation >> a >> b >> c;
        a--; b--; 
        
        if (degree.find(c) == degree.end()) {
            degree[c] = unordered_map<int, int>();
            edge_count[c] = 0;
        }
        
        bool color_was_excellent = non_excellent_colors.find(c) == non_excellent_colors.end();
        
        if (operation == '+') {
            degree[c][a] += 1;
            degree[c][b] += 1;
            edge_count[c] += 1;

            if (degree[c][a] > 1 || degree[c][b] > 1) {
                if (color_was_excellent) {
                    non_excellent_colors.insert(c);
                    total_beauty -= edge_count[c];
                }
            }
        } else {
            degree[c][a] -= 1;
            degree[c][b] -= 1;
            edge_count[c] -= 1;

            if (degree[c][a] <= 1 && degree[c][b] <= 1) {
                if (non_excellent_colors.find(c) != non_excellent_colors.end()) {
                    non_excellent_colors.erase(c);
                    total_beauty += edge_count[c];
                }
            }
        }
        
        answers.push_back(total_beauty);
    }
    
    for (int ans : answers) {
        cout << ans << endl;
    }
    
    return 0;
}
