#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

bool ask(int dx, int dy) {
    cout << "? " << dx << ' ' << dy << endl;
    char c; cin >> c;
    return (c == '+');
}

bool okay(int x, int y) {
    return (0 <= x && x < 8 && 0 <= y && y < 8);
}

void solve() {
    vector<bool> ans;
    int sum1 = 0, sum2 = 0, sum3 = 0;
    for (int d : {4, 2, 1}) {
        ans.push_back(ask(-d, -d));
        if (ans.back()) {
            sum1 += d;
        }
    }
    for (int d : {4, 2, 1}) {
        ans.push_back(ask(d, d));
        if (ans.back()) {
            sum2 += d;
        }
    }
    ans.push_back(ask(1, -1));
    if (ans.back()) {
        sum3 += 1;
    }
    int s1[8][8], s2[8][8], s3[8][8];
    for (int i = 0; i < 8; i++) {
        for (int j = 0; j < 8; j++) {
            s1[i][j] = s2[i][j] = s3[i][j] = 0;
        }
    }
    for (int sx = 0; sx < 8; sx++) {
        for (int sy = 0; sy < 8; sy++) {
            int cur_x = sx, cur_y = sy;
            for (int d : {4, 2, 1}) {
                if (okay(cur_x - d, cur_y - d)) {
                    cur_x -= d;
                    cur_y -= d;
                    s1[sx][sy] += d;
                }
            }
            for (int d : {4, 2, 1}) {
                if (okay(cur_x + d, cur_y + d)) {
                    cur_x += d;
                    cur_y += d;
                    s2[sx][sy] += d;
                }
            }
            if (okay(cur_x + 1, cur_y - 1)) {
                s3[sx][sy]++;
            }
        }
    }
    for (int i = 0; i < 8; i++) {
        for (int j = 0; j < 8; j++) {
            if (s1[i][j] == sum1 && s2[i][j] == sum2 && s3[i][j] == sum3) {
                cout << "! " << static_cast<char>('a' + i) << j + 1 << endl;
                return;
            }
        }
    }
}

int main() {
    //cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
