#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <cmath>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

struct Vector {
    int x;
    int y;
    Vector() : x(0), y(0) {}
    Vector(int _x, int _y) : x(_x), y(_y) {}
};
struct Line {
    double a;
    double b;
    double c;
    Line(Vector p1, Vector p2) {
        auto x1 = p1.x;
        auto y1 = p1.y;
        auto x2 = p2.x;
        auto y2 = p2.y;
        int xd = x1 - x2;
        int yd = y1 - y2;
        if (yd == 0) {
            a = 0, b = 1, c = -y1;
        }
        else if (xd == 0) {
            a = 1, b = 0, c = -x1;
        }
        else {
            a = 1;
            b = (double)xd / -yd;
            c = -(x1 + b * y1);
        }
    }
    double get(Vector p) {
        return abs(p.x * a + p.y * b + c) / sqrt(a * a + b * b);
    }
};
void solve() {
    vector<Vector> dots(3);
    for (int i = 0; i < 3; ++i) {
        cin >> dots[i].x >> dots[i].y;
    }
   
    double mn = 1e18;
    pair<Vector, Vector> ans;
    
    Line l1(dots[0], dots[1]), l2(dots[1], dots[2]), l3(dots[2], dots[0]);
    
    mn = l1.get(dots[2]);
    ans = make_pair(dots[0], dots[1]);

    if (l2.get(dots[0]) < mn) {
        mn = l2.get(dots[0]);
        ans = make_pair(dots[1], dots[2]);
    }
    if (l3.get(dots[1]) < mn) {
        mn = l2.get(dots[1]);
        ans = make_pair(dots[2], dots[0]);
    }
    cout << ans.first.x << ' ' << ans.first.y << ' ' << ans.second.x << ' ' << ans.second.y;
}

int main() {
    //cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
