#include <iostream>
#include <cmath>
#define ll long long
using namespace std;

double ush(ll c, ll h) {
    if (c <= 0 || h <= 0) {
        return -1;
    }

    double d = c * c - 4.0 * h * h;
    if (d < 0) {
        return -1;
    }

    double p = (c + sqrt(d)) / 2.0;
    double q = (c - sqrt(d)) / 2.0;

    if (p > 0 && q > 0 && fabs(p * q - h * h) < 1e-9) {
        return 0.5 * c * h;
    } else {
        return -1;
    }
}

int main() {
    ll c, h;
    cin >> c >> h;
    double res = ush(c, h);
    if (res == -1) {
        cout << -1 << endl;
    } else {
        cout << res << endl;
    }
    return 0;
}
