def solve_timeline(n, a, b):
    cards = list(zip(a, b))
    cards.sort(key=lambda x: min(x))
    top, bottom = [], []
    last_top = last_bottom = -1
    
    for front, back in cards:
        if front >= last_top and back >= last_bottom:
            top.append(front)
            bottom.append(back)
            last_top = front
            last_bottom = back
        elif back >= last_top and front >= last_bottom:
            top.append(back)
            bottom.append(front)
            last_top = back
            last_bottom = front
        else:
            return -1
    return top, bottom

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
result = solve_timeline(n, a, b)

if result == -1:
    print(-1)
else:
    top, bottom = result
    print(" ".join(map(str, top)))
    print(" ".join(map(str, bottom)))