#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

using namespace std;

const int MAX_N = 1e5 + 5;

vector<unordered_map<int, int>> adj(MAX_N); 
vector<int> color_count(MAX_N, 0); 
set<int> excellent_colors;
long long total_beauty = 0;

void add_edge(int v, int u, int c) {
    adj[v][c]++;
    adj[u][c]++;
    color_count[c]++;

    if (color_count[c] == 1) {
        excellent_colors.insert(c);
        total_beauty++;
    } else if (color_count[c] == 2 && excellent_colors.count(c)) {
        excellent_colors.erase(c);
        total_beauty--;
    }

    if (adj[v][c] == 2 && excellent_colors.count(c)) {
        excellent_colors.erase(c);
        total_beauty -= color_count[c];
    }
    if (adj[u][c] == 2 && excellent_colors.count(c)) {
        excellent_colors.erase(c);
        total_beauty -= color_count[c];
    }
}

void remove_edge(int v, int u, int c) {
    adj[v][c]--;
    adj[u][c]--;
    color_count[c]--;

    if (color_count[c] == 0) {
        excellent_colors.erase(c);
    } else if (color_count[c] == 1) {
        excellent_colors.insert(c);
        total_beauty++;
    }

    if (adj[v][c] == 1 && color_count[c] > 1 && !excellent_colors.count(c)) {
        bool is_excellent = true;
        for (auto &p : adj) {
            if (p[c] > 1) {
                is_excellent = false;
                break;
            }
        }
        if (is_excellent) {
            excellent_colors.insert(c);
            total_beauty += color_count[c];
        }
    }
    if (adj[u][c] == 1 && color_count[c] > 1 && !excellent_colors.count(c)) {
        bool is_excellent = true;
        for (auto &p : adj) {
            if (p[c] > 1) {
                is_excellent = false;
                break;
            }
        }
        if (is_excellent) {
            excellent_colors.insert(c);
            total_beauty += color_count[c];
        }
    }
}

int main() {
    int n, q;
    cin >> n >> q;

    while (q--) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            add_edge(v, u, c);
        } else {
            remove_edge(v, u, c);
        }

        cout << total_beauty << endl;
    }

    return 0;
}