from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Словари для хранения состояния графа
edges = defaultdict(set)  # хранит рёбра для каждого цвета
degree = defaultdict(lambda: defaultdict(int))  # хранит количество рёбер, исходящих из вершины для каждого цвета
beauty = defaultdict(int)  # хранит "красоту" для каждого цвета

# Переменная для хранения общей красоты
total_beauty = 0

# Функция для обновления красоты
def update_beauty(c):
    global total_beauty
    # Проверяем, является ли цвет c превосходным
    if all(degree[v][c] <= 1 for v in range(1, n+1)):
        # Если цвет c превосходный, обновляем его красоту
        new_beauty = len(edges[c])
        # Обновляем только если новый результат отличается от предыдущего
        total_beauty += new_beauty - beauty[c]
        beauty[c] = new_beauty
    else:
        # Если цвет c не превосходный, его красота обнуляется
        total_beauty -= beauty[c]
        beauty[c] = 0

# Обработка запросов
for _ in range(q):
    query = input().split()
    if query[0] == '+':
        v, u, c = map(int, query[1:])
        if (v, u) not in edges[c]:
            # Добавляем ребро (v, u) цвета c
            edges[c].add((v, u))
            edges[c].add((u, v))  # так как ребро неориентированное
            degree[v][c] += 1
            degree[u][c] += 1
            update_beauty(c)  # обновляем красоту для цвета c
    elif query[0] == '-':
        v, u, c = map(int, query[1:])
        if (v, u) in edges[c]:
            # Удаляем ребро (v, u) цвета c
            edges[c].remove((v, u))
            edges[c].remove((u, v))
            degree[v][c] -= 1
            degree[u][c] -= 1
            update_beauty(c)  # обновляем красоту для цвета c
    # Выводим текущую суммарную красоту
    print(total_beauty)
