from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Словари для хранения состояния графа
edges = defaultdict(set)  # хранит рёбра для каждого цвета
degree = defaultdict(lambda: defaultdict(int))  # хранит количество рёбер, исходящих из вершины для каждого цвета
beauty = defaultdict(int)  # хранит "красоту" для каждого цвета
nodes_with_multiple_edges = defaultdict(set)  # хранит вершины с количеством рёбер > 1 для каждого цвета

# Переменная для хранения общей красоты
total_beauty = 0

# Функция для обновления красоты
def update_beauty(c):
    global total_beauty
    if len(nodes_with_multiple_edges[c]) == 0:
        # Если для цвета c нет вершин с более чем одним рёбром, обновляем его красоту
        new_beauty = len(edges[c])
        total_beauty += new_beauty - beauty[c]
        beauty[c] = new_beauty
    else:
        # Если есть вершины с несколькими рёбрами, обнуляем красоту
        total_beauty -= beauty[c]
        beauty[c] = 0

# Список для хранения ответов
answers = []

# Обработка запросов
for _ in range(q):
    query = input().split()
    if query[0] == '+':
        v, u, c = map(int, query[1:])
        if (v, u) not in edges[c]:
            # Добавляем ребро (v, u) цвета c
            edges[c].add((v, u))
            edges[c].add((u, v))  # так как ребро неориентированное
            degree[v][c] += 1
            degree[u][c] += 1

            # Если количество рёбер для вершины больше 1, добавляем её в множество
            if degree[v][c] > 1:
                nodes_with_multiple_edges[c].add(v)
            if degree[u][c] > 1:
                nodes_with_multiple_edges[c].add(u)

            update_beauty(c)  # обновляем красоту для цвета c

    elif query[0] == '-':
        v, u, c = map(int, query[1:])
        if (v, u) in edges[c]:
            # Удаляем ребро (v, u) цвета c
            edges[c].remove((v, u))
            edges[c].remove((u, v))
            degree[v][c] -= 1
            degree[u][c] -= 1

            # Если количество рёбер для вершины стало меньше 2, удаляем её из множества
            if degree[v][c] == 1:
                nodes_with_multiple_edges[c].remove(v)
            if degree[u][c] == 1:
                nodes_with_multiple_edges[c].remove(u)

            update_beauty(c)  # обновляем красоту для цвета c

    # Добавляем текущую суммарную красоту в список ответов
    answers.append(int(total_beauty // 2))

# Выводим все ответы
print("\n".join(map(str, answers)))
