n, q = map(int, input().split())

graph = {} 
vertex_degree = {}


def is_excellent(color):
    if color not in vertex_degree:
        return True
    for degree in vertex_degree[color].values():
        if degree > 1:
            return False
    return True

def calculate_total_beauty():
    total_beauty = 0
    for color in graph:
        if is_excellent(color):
            total_beauty += len(graph[color])
    return total_beauty


for _ in range(q):
    query = input().split()
    op = query[0]
    u, v, c = int(query[1]), int(query[2]), int(query[3])

    edge = tuple(sorted((u, v)))  

    if op == "+":
        if c not in graph:
            graph[c] = {}
            vertex_degree[c] = {}
        graph[c][edge] = 1
        if u not in vertex_degree[c]:
            vertex_degree[c][u] = 0
        if v not in vertex_degree[c]:
            vertex_degree[c][v] = 0
        vertex_degree[c][u] += 1
        vertex_degree[c][v] += 1

    elif op == "-":
        graph[c].pop(edge)
        vertex_degree[c][u] -= 1
        vertex_degree[c][v] -= 1
        if not graph[c]:
            del graph[c]
            del vertex_degree[c]

    print(calculate_total_beauty())
