n, q = map(int, input().split())

graph = {}
vertex_degree = {}
excellent_colors = set()

def calculate_total_beauty():
    total_beauty = 0
    for color in excellent_colors:
        total_beauty += len(graph[color])
    return total_beauty

for _ in range(q):
    query = input().split()
    op = query[0]
    u, v, c = int(query[1]), int(query[2]), int(query[3])

    edge = tuple(sorted((u, v)))

    if op == "+":
        if c not in graph:
            graph[c] = {}
            vertex_degree[c] = {}
            excellent_colors.add(c)
        
        graph[c][edge] = 1
        
        if u not in vertex_degree[c]:
            vertex_degree[c][u] = 0
        if v not in vertex_degree[c]:
            vertex_degree[c][v] = 0
        
        vertex_degree[c][u] += 1
        vertex_degree[c][v] += 1
        
        if vertex_degree[c][u] > 1 or vertex_degree[c][v] > 1:
            excellent_colors.discard(c)

    elif op == "-":
        graph[c].pop(edge)
        
        vertex_degree[c][u] -= 1
        vertex_degree[c][v] -= 1
        
        if vertex_degree[c][u] == 1 and vertex_degree[c][v] == 1:
            if c not in excellent_colors:
                excellent_colors.add(c)
        
        if not graph[c]:
            del graph[c]
            del vertex_degree[c]
            excellent_colors.discard(c)

    print(calculate_total_beauty())
