import sys
import threading

def main():
    input = sys.stdin.readline

    n, m, s = map(int, sys.stdin.readline().split())

    if s == n * m:
        print(0)
        return

    max_cuts = n + m - 2

    def generate_equal_cuts(length, cuts):
        if cuts == 0:
            return []
        step = length / (cuts + 1)
        positions = [int(round(step * (i + 1))) for i in range(cuts)]
        positions = sorted(set(positions))
        return positions

    def generate_pieces(length, cuts):
        positions = [0] + cuts + [length]
        sizes = [positions[i+1] - positions[i] for i in range(len(positions)-1)]
        return sizes

    for total_cuts in range(1, max_cuts + 1):
        found = False
        for x_cuts in range(max(0, total_cuts - (n - 1)), min(total_cuts, m - 1) + 1):
            y_cuts = total_cuts - x_cuts
            if y_cuts > n - 1:
                continue

            vertical_positions = generate_equal_cuts(m, x_cuts)
            horizontal_positions = generate_equal_cuts(n, y_cuts)

            widths = generate_pieces(m, vertical_positions)
            heights = generate_pieces(n, horizontal_positions)

            areas = [w * h for h in heights for w in widths]

            dp = set([0])
            for area in areas:
                new_dp = dp.copy()
                for existing_sum in dp:
                    new_sum = existing_sum + area
                    if new_sum == s:
                        print(total_cuts)
                        return
                    if new_sum < s:
                        new_dp.add(new_sum)
                dp = new_dp

    print(max_cuts)
threading.Thread(target=main).start()