import sys
import threading
from itertools import combinations
from bisect import bisect_left

def main():
    import sys
    sys.setrecursionlimit(1 << 25)
    input = sys.stdin.readline

    n, m, s = map(int, sys.stdin.readline().split())

    if s == n * m:
        print(0)
        return

    max_cuts = n + m - 2
    found = False

    def generate_pieces(n, cuts):
        positions = [0] + sorted(cuts) + [n]
        sizes = [positions[i+1] - positions[i] for i in range(len(positions)-1)]
        return sizes

    for total_cuts in range(1, max_cuts + 1):
        for x_cuts in range(max(0, total_cuts - (n - 1)), min(total_cuts, m - 1) + 1):
            y_cuts = total_cuts - x_cuts
            if y_cuts > n - 1:
                continue

            from itertools import combinations

            vertical_positions = [i for i in range(1, m)]
            horizontal_positions = [i for i in range(1, n)]

            vertical_cuts_list = list(combinations(vertical_positions, x_cuts)) if x_cuts > 0 else [()]
            horizontal_cuts_list = list(combinations(horizontal_positions, y_cuts)) if y_cuts > 0 else [()]

            for v_cuts in vertical_cuts_list:
                widths = generate_pieces(m, v_cuts)
                for h_cuts in horizontal_cuts_list:
                    heights = generate_pieces(n, h_cuts)
                    areas = [w * h for h in heights for w in widths]

                    if len(areas) > 20:
                        continue

                    possible_sums = set([0])
                    for area in areas:
                        new_sums = set()
                        for existing_sum in possible_sums:
                            new_sum = existing_sum + area
                            if new_sum == s:
                                print(total_cuts)
                                return
                            new_sums.add(new_sum)
                        possible_sums.update(new_sums)

    print(max_cuts)

threading.Thread(target=main).start()