import sys
import threading

def main():
    import sys
    valid_positions = set()
    for x in range(1, 9):
        for y in range(1, 9):
            valid_positions.add((x, y))
    move_offsets = [ 
        (2, 2),
        (1, -1),
        (2, 2),
        (-1, 1),
        (1, 1),
        (1, -1),
        (-1, -1)
    ]

    current_move_index = 0
    while len(valid_positions) > 1 and current_move_index < len(move_offsets):
        dx, dy = move_offsets[current_move_index]
        current_move_index += 1
        print(f"? {dx} {dy}")
        sys.stdout.flush()
        user_response = sys.stdin.readline().strip()
        if user_response == '+':
            updated_positions = set()
            for x, y in valid_positions:
                nx, ny = x + dx, y + dy
                if 1 <= nx <= 8 and 1 <= ny <= 8:
                    updated_positions.add((nx, ny))
            valid_positions = updated_positions
        elif user_response == '-':
            updated_positions = set()
            for x, y in valid_positions:
                nx, ny = x + dx, y + dy
                if not (1 <= nx <= 8 and 1 <= ny <= 8):
                    updated_positions.add((x, y))
            valid_positions = updated_positions
        else:
            sys.exit(1)
    if len(valid_positions) == 1:
        x, y = valid_positions.pop()
        column_label = chr(ord('a') + x - 1)
        final_position = f"{column_label}{y}"
        print(f"! {final_position}")
        sys.stdout.flush()
    else:
        x, y = next(iter(valid_positions))
        column_label = chr(ord('a') + x - 1)
        final_position = f"{column_label}{y}"
        print(f"! {final_position}")
        sys.stdout.flush()

if __name__ == "__main__":
    threading.Thread(target=main).start()
