#include <bits/stdc++.h>
using namespace std;
#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif
#define int long long
#pragma GCC optimize ("Ofast") 
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("03")
#pragma GCC optimize("fast-math")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
#define all(x) x.begin(), x.end()
#define sz(x) x.size()
#define skip continue
#define pb push_back
#define F first
#define S second
const int N = 2e5 + 12;
const int MODULAR = 1000000007;
template <class T>
class SegTree
{
public:
    class Truple
    {
    public:
        int ones, zeroes;
    };
    SegTree(const vector<T>& v): data(v)
    {
        st = vector<Truple>(4 * v.size());
        neutral = {0, 0};
        neutral_set = 0;
        promise_set = vector<T>(4 * v.size(), neutral_set);
        build(0, 0, v.size() - 1);
    }
    void build(size_t node, size_t l, size_t r)
    {
        if(l == r)
        {
            st[node] = {(powers[l] * (data[l] + 1)) % MODULAR, (powers1[l] * (data[l] + 1)) % MODULAR, powers[l], powers1[l]};
        }
        else
        {
            build(2 * node + 1, l, l + (r - l) / 2);
            build(2 * node + 2, l + (r - l) / 2 + 1, r);
            st[node] = func(st[2 * node + 1], st[2 * node + 2]);
        }
    }
    Truple func(const Truple& x, const Truple& y)
    {
        return {(x.hash + y.hash) % MODULAR, (x.hash1 + y.hash1) % MODULAR, (x.sum + y.sum) % MODULAR, (x.sum1 + y.sum1) % MODULAR};
    }
    Truple query(size_t l, size_t r)
    {
        return query_internal(l, r, 0, data.size() - 1);
    }
    Truple query(size_t k)
    {
        return query(k, k);
    }
    Truple query_internal(size_t l, size_t r, size_t tl, size_t tr, int node = 0)
    {
        if(tl > r || tr < l)
        {
            return neutral;
        }
        push(node, tl, tr);
        if(tl >= l && tr <= r)
        {
            return st[node];
        }
        Truple left_result = query_internal(l, r, tl, (tl + tr) / 2, 2 * node + 1);
        Truple right_result = query_internal(l, r, (tl + tr) / 2 + 1, tr, 2 * node + 2);
        return func(left_result, right_result);
    }
    
    void set(size_t l, size_t r, int x)
    {
        set_internal(l, r, x, 0, data.size() - 1);
    }
    void set_internal(size_t l, size_t r, int x, size_t tl, size_t tr, int node = 0)
    {
        push(node, tl, tr);
        if(tl > r || tr < l)
        {
            return;
        }
        if(tl >= l && tr <= r)
        {
            promise_set[node] = x;
            push(node, tl, tr);
            return;
        }
        else
        {
            set_internal(l, r, x, tl, (tl + tr) / 2, 2 * node + 1);
            set_internal(l, r, x, (tl + tr) / 2 + 1, tr, 2 * node + 2);
        }
        st[node] = func(st[2 * node + 1], st[2 * node + 2]);
    }
    void push(int node, size_t tl, size_t tr)
    {
        if(promise_set[node] != neutral_set)
        {
            st[node] = {(st[node].sum * (promise_set[node] + 1)) % MODULAR,
                (st[node].sum1 * (promise_set[node] + 1)) % MODULAR,
                st[node].sum,
                st[node].sum1};
            if(2 * node + 1 < st.size())
            {
                if(2 * node + 1 < st.size())
                {
                    promise_set[2 * node + 1] = promise_set[node];
                }
                if(2 * node + 2 < st.size())
                {
                    promise_set[2 * node + 2] = promise_set[node];;
                }
            }
        }
        promise_set[node] = neutral_set;
    }
    T neutral_set;
    vector<T> promise_set;
    Truple neutral;
    vector<T> data;
    vector<Truple> st;
    vector<int> powers;
    vector<int> powers1;
};
struct custom_hash
{
    static uint64_t splitmix64(uint64_t x)
    {
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }
    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return splitmix64(x + FIXED_RANDOM);
    }
};
class cpp
{
public:
    void yes()
    {
        std::cout << "YES" << std::endl;
    }
    void no()
    {
        std::cout << "NO" << std::endl;
    }
};
class Timer
{
public:
    Timer()
    {
        start = std::chrono::high_resolution_clock::now();
    }
    ~Timer()
    {
#ifdef LOCAL
        end = std::chrono::high_resolution_clock::now();
        std::chrono::duration<float> dur = end - start;
        std::cout.precision(3);
        std::cout << "Time elapsed: " << std::fixed << dur.count() << "ms" << std::endl;
#endif
    }
private:
    decltype(std::chrono::high_resolution_clock::now()) start, end;
};
void file(string s) 
{
    freopen((s+".in").c_str(),"r",stdin);
    freopen((s+".out").c_str(),"w",stdout);
}
int binpow(int a, int n, int m)
{
    int res = 1;
    while(n)
    {
        if(n & 1)
        {
            res = res * a % m;
        }
        a = a * a % m;
        n >>= 1;
    }
    return res;
}
void solve()
{
    int n;
    cin >> n;
    cout << (n * (n + 1)) / 2 + n;
}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Timer _timer;
    try
    {
        int t = 1;
        //cin >> t;
        while(t--)
        {
            solve();
        }
    }
    catch(...)
    {
        cout << "An exception has occured.." << endl;
    }
}
