#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
template<typename T>
using unset = unordered_set<T>;

constexpr ll maxn = 1e5 + 10;
ll a[maxn], t[maxn << 2];
gp_hash_table<ll, ll> g[maxn];
unset<ll> bad_v[maxn];

struct Segment_tree{
    ll n;
private:
    void build(ll v, ll l, ll r) {
        if (l == r) {
            t[v] = a[l];
            return;
        }
        ll mid = (l + r) >> 1;
        build(v * 2, l, mid);
        build(v * 2 + 1, mid + 1, r);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
public:
    Segment_tree(ll n) : n(n) {}
    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if (l > r) return 0;
        if (l == ql && r == qr)
            return t[v];
        ll mid = (l + r) >> 1;
        return get(v * 2, l, mid, ql, min(qr, mid)) + get(v * 2 + 1, mid + 1, r, max(ql, mid + 1), qr);
    }
    void update(ll v, ll l, ll r, ll i, ll val) {
        if (l == r) {
            t[v] = val;
            a[i] = val;
            return;
        }
        ll mid = (l + r) >> 1;
        if (i <= mid)
            update(v * 2, l, mid, i, val);
        else
            update(v * 2 + 1, mid + 1, r, i, val);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
};

Segment_tree tt(maxn);

void add(ll v, ll u, ll c) {
    ++g[v][c];
    ++g[u][c];
    if (g[v][c] > 1)
        bad_v[c].emplace(v);
    if (g[u][c] > 1)
        bad_v[c].emplace(u);
    tt.update(1, 0, maxn - 1, c, bad_v[c].empty());
}

void remove(ll v, ll u, ll c) {
    --g[v][c];
    --g[u][c];
    if (g[v][c] < 2)
        bad_v[c].erase(v);
    if (g[u][c] < 2)
        bad_v[c].erase(u);
    tt.update(1, 0, maxn - 1, c, bad_v[c].empty());
}

void print(ll n) {
    for (ll i = 1; i <= n; ++i)
        cout << a[i] << " ";
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, q;
    cin >> n >> q;
    while (q--) {
        char type;
        ll v, u, c;
        cin >> type >> v >> u >> c;
        if (type == '+')
            add(v, u, c);
        else
            remove(v, u, c);
        cout << t[1] << "\n";
    }
    return 0;
}
