#include <iostream>
#include <vector>
#include <algorithm>

bool canArrange(std::vector<std::pair<long int, long int>> &cards, std::vector<long int> &frontYears, std::vector<long int> &backYears) {
    std::sort(cards.begin(), cards.end(), [](const std::pair<long int, long int> &a, const std::pair<long int, long int> &b) {
        return std::min(a.first, a.second) < std::min(b.first, b.second);
    });

    int maxFront = -1, maxBack = -1;
    for (const auto &card : cards) {
        if (std::max(card.first, card.second) < maxFront && std::max(card.first, card.second) < maxBack) {
            return false;
        }
        if (card.first >= maxFront && card.second >= maxBack) {
            frontYears.push_back(card.first);
            backYears.push_back(card.second);
            maxFront = card.first;
            maxBack = card.second;
        } else if (card.second >= maxFront && card.first >= maxBack) {
            frontYears.push_back(card.second);
            backYears.push_back(card.first);
            maxFront = card.second;
            maxBack = card.first;
        } else if (card.first >= maxFront) {
            frontYears.push_back(card.first);
            backYears.push_back(card.second);
            maxFront = card.first;
        } else {
            frontYears.push_back(card.second);
            backYears.push_back(card.first);
            maxBack = card.first;
        }
    }
    return true;
}

int main() {
    int n;
    std::cin >> n;
    std::vector<std::pair<long int, long int>> cards(n);
    for (int i = 0; i < n; ++i) std::cin >> cards[i].first;
    for (int i = 0; i < n; ++i) std::cin >> cards[i].second;
    std::vector<long int> frontYears, backYears;
    if (canArrange(cards, frontYears, backYears)) {
        bool valid = true;
        for (long int i = 0; i < frontYears.size() - 1 && valid; ++i) if (frontYears[i] > frontYears[i + 1] || backYears[i] > backYears[i + 1]) valid = false;
        if (!valid) {
            std::cout << -1;
            return 0;
        }
        for (int year : frontYears) std::cout << year << " ";
        std::cout << std::endl;
        for (int year : backYears) std::cout << year << " ";
        std::cout << std::endl;
    } else std::cout << -1 << std::endl;
    return 0;
}

