#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;

struct Card {
    long long a, b;
    long long index;
};

bool solve(long long n, vector<Card>& cards) {
    sort(cards.begin(), cards.end(), [](const Card& c1, const Card& c2) {
        return min(c1.a, c1.b) < min(c2.a, c2.b);
    });

    vector<int> result_a(n), result_b(n);
    int max_a = -1, max_b = -1;

    for (long long i = 0; i < n; ++i) {
        if (cards[i].a >= max_a && cards[i].b >= max_b) {
            result_a[i] = cards[i].a;
            result_b[i] = cards[i].b;
            max_a = cards[i].a;
            max_b = cards[i].b;
        } else if (cards[i].b >= max_a && cards[i].a >= max_b) {
            result_a[i] = cards[i].b;
            result_b[i] = cards[i].a;
            max_a = cards[i].b;
            max_b = cards[i].a;
        } else {
            return false;
        }
    }

    for (long long i = 0; i < n; ++i) {
        cout << result_a[i] << " ";
    }
    cout << endl;
    for (long long  i = 0; i < n; ++i) {
        cout << result_b[i] << " ";
    }
    cout << endl;

    return true;
}

int main() {
    long long n;
    cin >> n;

    vector<Card> cards(n);

    for (long long i = 0; i < n; ++i) {
        cin >> cards[i].a;
        cards[i].index = i;
    }

    for (long long  i = 0; i < n; ++i) {
        cin >> cards[i].b;
    }

    if (!solve(n, cards)) {
        cout << -1 << endl;
    }

    return 0;
}
