def solve():
    # Чтение входных данных
    n, m, s = map(int, input().split())
    
    # Если нужно всю площадь, разрезать ничего не нужно
    if s == n * m:
        print(0)
        return
    
    min_cuts = float('inf')
    
    # Пробуем все возможные числа вертикальных разрезов x и горизонтальных разрезов y
    for x in range(n):
        for y in range(m):
            # Количество кусочков после этих разрезов
            num_pieces = (x + 1) * (y + 1)
            
            # Проверяем, если у нас достаточно кусочков для того, чтобы собрать s клеток
            if num_pieces <= s:
                # Проверяем, можно ли точно собрать s клеток
                if s % num_pieces == 0:
                    # Если да, то считаем количество разрезов
                    min_cuts = min(min_cuts, x + y)
    
    # Выводим результат
    if min_cuts == float('inf'):
        print(-1)
    else:
        print(min_cuts)

