def solve_timeline(n, front, back):
    cards = [(front[i], back[i]) for i in range(n)]
    
    # 1. Сортируем карточки по первой стороне, если равны, по второй
    cards.sort()

    # 2. Попробуем создать два результата, для фронтальной и обратной сторон
    result_front = []
    result_back = []
    
    # 3. Переменная для хранения последнего добавленного элемента
    last_front = -1
    last_back = -1
    
    for a, b in cards:
        if a &gt;= last_front and b &gt;= last_back:
            # Мы можем взять карту с лицевой стороны
            result_front.append(a)
            result_back.append(b)
            last_front = a
            last_back = b
        elif a &gt;= last_back and b &gt;= last_front:
            # Мы можем взять карту с обратной стороны
            result_front.append(b)
            result_back.append(a)
            last_front = b
            last_back = a
        else:
            # Невозможно выполнить условие
            return -1
    
    return result_front, result_back

# Ввод данных
n = int(input().strip())
front = list(map(int, input().strip().split()))
back = list(map(int, input().strip().split()))

# Решение задачи
result = solve_timeline(n, front, back)

# Вывод результата
if result == -1:
    print(-1)
else:
    for line in result:
        print(' '.join(map(str, line)))
