def can_make_spell(n, m, k, p, a, students):
    from collections import defaultdict, deque
    
    # Создаем мапу позиций рун в книге
    rune_positions = defaultdict(list)
    for i in range(m):
        rune_positions[a[i]].append(i + 1)  # используем индекс с 1
    
    # Результат (номер студентов)
    result_students = []
    
    # Начальная позиция
    current_position = 0
    
    # Используем очередь для выбора студентов
    used_students = set()
    
    for rune in p:
        available_positions = rune_positions.get(rune, [])
        if not available_positions:
            return -1
        
        # Ищем ближайший к текущему положению доступный номер
        best_choice = -1
        best_range = float('inf')
        for student_index, (l, r) in enumerate(students, start=1):
            if student_index in used_students:
                continue
            # Проверяем, доступен ли данный студент для этой руны
            if available_positions[-1] < l or available_positions[0] > r:
                continue
            
            # Определяем охватывающее окно
            best_position = max(l, available_positions[0])
            distance = best_position - current_position
            
            if best_position <= r and distance >= 0 and distance < best_range:
                best_range = distance
                best_choice = student_index
        
        if best_choice == -1:
            return -1
        
        used_students.add(best_choice)
        result_students.append(best_choice)
        current_position += best_range
    
    return len(result_students), result_students


# Входные данные
import sys
input = sys.stdin.read
data = input().strip().splitlines()

t = int(data[0])
index = 1
results = []

for _ in range(t):
    n, m, k = map(int, data[index].split())
    index += 1
    p = list(map(int, data[index].split()))
    index += 1
    a = list(map(int, data[index].split()))
    index += 1
    
    students = []
    for __ in range(k):
        l, r = map(int, data[index].split())
        students.append((l, r))
        index += 1
    
    result = can_make_spell(n, m, k, p, a, students)
    
    if result == -1:
        results.append("-1")
    else:
        c, student_indices = result
        results.append(str(c))
        results.append(" ".join(map(str, student_indices)))

# Вывод результата
print("\n".join(results))
