#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;

struct Station {
    int x, t;
};

int main() {
    int n, m, c;
    cin >> n >> m >> c;

    vector<Station> stations(n);
    for (int i = 0; i < n; ++i) {
        cin >> stations[i].x >> stations[i].t;
    }

    // dp[i] - минимальное время, чтобы добраться до заправки i
    vector<double> dp(n + 1, numeric_limits<double>::infinity());
    dp[0] = 0.0;  // Начинаем с Санкт-Петербурга, минимальное время = 0

    // dp для конечной точки (Москва)
    double final_time = numeric_limits<double>::infinity();
    
    // Погоня за минимальным временем
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (stations[j].x - stations[i].x <= c) {
                // Расстояние между станциями в пределах объема бака
                dp[j] = min(dp[j], dp[i] + (stations[j].x - stations[i].x) + stations[j].t);
            }
        }
    }

    // Время на путь от последней заправки до Москвы
    final_time = min(final_time, dp[n] + m - stations[n-1].x);

    cout << final_time << endl;

    return 0;
}
