#include <iostream>
#include <cmath>
#include <tuple>

using namespace std;

// Функция для нахождения точки на прямой, проходящей через две другие точки
pair<int, int> getPointOnLine(int x1, int y1, int x2, int y2) {
    return {x1 + (y2 - y1), y1 - (x2 - x1)};
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    // Находим центроид
    double centerX = (x1 + x2 + x3) / 3.0;
    double centerY = (y1 + y2 + y3) / 3.0;

    // Подбираем координаты двух точек, прорывающей линию
    // Берём одну точку из центроида (округляя)
    int xA = static_cast<int>(round(centerX)); 
    int yA = static_cast<int>(round(centerY));

    // Вторая точка будет немного смещена от первой точки
    pair<int, int> pointB = getPointOnLine(xA, yA, xA + 1, yA + 1); // смещение

    cout << xA << " " << yA << " " << pointB.first << " " << pointB.second << endl;

    return 0;
}