#include <iostream>
#include <string>
#include <cmath>

using namespace std;

bool check(int a, int b, int numerator, int denominator) {
    // Проверяем, что a / b действительно равно numerator / denominator
    return (long long) a * denominator == (long long) numerator * b;
}

int main() {
    int n;
    cin >> n;
    
    string digits;
    cin >> digits;
    
    // Получаем числовое значение из введенных цифр
    int numerator = stoi(digits);
    int denominator = pow(10, n);
    
    // Перебираем значения b
    for (int b = 1; b < 1000000; ++b) {
        // Для каждого b находим a, используя пропорцию
        int a = numerator * b / denominator;
        
        // Проверяем, что a / b точно соответствует дроби numerator / denominator
        if (check(a, b, numerator, denominator) && a < b && a > 0) {
            cout << "YES\n" << a << " " << b << endl;
            return 0;
        }
    }
    
    cout << "NO\n";
    return 0;
}
