def galactic_timeline(n, a, b):
    # Создаём массив пар (лицевая сторона, оборотная сторона)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Сортируем карточки по минимуму лицевой и оборотной стороны
    cards.sort(key=lambda x: min(x))
    
    # Два списка для финальных результатов
    top_result = []
    bottom_result = []
    
    # Переменные для отслеживания предыдущего года на лицевой и оборотной сторонах
    top_prev, bottom_prev = -1, -1

    for card in cards:
        top_face, bottom_face = card  # лицевая и оборотная стороны
        
        # Проверяем, можно ли использовать карточку "как есть"
        if top_face >= top_prev and bottom_face >= bottom_prev:
            top_result.append(top_face)
            bottom_result.append(bottom_face)
            top_prev, bottom_prev = top_face, bottom_face
        # Проверяем, можно ли перевернуть карточку
        elif bottom_face >= top_prev and top_face >= bottom_prev:
            top_result.append(bottom_face)
            bottom_result.append(top_face)
            top_prev, bottom_prev = bottom_face, top_face
        else:
            # Если ни одно из условий не выполняется, задача неразрешима
            return -1

    return top_result, bottom_result


# Считывание данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

result = galactic_timeline(n, a, b)
if result == -1:
    print(-1)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))
