from collections import defaultdict


def process_queries(n, queries):
    color_edges = defaultdict(set)
    vertex_color_degree = defaultdict(lambda: defaultdict(int))
    total_beauty = 0
    is_superior_color = defaultdict(bool)
    color_beauty = defaultdict(int)

    result = []

    for action, v, u, c in queries:
        v, u = min(v, u), max(v, u)
        if action == '+':
            color_edges[c].add((v, u))
            vertex_color_degree[c][v] += 1
            vertex_color_degree[c][u] += 1

            if is_superior_color[c]:
                total_beauty -= color_beauty[c]
            is_superior_color[c] = all(degree <= 1 for degree in vertex_color_degree[c].values())
            color_beauty[c] = len(color_edges[c]) if is_superior_color[c] else 0

            total_beauty += color_beauty[c]

        elif action == '-':
            color_edges[c].remove((v, u))
            vertex_color_degree[c][v] -= 1
            vertex_color_degree[c][u] -= 1
            if is_superior_color[c]:
                total_beauty -= color_beauty[c]

            is_superior_color[c] = all(degree <= 1 for degree in vertex_color_degree[c].values())
            color_beauty[c] = len(color_edges[c]) if is_superior_color[c] else 0

            total_beauty += color_beauty[c]
        result.append(total_beauty)

    return result


n, q = map(int, input().split())
queries = []
for _ in range(q):
    query = input().split()
    queries.append((query[0], int(query[1]), int(query[2]), int(query[3])))

for res in process_queries(n, queries):
    print(res)
