#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    // Если нужна вся площадь, разрезы не нужны
    if (s == n * m) {
        cout << 0 << endl;
        return 0;
    }

    int minCuts = INT_MAX;

    // Перебираем все варианты разрезов
    for (int x = 0; x <= n - 1; ++x) {
        for (int y = 0; y <= m - 1; ++y) {
            // Число строк и столбцов после разрезов
            int rows = x + 1;
            int cols = y + 1;

            // Создаем массив площадей всех частей
            vector<int> areas;
            for (int i = 0; i < rows; ++i) {
                for (int j = 0; j < cols; ++j) {
                    int rowSize = (i < n % rows) ? (n / rows + 1) : (n / rows);
                    int colSize = (j < m % cols) ? (m / cols + 1) : (m / cols);
                    areas.push_back(rowSize * colSize);
                }
            }

            // Проверяем, можно ли собрать ровно s клеток
            int sum = 0;
            for (int area : areas) {
                sum += area;
                if (sum == s) {
                    minCuts = min(minCuts, x + y);
                    break;
                }
            }
        }
    }

    // Выводим минимальное количество разрезов
    cout << minCuts << endl;
    return 0;
}
