#include <iostream>
#include <cmath>

using namespace std;

int main() {
    int c, h;
    cin >> c >> h;

    // Проверим, существует ли такой треугольник
    if (h >= c) {
        cout << -1 << endl; // Высота не может быть больше или равна гипотенузе
        return 0;
    }

    // Вычисляем площадь треугольника
    double area = 0.5 * c * h;

    // Проверим, можно ли построить треугольник с такими параметрами
    // Найдем длину оснований треугольника, используя теорему Пифагора
    double a = sqrt(c * c / 4.0 + h * h); // Основание треугольника
    double b = sqrt(c * c / 4.0 - h * h); // Другая сторона

    if (a > 0 && b > 0) {
        cout << area << endl; // Площадь треугольника
    } else {
        cout << -1 << endl; // Треугольник с такими параметрами невозможен
    }

    return 0;
}