def min_cuts(n, m, s):
    if s > n * m:
        return -1

    min_cuts_needed = float('inf')
    for vertical_cuts in range(n):
        for horizontal_cuts in range(m):
            sheets = (vertical_cuts + 1) * (horizontal_cuts + 1)

            areas = []
            for i in range(vertical_cuts + 1):
                for j in range(horizontal_cuts + 1):
                    width = (n // (vertical_cuts + 1)) + (1 if i < n % (vertical_cuts + 1) else 0)
                    height = (m // (horizontal_cuts + 1)) + (1 if j < m % (horizontal_cuts + 1) else 0)
                    areas.append(width * height)

            areas.sort(reverse=True)
            current_sum = 0
            for area in areas:
                if current_sum + area <= s:
                    current_sum += area
                if current_sum == s:
                    min_cuts_needed = min(min_cuts_needed, vertical_cuts + horizontal_cuts)
                    break

    return min_cuts_needed if min_cuts_needed != float('inf') else -1


n, m, s = map(int, input("Введите n, m, s через пробел: ").split())

result = min_cuts(n, m, s)
print(result)