def area(n, m, s, vertical_cuts, horizontal_cuts):
  
    row_sizes = []
    for i in range(vertical_cuts + 1):
        size = n // (vertical_cuts + 1) + (1 if i < n % (vertical_cuts + 1) else 0)
        row_sizes.append(size)
    
    col_sizes = []
    for j in range(horizontal_cuts + 1):
        size = m // (horizontal_cuts + 1) + (1 if j < m % (horizontal_cuts + 1) else 0)
        col_sizes.append(size)
    
    areas = []
    for row in row_sizes:
        for col in col_sizes:
            areas.append(row * col)
    
    dp = [False] * (s + 1)
    dp[0] = True
    for area in areas:
        for current in range(s, area - 1, -1):
            dp[current] |= dp[current - area]
    
    return dp[s]

def min_cuts(n, m, s):
    
    if s > n * m:  
        return -1

    for total_cuts in range(n + m): 
        for vertical_cuts in range(min(total_cuts + 1, n)):  
            horizontal_cuts = total_cuts - vertical_cuts
            if horizontal_cuts >= m:  
                continue
            if area(n, m, s, vertical_cuts, horizontal_cuts):
                return total_cuts

    return -1

n, m, s = map(int, input().split())

result = min_cuts(n, m, s)
print(result)