#include <iostream>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

// Проверка, можно ли сформировать заданную площадь
bool can_form_area(vector<int>& areas, int target) {
    vector<bool> dp(target + 1, false);
    dp[0] = true;
    for (int area : areas) {
        for (int t = target; t >= area; --t) {
            dp[t] = dp[t] || dp[t - area];
        }
    }
    return dp[target];
}

// Основная функция поиска минимальных разрезов
int min_cuts(int n, int m, int s) {
    if (s > n * m) {
        return -1;
    }

    // Инициализация BFS
    queue<tuple<int, int, vector<int>, int>> q;
    set<pair<int, int>> visited;

    q.push({n, m, {n * m}, 0});
    visited.insert({n, m});

    while (!q.empty()) {
        auto [h, w, areas, cuts] = q.front();
        q.pop();

        if (can_form_area(areas, s)) {
            return cuts;
        }

        // Разрезаем по горизонтали
        for (int i = 1; i < h; ++i) {
            vector<int> new_areas = areas;
            auto it = find(new_areas.begin(), new_areas.end(), h * w);
            if (it != new_areas.end()) {
                new_areas.erase(it);
            }
            new_areas.push_back(i * w);
            new_areas.push_back((h - i) * w);
            sort(new_areas.begin(), new_areas.end());
            if (visited.find({h - i, w}) == visited.end()) {
                visited.insert({h - i, w});
                q.push({h - i, w, new_areas, cuts + 1});
            }
        }

        // Разрезаем по вертикали
        for (int j = 1; j < w; ++j) {
            vector<int> new_areas = areas;
            auto it = find(new_areas.begin(), new_areas.end(), h * w);
            if (it != new_areas.end()) {
                new_areas.erase(it);
            }
            new_areas.push_back(h * j);
            new_areas.push_back(h * (w - j));
            sort(new_areas.begin(), new_areas.end());
            if (visited.find({h, w - j}) == visited.end()) {
                visited.insert({h, w - j});
                q.push({h, w - j, new_areas, cuts + 1});
            }
        }
    }

    return -1;
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;
    cout << min_cuts(n, m, s) << endl;
    return 0;
}