#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <utility> //  pair

using namespace std;

const double EPS = 1e-6;

int main() {
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0;
    cin >> x1 >> y1;
    cin >> n;

    vector<int> a(n);
    int sum_a = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum_a += a[i];
    }

    //     (x0, y0)  (x1, y1)
    double distance = sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0));

    //          ,  Impossible
    if (sum_a != distance) {
        cout << "Impossible" << endl;
        return 0;
    }

    //  
    double x = x0, y = y0;

    //     
    vector< pair<double, double> > points; //     ">>"
    points.push_back({x, y});  //  

    double dx = x1 - x0;
    double dy = y1 - y0;

    //  ,    
    for (int i = 0; i < n; ++i) {
        //     
        double angle = atan2(dy, dx);

        //  
        double jump_length = a[i];
        double dx_jump = jump_length * cos(angle);
        double dy_jump = jump_length * sin(angle);

        //  
        x += dx_jump;
        y += dy_jump;

        //     
        points.push_back({x, y});

        //   
        dx = x1 - x;
        dy = y1 - y;
    }

    // ,      
    if (fabs(x - x1) < EPS && fabs(y - y1) < EPS) {
        cout << "Possible" << endl;
        //    range-based
        for (size_t i = 0; i < points.size(); ++i) {
            cout << fixed << setprecision(8) << points[i].first << " " << points[i].second << endl;
        }
    } else {
        cout << "Impossible" << endl;
    }

    return 0;
}

