#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> front(n), back(n);
    for (int i = 0; i < n; ++i) cin >> front[i];
    for (int i = 0; i < n; ++i) cin >> back[i];

    vector<pair<int, int>> cards; 
    for (int i = 0; i < n; ++i) {
        cards.push_back({min(front[i], back[i]), i});
    }

    sort(cards.begin(), cards.end()); 

    vector<int> result; 
    int lastFront = 0, lastBack = 0;

    for (auto& card : cards) {
        int idx = card.second;

        if (front[idx] >= lastFront && back[idx] >= lastBack) {
            result.push_back(idx + 1);
            lastFront = front[idx];
            lastBack = back[idx];
        } else if (back[idx] >= lastFront && front[idx] >= lastBack) {
            result.push_back(-(idx + 1)); 
            lastFront = back[idx];
            lastBack = front[idx];
        } else {
            cout << -1 << endl; 
            return 0;
        }
    }

    for (auto& res : result) {
        cout << res << " ";
    }
    cout << endl;

    return 0;
}