import heapq

def min_time_to_moscow(n, m, c, stations):
    stations.append((m, 0))
    stations.sort() 
    
    dp = [float('inf')] * (n + 1)  
    dp[0] = 0 
    
    pq = [(0, 0)]: 
    
    while pq:
        current_time, index = heapq.heappop(pq)
        
        if current_time > dp[index]:
            continue
        
        x1, t1 = stations[index]
        
        for next_index in range(index + 1, n + 1):
            x2, t2 = stations[next_index]
            distance = x2 - x1
            
            if distance > c:
                break 
            
            travel_time = (distance ** 2) / c
            total_time = current_time + travel_time
            
            if next_index < n:
                total_time += t2
            
            if total_time < dp[next_index]:
                dp[next_index] = total_time
                heapq.heappush(pq, (total_time, next_index))
    
    return dp[n]

n, m, c = 4, 100, 25
stations = [(10, 50), (15, 30), (50, 100), (80, 60)]
print(f"{min_time_to_moscow(n, m, c, stations):.10f}")