#include <iostream>
#include <vector>
#include <deque>
#include <unordered_map>
#include <algorithm>
#include <set>

using namespace std;


bool is_subsequence(const vector<int>& p, const vector<int>& r) {
    int n = p.size(), m = r.size();
    int j = 0;
    for (int i = 0; i < m && j < n; ++i) {
        if (p[j] == r[i]) ++j;
    }
    return j == n;
}

void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n, m, k;
        cin >> n >> m >> k;

        vector<int> p(n);
        for (int& x : p) cin >> x;

        vector<int> a(m);
        for (int& x : a) cin >> x;

        vector<pair<int, int>> ranges(k);
        for (auto& [l, r] : ranges) {
            cin >> l >> r;
            --l; --r; 
        }

        
        vector<int> selected;
        for (int i = 0; i < k; ++i) {
            auto [l, r] = ranges[i];
            vector<int> extracted(a.begin() + l, a.begin() + r + 1);

            
            if (is_subsequence(p, extracted)) {
                selected.push_back(i + 1);
                break;
            }
        }

        
        if (!selected.empty()) {
            cout << selected.size() << endl;
            for (int x : selected) cout << x << " ";
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}