#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; ++i) cin >> cards[i].first; 
    for (int i = 0; i < n; ++i) cin >> cards[i].second; 

    vector<pair<int, int>> sorted_cards = cards;
    for (auto& card : sorted_cards) {
        if (card.first > card.second) swap(card.first, card.second);
    }
    sort(sorted_cards.begin(), sorted_cards.end());

    vector<int> front, back;
    int prev_front = -1, prev_back = -1;
    for (const auto& card : sorted_cards) {
        if (card.first >= prev_front && card.second >= prev_back) {
            front.push_back(card.first);
            back.push_back(card.second);
            prev_front = card.first;
            prev_back = card.second;
        } else if (card.second >= prev_front && card.first >= prev_back) {
            front.push_back(card.second);
            back.push_back(card.first);
            prev_front = card.second;
            prev_back = card.first;
        } else {
            cout << -1 << endl;
            return;
        }
    }

    for (int x : front) cout << x << " ";
    cout << endl;
    for (int x : back) cout << x << " ";
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}