def min_students_for_spell(n, m, k, p, pages, students):
    rune_positions = {}
    for idx, rune in enumerate(pages):
        if rune in rune_positions:
            rune_positions[rune].append(idx + 1)
        else:
            rune_positions[rune] = [idx + 1]
    selected_students = []
    current_position = 0
    
    for rune in p:
        if rune not in rune_positions:
            return -1, []
        
        found = False
        for i, (l, r) in enumerate(students):
            if l <= current_position + 1 and r >= current_position + 1 and rune in pages[l-1:r]:
                current_position = r
                selected_students.append(i + 1)
                found = True
                break
        
        if not found:
            return -1, []
    
    return len(selected_students), selected_students

def main():
    t = int(input().strip())
    
    results = []
    for _ in range(t):
        n, m, k = map(int, input().strip().split())
        p = list(map(int, input().strip().split()))
        pages = list(map(int, input().strip().split()))
        students = []
        for _ in range(k):
            l, r = map(int, input().strip().split())
            students.append((l, r))
        min_count, student_order = min_students_for_spell(n, m, k, p, pages, students)
        
        if min_count == -1:
            results.append("-1")
        else:
            results.append(f"{min_count}")
            results.append(" ".join(map(str, student_order)))
    print("\n".join(results))
main()