n = int(input())  # Количество карточек
A = list(map(int, input().split()))  # Лицевые стороны
B = list(map(int, input().split()))  # Обратные стороны

def galactic_timeline(n, A, B):
    # Динамическое программирование
    dp = [[False] * 2 for _ in range(n)]
    dp[0][0] = dp[0][1] = True  # Первая карточка может быть в любом положении

    for i in range(1, n):
        # Если предыдущая карточка не перевернута
        if dp[i-1][0]:
            if A[i] >= A[i-1]:
                dp[i][0] = True
            if B[i] >= A[i-1]:
                dp[i][1] = True
        # Если предыдущая карточка перевернута
        if dp[i-1][1]:
            if A[i] >= B[i-1]:
                dp[i][0] = True
            if B[i] >= B[i-1]:
                dp[i][1] = True

    # Проверяем, возможно ли выложить карточки
    if not dp[n-1][0] and not dp[n-1][1]:
        return "Impossible"

    # Восстанавливаем порядок карточек
    result = [0] * n
    flip = [0] * n
    if dp[n-1][0]:
        flip[n-1] = 0
    else:
        flip[n-1] = 1

    for i in range(n-2, -1, -1):
        if flip[i+1] == 0:  # Следующая карточка не перевернута
            if dp[i][0] and A[i] <= A[i+1]:
                flip[i] = 0
            else:
                flip[i] = 1
        else:  # Следующая карточка перевернута
            if dp[i][0] and A[i] <= B[i+1]:
                flip[i] = 0
            else:
                flip[i] = 1

    # Формируем результат
    top = []
    bottom = []
    for i in range(n):
        if flip[i] == 0:
            top.append(A[i])
            bottom.append(B[i])
        else:
            top.append(B[i])
            bottom.append(A[i])

    return "\n".join([" ".join(map(str, top)), " ".join(map(str, bottom))])

# Вывод результата
print(galactic_timeline(n, A, B))
