def solve():
    # Read inputs
    n, m, k = map(int, input().split())  # n = permutation length, m = length of runes, k = number of students
    runes = list(map(int, input().split()))  # List of m runes
    students = []
    
    # Read student segments
    for i in range(k):
        l, r = map(int, input().split())
        students.append((l-1, r-1, i+1))  # 0-based indexing and storing student index
    
    # The desired permutation is [1, 2, ..., n]
    target = list(range(1, n+1))
    
    # Sort students by their left bounds
    students.sort()

    # Result list of students' indices
    result = []
    
    # Use a greedy approach to find the shortest sequence of student segments
    current_left = 0  # We want to cover the range [0, n-1]
    while current_left < n:
        best_right = -1
        best_student = -1
        for (l, r, idx) in students:
            if l <= current_left:
                if r > best_right:
                    best_right = r
                    best_student = idx
            if r >= n-1:
                break
        
        # If no student can extend the range, it's impossible
        if best_right == -1:
            print(-1)
            return
        
        # Add the chosen student to the result
        result.append(best_student)
        current_left = best_right + 1
    
    # Print the number of students and their indices
    print(len(result))
    print(' '.join(map(str, result)))

