def greedy_coloring(graph):
    # Количество вершин
    n = len(graph)
    
    # Массив цветов для вершин
    colors = [-1] * n
    
    # Для первой вершины выбираем любой цвет (например, 0)
    colors[0] = 0
    
    # Раскрасить остальные вершины
    for u in range(1, n):
        # Массив, который будет хранить доступные цвета
        available = [True] * n
        
        # Для каждого соседа вершины u делаем недоступными его цвета
        for v in graph[u]:
            if colors[v] != -1:
                available[colors[v]] = False
        
        # Выбираем минимальный доступный цвет
        for c in range(n):
            if available[c]:
                colors[u] = c
                break
    
    return colors

# Пример графа (в виде списка смежности)
# Граф с 4 вершинами, где граф представлен списком смежности:
# 0 - 1
# 1 - 2
# 2 - 3
# 3 - 0
graph = [
    [1, 3],  # Вершина 0 соединена с вершинами 1 и 3
    [0, 2],  # Вершина 1 соединена с вершинами 0 и 2
    [1, 3],  # Вершина 2 соединена с вершинами 1 и 3
    [0, 2]   # Вершина 3 соединена с вершинами 0 и 2
]

# Вызываем алгоритм раскраски
colors = greedy_coloring(graph)
print("Цвета вершин:", colors)
