import random

# Определение возможных фигур мультимино
TETROMINOS = [
    [(1, 1), (1, 2), (1, 3), (2, 3)],  # L-образная
    [(1, 1), (2, 1), (1, 2), (2, 2)],  # квадрат
    [(1, 1), (1, 2), (2, 2), (2, 3)],  # Z-образная
    [(0, 0), (1, 0), (2, 0), (3, 0)],  # линия
    [(1, 1), (2, 1), (2, 2), (3, 2)],  # S-образная
]

# Генерация случайной фигуры
def generate_mino():
    return random.choice(TETROMINOS)

# Отображение фигуры в виде координат на поле
def draw_mino(mino):
    field = [['.' for _ in range(10)] for _ in range(10)]  # 10x10 игровое поле
    for x, y in mino:
        if 0 <= x < 10 and 0 <= y < 10:
            field[x][y] = '#'
    return field

# Печать игрового поля
def print_field(field):
    for row in field:
        print(' '.join(row))
    print()

# Основная программа
def main():
    print("Пример работы с мультимино:\n")

    # Генерируем случайную фигуру
    mino = generate_mino()

    # Получаем поле с размещенной фигурой
    field = draw_mino(mino)

    # Печатаем поле
    print_field(field)

# Запуск программы
if __name__ == "__main__":
    main()
