import heapq

def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    # Чтение входных данных
    n, m, c = map(int, data[:3])
    stations = []
    for i in range(n):
        x, t = map(int, data[3 + 2 * i:5 + 2 * i])
        stations.append((x, t))
    stations.append((m, 0))  # Добавляем конечную точку
    
    # Инициализация переменных
    stations.sort()
    pq = []  # Приоритетная очередь: (время, текущая позиция, оставшееся топливо)
    heapq.heappush(pq, (0, 0, c))  # Начинаем с нуля времени, позиции 0, полного бака
    
    visited = {}
    
    while pq:
        current_time, current_pos, fuel = heapq.heappop(pq)
        
        # Если уже посетили эту позицию с этим количеством топлива, пропускаем
        if (current_pos, fuel) in visited and visited[(current_pos, fuel)] <= current_time:
            continue
        visited[(current_pos, fuel)] = current_time
        
        # Если достигли Москвы
        if current_pos == m:
            print(f"{current_time:.6f}")
            return
        
        # Перебираем все следующие заправочные станции
        for i in range(len(stations)):
            next_pos, refill_time = stations[i]
            distance = next_pos - current_pos
            
            if distance > c:  # Недостижимо без заправки
                break
            
            remaining_fuel = fuel - distance
            if remaining_fuel >= 0:
                # Можно доехать без заправки
                heapq.heappush(pq, (current_time + distance / fuel, next_pos, remaining_fuel))
            else:
                # Нужно заправиться
                heapq.heappush(pq, (current_time + refill_time + distance / c, next_pos, c - distance))
