from collections import defaultdict

def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    n, q = map(int, data[:2])  # Читаем количество вершин и запросов
    queries = data[2:]
    
    edges_by_color = defaultdict(set)  # Рёбра, сгруппированные по цветам
    degree = defaultdict(lambda: defaultdict(int))  # degree[v][c] — степень вершины v для цвета c
    is_excellent = defaultdict(lambda: True)  # Флаг превосходности цвета
    total_beauty = 0  # Суммарная красота
    
    results = []
    
    def update_excellence(color):
        """Проверяет и обновляет статус превосходности цвета."""
        nonlocal total_beauty
        if is_excellent[color]:
            # Проверяем, остался ли цвет превосходным
            for v in degree:
                if degree[v][color] > 1:
                    is_excellent[color] = False
                    total_beauty -= len(edges_by_color[color])
                    break
        else:
            # Проверяем, стал ли цвет снова превосходным
            if all(degree[v][color] <= 1 for v in degree if degree[v][color] > 0):
                is_excellent[color] = True
                total_beauty += len(edges_by_color[color])
    
    # Обработка запросов
    idx = 0
    while idx < len(queries):
        query = queries[idx]
        v, u, c = map(int, queries[idx + 1:idx + 4])
        idx += 4
        
        if query == "+":
            # Добавление ребра
            edges_by_color[c].add((v, u))
            degree[v][c] += 1
            degree[u][c] += 1
            update_excellence(c)
        elif query == "-":
            # Удаление ребра
            edges_by_color[c].remove((v, u))
            degree[v][c] -= 1
            degree[u][c] -= 1
            update_excellence(c)
        
        # Сохранить текущую суммарную красоту
        results.append(total_beauty)
    
    # Вывод результатов
    sys.stdout.write("\n".join(map(str, results)) + "\n")
