def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    n = int(data[0])  # Количество карточек
    a = list(map(int, data[1:n+1]))  # Лицевая сторона
    b = list(map(int, data[n+1:2*n+1]))  # Оборотная сторона
    
    # Проверка возможности сортировки
    def is_valid(order):
        for i in range(1, n):
            if order[i] <= order[i-1]:
                return False
        return True
    
    # Попробуем два варианта:
    # 1. Сортируем по a
    cards = sorted(zip(a, b))
    a_sorted = [card[0] for card in cards]
    b_sorted = [card[1] for card in cards]
    if is_valid(a_sorted) and is_valid(b_sorted):
        print(" ".join(map(str, a_sorted)))
        print(" ".join(map(str, b_sorted)))
        return
    
    # 2. Сортируем по b
    cards = sorted(zip(b, a))
    b_sorted = [card[0] for card in cards]
    a_sorted = [card[1] for card in cards]
    if is_valid(a_sorted) and is_valid(b_sorted):
        print(" ".join(map(str, a_sorted)))
        print(" ".join(map(str, b_sorted)))
        return
    
    # Если ни один вариант не работает
    print(-1)
