input_line = input()
nums = list(map(int, input_line.strip().split()))
x1, y1, x2, y2, x3, y3 = nums

def get_line_coefficients(x1, y1, x2, y2):
    A = y1 - y2
    B = x2 - x1
    C = x1 * y2 - x2 * y1
    return A, B, C

def point_line_distance(A, B, C, x0, y0):
    return abs(A * x0 + B * y0 + C) / ( (A ** 2 + B ** 2) ** 0.5 )

A12, B12, C12 = get_line_coefficients(x1, y1, x2, y2)
A13, B13, C13 = get_line_coefficients(x1, y1, x3, y3)
A23, B23, C23 = get_line_coefficients(x2, y2, x3, y3)

D12 = point_line_distance(A12, B12, C12, x3, y3)
D13 = point_line_distance(A13, B13, C13, x2, y2)
D23 = point_line_distance(A23, B23, C23, x1, y1)

min_distance = D12
best_line = (A12, B12, C12)
if D13 < min_distance:
    min_distance = D13
    best_line = (A13, B13, C13)
if D23 < min_distance:
    min_distance = D23
    best_line = (A23, B23, C23)

A, B, C = best_line

if A != 0 and B != 0:
    x0 = 0
    y0 = (-C - A * x0) / B
    if y0 != int(y0):
        y0 = 0
        x0 = (-C - B * y0) / A
else:
    if A == 0 and B != 0:
        y0 = -C / B
        x0 = 0
    elif B == 0 and A != 0:
        x0 = -C / A
        y0 = 0
    else:
        print("0 0 1 1")
        exit()

x0 = int(x0)
y0 = int(y0)

from math import gcd

dx = -B
dy = A

if dx == 0 and dy == 0:
    dx = 1
    dy = 0

g = gcd(abs(dx), abs(dy))
dx_unit = dx // g
dy_unit = dy // g

t1 = 1
t2 = 3

x1_out = x0 + dx_unit * t1
y1_out = y0 + dy_unit * t1

x2_out = x0 + dx_unit * t2
y2_out = y0 + dy_unit * t2

def clamp(value):
    return max(-10**9, min(10**9, value))

x1_out = int(clamp(x1_out))
y1_out = int(clamp(y1_out))
x2_out = int(clamp(x2_out))
y2_out = int(clamp(y2_out))

print(f"{abs(x1_out)} {abs(y1_out)} {abs(x2_out)} {abs(y2_out)}")
