import math

def is_possible_journey(x0, y0, x1, y1, jumps):
    n = len(jumps)
    distances = []
    for i in range(1, n + 1):
        distances.append(math.sqrt((x1 - x0) ** 2 + (y1 - y0) ** 2))
    
    if sum(distances) != sum(jumps):
        return False
    
    for i in range(n):
        if distances[i] != jumps[i]:
            return False
    
    return True

def calculate_coordinates(x0, y0, jumps):
    coordinates = [(x0, y0)]
    for jump in jumps:
        angle = random.uniform(0, 2 * math.pi)
        new_x = coordinates[-1][0] + jump * math.cos(angle)
        new_y = coordinates[-1][1] + jump * math.sin(angle)
        coordinates.append((new_x, new_y))
    
    return coordinates

def main():
    x0, y0 = map(int, input("Введите начальные координаты x0 и y0: ").split())
    x1, y1 = map(int, input("Введите конечные координаты x1 и y1: ").split())
    n = int(input("Введите количество прыжков n: "))
    jumps = list(map(int, input("Введите длины прыжков: ").split()))

    if is_possible_journey(x0, y0, x1, y1, jumps):
        print("Possible")
        coordinates = calculate_coordinates(x0, y0, jumps)
        for coord in coordinates:
            print(f"{coord[0]:.6f} {coord[1]:.6f}")
    else:
        print("Impossible")

if __name__ == "__main__":
    main()
