from itertools import permutations

def calculate_distance(path):
    """Функция для расчета длины маршрута."""
    distance = 0
    for i in range(len(path) - 1):
        x1, y1 = path[i]
        x2, y2 = path[i + 1]
        distance += abs(x1 - x2) + abs(y1 - y2)
    return distance

def find_optimal_route(beacons):
    """Функция для нахождения оптимального маршрута."""
    start_point = (0, 0)
    shortest_distance = float('inf')
    optimal_path = []
    
    # Все возможные перестановки маяков
    for perm in permutations(beacons):
        path = [start_point] + list(perm) + [start_point]
        distance = calculate_distance(path)
        
        if distance < shortest_distance:
            shortest_distance = distance
            optimal_path = path
    
    return optimal_path, shortest_distance

def main():
    # Ввод данных
    n = int(input())
    beacons = []
    for _ in range(n):
        x, y = map(int, input().split())
        beacons.append((x, y))
    
    # Поиск оптимального маршрута
    optimal_path, shortest_distance = find_optimal_route(beacons)
    
    # Вывод результата
    for point in optimal_path:
        print(point[0], point[1])

if _name_ == "_main_":
    main()
    
