import math

def solve(x0, y0, x1, y1, n, jumps):
    # Вычисляем общее расстояние между начальной и конечной точкой
    total_dx = x1 - x0
    total_dy = y1 - y0
    total_distance = math.sqrt(total_dx ** 2 + total_dy ** 2)
    
    # Проверим, если сумма всех прыжков не совпадает с расстоянием
    if sum(jumps) != total_distance:
        print("Impossible")
        return
    
    # Начальная позиция кузнечика
    x, y = x0, y0
    print("Possible")
    
    # Направление движения (от начальной точки к конечной)
    for i in range(n):
        # Длина текущего прыжка
        jump_length = jumps[i]
        
        # Нормализуем вектор от текущей позиции к целевой
        dist = math.sqrt(total_dx ** 2 + total_dy ** 2)
        
        if dist == 0:
            # Если мы уже на целевой точке, выводим
            print("{x1:.8} {y1:.8}")
            continue
        
        # Вычисляем коэффициент для пропорционального деления текущего расстояния
        factor = jump_length / dist
        dx_new = total_dx * factor
        dy_new = total_dy * factor
        
        # Обновляем текущие координаты
        x += dx_new
        y += dy_new
        
        # Выводим текущие координаты после прыжка
        print("{x:.8} {y:.8}")
        
        # Обновляем оставшийся вектор для следующего прыжка
        total_dx -= dx_new
        total_dy -= dy_new

# Чтение входных данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
jumps = list(map(int, input().split()))

# Вызов функции
solve(x0, y0, x1, y1, n, jumps)

