from collections import defaultdict

def solve():
    # Чтение входных данных
    n, q = map(int, input().split())
    
    # Храним количество рёбер для каждого цвета
    edge_count = defaultdict(int)
    # Храним количество рёбер, исходящих от каждой вершины для каждого цвета
    vertex_edge_count = defaultdict(lambda: defaultdict(int))
    # Храним "красоту" графа, то есть количество рёбер для превосходных цветов
    beauty = 0
    
    # Обрабатываем запросы
    for _ in range(q):
        query = input().split()
        action, v, u, c = query[0], int(query[1]), int(query[2]), int(query[3])
        
        if action == "+":
            # Проверяем, не нарушает ли превосходность цвета c
            # Если из вершины v уже выходит ребро цвета c или из вершины u
            if vertex_edge_count[c][v] == 0 and vertex_edge_count[c][u] == 0:
                # Если обе вершины не имеют рёбер этого цвета, то этот цвет превосходный
                edge_count[c] += 1
                beauty += 1
            
            # Увеличиваем количество рёбер для этих вершин и этого цвета
            vertex_edge_count[c][v] += 1
            vertex_edge_count[c][u] += 1
        
        elif action == "-":
            # Уменьшаем количество рёбер
            edge_count[c] -= 1
            beauty -= 1
            
            # Уменьшаем количество рёбер для этих вершин и этого цвета
            vertex_edge_count[c][v] -= 1
            vertex_edge_count[c][u] -= 1
        
        # После каждого запроса выводим суммарную красоту
        print(beauty)

# Ввод
solve()
