def find_min_line(x1, y1, x2, y2, x3, y3):
    def line_through_points(x1, y1, x2, y2):
        A = y2 - y1
        B = x1 - x2
        C = -(A * x1 + B * y1)
        return A, B, C

    def point_to_line_distance(A, B, C, px, py):
        return abs(A * px + B * py + C) / (A**2 + B**2)**0.5

    lines = [
        ((x1, y1), (x2, y2)),
        ((x1, y1), (x3, y3)),
        ((x2, y2), (x3, y3)),
    ]

    min_distance = float('inf')
    best_line = None

    for (x1, y1), (x2, y2) in lines:
        A, B, C = line_through_points(x1, y1, x2, y2)

        dist_sum = (point_to_line_distance(A, B, C, x1, y1) +
                    point_to_line_distance(A, B, C, x2, y2) +
                    point_to_line_distance(A, B, C, x3, y3))

        if dist_sum < min_distance:
            min_distance = dist_sum
            best_line = ((x1, y1), (x2, y2))

    return best_line
point1, point2 = find_min_line(x1, y1, x2, y2, x3, y3)

print(point1[0], point1[1])
print(point2[0], point2[1])
