def find_min_line(x1, y1, x2, y2, x3, y3):
    # Функция для нахождения коэффициентов прямой, проходящей через две точки
    def line_through_points(x1, y1, x2, y2):
        A = y2 - y1
        B = x1 - x2
        C = -(A * x1 + B * y1)
        return A, B, C

    # Функция для вычисления расстояния от точки до прямой
    def point_to_line_distance(A, B, C, px, py):
        return abs(A * px + B * py + C) / (A ** 2 + B ** 2) ** 0.5

    # Линии, образованные каждой парой точек
    lines = [
        ((x1, y1), (x2, y2)),
        ((x1, y1), (x3, y3)),
        ((x2, y2), (x3, y3)),
    ]

    # Вычисление расстояний для каждой из трёх линий
    distances = []
    for line in lines:
        A, B, C = line_through_points(*line[0], *line[1])
        distances.append(sum(point_to_line_distance(A, B, C, *point) for point in [(x1, y1), (x2, y2), (x3, y3)]))

    # Выбор линии с минимальной суммой расстояний
    best_line = lines[distances.index(min(distances))]

    return best_line

# Пример использования:
x1, y1 = map(int, input().split())
x2, y2 = map(int, input().split())
x3, y3 = map(int, input().split())

point1, point2 = find_min_line(x1, y1, x2, y2, x3, y3)

print(point1[0], point1[1])
print(point2[0], point2[1])

