def find_min_line(x1, y1, x2, y2, x3, y3):
    # Функция для нахождения коэффициентов прямой, проходящей через две точки
    def line_through_points(x1, y1, x2, y2):
        A = y2 - y1
        B = x1 - x2
        C = -(A * x1 + B * y1)
        return A, B, C

    # Функция для вычисления расстояния от точки до прямой
    def point_to_line_distance(A, B, C, px, py):
        # Используем формулу для расстояния от точки до прямой: |Ax + By + C| / sqrt(A^2 + B^2)
        return abs(A * px + B * py + C) / (A ** 2 + B ** 2) ** 0.5

    # Линии, образованные каждой парой точек
    lines = [
        ((x1, y1), (x2, y2)),
        ((x1, y1), (x3, y3)),
        ((x2, y2), (x3, y3)),
    ]
    
    # Для каждой линии находим сумму расстояний от всех точек
    min_distance = float('inf')
    best_line = None

    for line in lines:
        A, B, C = line_through_points(*line[0], *line[1])
        # Суммируем расстояния для всех трёх точек от этой линии
        total_distance = (point_to_line_distance(A, B, C, x1, y1) +
                          point_to_line_distance(A, B, C, x2, y2) +
                          point_to_line_distance(A, B, C, x3, y3))

        if total_distance < min_distance:
            min_distance = total_distance
            best_line = line

    return best_line

# Пример использования:
x1, y1 = map(int, input().split())
x2, y2 = map(int, input().split())
x3, y3 = map(int, input().split())

point1, point2 = find_min_line(x1, y1, x2, y2, x3, y3)

print(point1[0], point1[1])
print(point2[0], point2[1])


