#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

const double PI = 3.14159265358979323846;
const double EPS = 1e-6;

int main() {
    // Ввод данных
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0 >> x1 >> y1 >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    // Вычислим разницу по координатам
    double dx = x1 - x0;
    double dy = y1 - y0;

    // Перемещение для каждого прыжка
    vector<pair<double, double>> points;
    double current_x = x0;
    double current_y = y0;

    // Изначальный угол
    double angle = atan2(dy, dx);

    // Ходим по каждому прыжку
    for (int i = 0; i < n; ++i) {
        // Для каждого прыжка можно выбрать направление.
        double jump_length = a[i];
        double jump_dx = jump_length * cos(angle);
        double jump_dy = jump_length * sin(angle);

        // Обновляем текущую позицию
        current_x += jump_dx;
        current_y += jump_dy;

        // Записываем точку после этого прыжка
        points.push_back({current_x, current_y});

        // Пытаемся вычислить следующий угол
        dx = x1 - current_x;
        dy = y1 - current_y;
        angle = atan2(dy, dx);

        // Если мы уже почти на месте, выходим из цикла
        if (abs(current_x - x1) < EPS && abs(current_y - y1) < EPS) {
            break;
        }
    }

    // Проверяем, пришли ли мы в нужную точку
    if (abs(current_x - x1) < EPS && abs(current_y - y1) < EPS) {
        cout << "Possible" << endl;
        for (auto& p : points) {
            printf("%.6f %.6f\n", p.first, p.second);
        }
    } else {
        cout << "Impossible" << endl;
    }

    return 0;
}
