#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Interval {
    int l, r, idx; // l и r - границы отрезка, idx - индекс ученика
};

bool compareIntervals(const Interval& a, const Interval& b) {
    return a.l < b.l; // Сортируем по начальной позиции
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<int> p(n); // Перестановка, которую нужно получить
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }

    vector<Interval> intervals(k);
    for (int i = 0; i < k; i++) {
        cin >> intervals[i].l >> intervals[i].r;
        intervals[i].idx = i + 1; // Индекс ученика
    }

    // Сортируем интервалы по начальной позиции
    sort(intervals.begin(), intervals.end(), compareIntervals);

    vector<int> pos(n + 1, -1); // Сохраняем, где каждое число из перестановки расположено в справочнике
    for (int i = 0; i < m; i++) {
        int rune;
        cin >> rune;
        pos[rune] = i + 1; // Присваиваем позиции каждой руне в справочнике
    }

    int currentPosition = 0; // Текущая позиция в перестановке
    int usedCount = 0; // Количество использованных учеников
    int i = 0; // Индекс текущего ученика
    while (currentPosition < n) {
        int bestNext = -1;
        // Ищем подходящих учеников, которые могут покрыть требуемую позицию
        while (i < k && intervals[i].l <= currentPosition + 1) {
            if (intervals[i].r >= currentPosition + 1) {
                bestNext = max(bestNext, intervals[i].r);
            }
            i++;
        }

        if (bestNext == -1) {
            cout << -1 << endl; // Невозможно покрыть перестановку
            return 0;
        }

        usedCount++;
        currentPosition = bestNext; // Обновляем текущую позицию
    }

    cout << usedCount << endl; // Выводим количество используемых учеников
    return 0;
}
