from collections import defaultdict
def process_queries(n, q, queries):
    color_edges_count = defaultdict(int)
    vertex_color_degree = defaultdict(lambda: defaultdict(int))
    total_beauty = 0
    def is_excellent(color):
        return all(vertex_color_degree[v][color] <= 1 for v in range(1, n + 1))
    for query in queries:
        type_of_query, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        if type_of_query == '+':
            color_edges_count[c] += 1
            vertex_color_degree[v][c] += 1
            vertex_color_degree[u][c] += 1
        elif type_of_query == '-':
            color_edges_count[c] -= 1
            vertex_color_degree[v][c] -= 1
            vertex_color_degree[u][c] -= 1
        total_beauty = 0
        for color, count in color_edges_count.items():
            if is_excellent(color):
                total_beauty += count
        print(total_beauty)
n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]
process_queries(n, q, queries)