from collections import defaultdict
def process_queries(n, q, queries):
    color_edges_count = defaultdict(int)
    vertex_color_degree = defaultdict(lambda: defaultdict(int))
    color_non_excellent_count = defaultdict(int)
    total_beauty = 0
    excellent_colors = set()
    def update_beauty(color):
        if color_non_excellent_count[color] == 0:
            excellent_colors.add(color)
        else:
            excellent_colors.discard(color)
        return sum(color_edges_count[c] for c in excellent_colors)
    for query in queries:
        type_of_query, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        if type_of_query == '+':
            color_edges_count[c] += 1
            vertex_color_degree[v][c] += 1
            vertex_color_degree[u][c] += 1
            if vertex_color_degree[v][c] == 2:
                color_non_excellent_count[c] += 1
            if vertex_color_degree[u][c] == 2:
                color_non_excellent_count[c] += 1
        elif type_of_query == '-':
            color_edges_count[c] -= 1
            vertex_color_degree[v][c] -= 1
            vertex_color_degree[u][c] -= 1
            if vertex_color_degree[v][c] == 1:
                color_non_excellent_count[c] -= 1
            if vertex_color_degree[u][c] == 1:
                color_non_excellent_count[c] -= 1
        total_beauty = update_beauty(c)
        print(total_beauty)
n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]
process_queries(n, q, queries)
