n = int(input())  # Вводим количество карточек
a = list(map(int, input().split()))  # Годы на лицевой стороне карточек
b = list(map(int, input().split()))  # Годы на оборотной стороне карточек

# Массив для хранения пар (лицевая сторона, оборотная сторона)
cards = [(a[i], b[i]) for i in range(n)]

# Сортируем карточки по минимальному году на каждой карточке
cards.sort(key=lambda x: (min(x), max(x)))

# Для решения задачи нужно следить за порядком на лицевой и оборотной сторонах
last_a = last_b = -1  # Начальные значения для проверки возрастающих последовательностей

# Массивы для хранения итоговых годов на лицевой и оборотной сторонах
res_a = []
res_b = []

for card in cards:
    x, y = card
    # Для каждой карточки выбираем минимальный возможный год для лицевой стороны
    if x > last_a:
        res_a.append(x)
        last_a = x
        res_b.append(y)
        last_b = y
    elif y > last_a:
        res_a.append(y)
        last_a = y
        res_b.append(x)
        last_b = x
    else:
        # Если для текущей карточки нельзя выбрать год для лицевой стороны
        # и не можем организовать возрастающий порядок, выводим -1
        print(-1)
        exit()

# Выводим результат
print(" ".join(map(str, res_a)))
print(" ".join(map(str, res_b)))
