def bresenham(x1, y1, x2, y2):
    coords = []
    dx = abs(x2 - x1)
    dy = abs(y2 - y1)
    sx = 1 if x1 < x2 else -1
    sy = 1 if y1 < y2 else -1
    err = dx - dy
    while True:
        coords.append((x1, y1))
        if x1 == x2 and y1 == y2:
            break
        e2 = 2 * err
        if e2 > -dy:
            err -= dy
            x1 += sx
        if e2 < dx:
            err += dx
            y1 += sy
    return coords

x1, y1, x2, y2, x3, y3 = map(int, input().split())
coords = set(bresenham(x1, y1, x2, y2))
coords.discard((x1, y1))
coords.discard((x2, y2))
coords.discard((x3, y3))
coords = sorted(coords)
res = coords[:2]
print("{} {} {} {}".format(res[0][0], res[0][1], res[1][0], res[1][1]))