﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
ld INF = 1e18;
struct Point {
    ll x, y;
    Point(ll x1, ll y1) : x(x1), y(y1) {}
    Point operator + (const Point& other) const {
        return Point(x + other.x, y + other.y);
    }
    Point operator - (const Point& other) const {
        return Point(x - other.x, y - other.y);
    }
    ll operator %(const Point& other) const {
        return x * other.y - y * other.x;
    }
    ld len() const {
        return sqrt(x * x + y * y);
    }
};
void solve() {
    Point a(0, 0), b(0, 0), c(0, 0);
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    Point AB = b - a, AC = c - a, BC = c - b, BA = a - b;
    ld mn = INF;
    Point a1(0, 0), b1(0, 0);
    if ((ld)llabs(AB % AC) / (2.0 * AB.len()) <= mn) {
        mn = (ld)llabs(AB % AC) / ((ld)2.0 * AB.len());
        a1 = a;
        b1 = b;
    }
    if ((ld)llabs(AC % AB) / (2.0 * AC.len()) <= mn) {
        mn = (ld)llabs(AC % AB) / ((ld)2.0 * AC.len());
        a1 = a;
        b1 = c;
    }
    if ((ld)llabs(BC % BA) / (2.0 * BC.len()) <= mn) {
        mn = (ld)llabs(BC % BA) / ((ld)2.0 * BC.len());
        a1 = b;
        b1 = c;
    }
    cout << a1.x << " " << a1.y << " " << b1.x << " " << b1.y;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}