def minimum_travel_time(n, l, m, stations):
    # Binary search to find the minimum possible travel time
    def can_reach_moscow(max_time):
        current_fuel = l  # Start with a full tank
        current_time = 0  # Start at time 0
        last_position = 0  # Starting position

        for position, time_to_refuel in stations + [(m, 0)]:
            distance = position - last_position

            # Check if the distance can be covered with the current fuel
            if distance > l:
                return False  # Can't reach this station

            if distance > current_fuel:
                # Refuel at the previous station
                current_time += time_to_refuel
                current_fuel = l

            current_fuel -= distance
            current_time += distance  # Add travel time
            last_position = position

            if current_time > max_time:
                return False

        return True

    # Binary search for the minimum time
    left, right = 0, 10**18  # Set an initially large range for time
    answer = right

    while right - left > 1e-6:  # Precision threshold
        mid = (left + right) / 2
        if can_reach_moscow(mid):
            answer = mid
            right = mid
        else:
            left = mid

    return answer


# Input data
n, l, m = map(int, input().split())  # Number of stations, tank capacity, distance to Moscow
stations = []

for _ in range(n):
    z, t = map(int, input().split())
    stations.append((z, t))

# Sort stations by their position
stations.sort()

# Solve the problem
result = minimum_travel_time(n, l, m, stations)
print(f"{result:.9f}")
