def min_time_to_moscow(n, m, c, stations):
    time = 0  # Total time spent
    position = 0  # Current position of the car
    speed = c  # Car speed proportional to tank capacity

    for i in range(n):
        # Distance to the next station
        distance_to_next = stations[i][0] - position

        # Check if we can reach the next station
        if distance_to_next > c:
            return "Impossible to reach Moscow"

        # Travel to the next station: calculate time by depleting the full tank
        travel_time = distance_to_next / speed
        time += travel_time

        # Refuel at the station and add refueling time
        time += stations[i][1]  # Refueling time
        position = stations[i][0]  # Update position

    # Calculate the distance and time to reach Moscow from the last station
    distance_to_moscow = m - position
    if distance_to_moscow > c:
        return "Impossible to reach Moscow"

    # Time to reach Moscow from the last station
    travel_time_to_moscow = distance_to_moscow / speed
    time += travel_time_to_moscow

    # Return the total time
    return time


# Input parsing
n, m, c = map(int, input().split())  # Number of stations, distance to Moscow, and tank capacity
stations = [tuple(map(int, input().split())) for _ in range(n)]  # (distance, refuel time) for each station

# Solve the problem and print the result
result = min_time_to_moscow(n, m, c, stations)
if result == "Impossible to reach Moscow":
    print(result)
else:
    print(f"{result:.6f}")
