#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Card {
    int year;
    int index;

    //        
    Card(int y, int idx) : year(y), index(idx) {}

    //    
    bool operator<(const Card& other) const {
        return year < other.year;
    }
};

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);

    //       
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    //       
    vector<Card> front, back;

    for (int i = 0; i < n; i++) {
        front.push_back(Card(a[i], i));
        back.push_back(Card(b[i], i));
    }

    //    
    sort(front.begin(), front.end());
    sort(back.begin(), back.end());

    //   
    vector<int> result_front(n), result_back(n);

    // ,     
    for (int i = 1; i < n; i++) {
        if (front[i].year < front[i-1].year || back[i].year < back[i-1].year) {
            cout << -1 << endl;
            return 0;
        }
    }

    //     
    for (int i = 0; i < n; i++) {
        result_front[front[i].index] = a[front[i].index];
        result_back[back[i].index] = b[back[i].index];
    }

    //  
    for (int i = 0; i < n; i++) {
        cout << result_front[i] << " ";
    }
    cout << endl;

    for (int i = 0; i < n; i++) {
        cout << result_back[i] << " ";
    }
    cout << endl;

    return 0;
}







































/*
                                      ....:::::::::^^^^^^^^^^^::::::...
                        .:^~!7?YY5PPGGGGBBGBBGGGPPPPPGPPPPP555PGGGPPGGGGGGGGGY!.
                  :~?YPB######BGGP55YJ?777~^......::^^::::. ^^^:.    ...::^!JG&&5^
              ^?PB#G5Y?^:^^:::::::^^^^^^^^::.. .!!!~!!!!~  .^^~!!!^:.         :?#@5:
           :Y#&BY~.  ?!  .:^~!!!!!!!!!!!!^::. ::~~~~~::::~77!~^:^^.              7@&7
          7@&Y^       :!??J??????7!~:.           7#7~^^^^^:. .^!??!:^^::          ^B@Y
         !@B.       ^5Y7^.      ..!^:.          ^G^              :^~^!!?7^:^~^     .P@G.
        .#@~       ^J^            ^7            7:   .^!7?????7!^.   :7~:!~  .       5@#^
       ^G@?        .   .^!~^^.   !.             ~YB&&&BP&@@@@@@&BP7. .              7&@J:
     !P@B~     . .: !5B&GGGGB@@&BP7^.          ^JBB5?~:.^Y@@@@@@@@B#&&Y:.^^:.      .:^:!#@&5~
   !B@B7..^.   ~^.^ ~?YPPGGB#@@@@@@@#GPY~     7&@#^^!JPB#BPY5YY5PGGPPGG?:!^~^. ..::::..:!5GG&B?.
  ~@&7..:7:               .::^!75@@@Y~.      ^?GBGPY7~.   !5J!:       .^^7YPGBPPGGBB5!  :!!Y@#7
  Y@!!^ ~J^PGPGPYYPJ!^:.::.       ^@@P                       ~P&&#GPYY5GB##G5?~:^.  :7B@B~    ^G@5
  5@~Y^ P:^5?~:.^.Y&@&&#&&~     .~P@G:          .              .^~7???7!^:   :?B@#7.   ?@&^     G@7
  7@JY?~#~     Y&: .::^~   .!5#@G!           .GBBBPJ^J::....          .^?P#&#55@@#Y^  #@J     7@Y
  :&&7P^~?~   7@@B.       ^?P&@@#~         .:^^~7J??B@J!!7!!~^^:  .:~7YG##GJ!:  P@B55J~^&@7  :  5@?
   7@#7~  J7 :&&&@B^   ^!???7?5B@B!.      ^7J5PB##:~@@~    .:~7J5GB#B#&7^.    ^P@B.    ?@Y :J^.5@G.
    ?@&!  ^~ Y@JY@#&57^:        ^JBBGPPJ.        . J5?!?YPBBBGPY?!^.^B5  .~?5#@@G:     JJ ^?^7#@Y.
     !&@~   .#@@@Y7@@GBBPY?!~^:..  ^?5P~:^^~!7J5PGB###&@&7^:      ^Y&@G5GBB55@@5.      !! ^J#@G~
      5@G   :&@@G ^@5  :P@555PPPPPBBP55PP5#@BYJ?7!~^:.^&&:  .^!JP#@@@@@5~..?&&7          J@@P~
      7@&:  :&@@P?J@Y: .#B       .&P..    Y@?        ..P@P5B&@@@&GY!?@7  !#@5:         ^B@5:
      !@&:  .&@@@@@@@&GG@#YYJ??77J@Y!77777G@5~7?Y5PG#&@@@@&#PY7^.    P57G@P^          7@@!
      !@&:   P@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@&#G5?~?@?         :5@&Y^           Y@#^
      !@&.   ~@#5&@#G@@#&@@@@@@@@@@@@@@@&&BG#@Y!~^.      B@!    :!5#&G7.           ~B@P:
      7@B     5@BY@5 J@P^!G@@5???7B@P^^^:.  7@~          ~@&~^JG&&P?:            ~P@#!
      ?@P      J&&@Y::?@P. 7@B:   !@#.      ^@?     ..:^~7&@&BPJ~.  :.   .:   :?B@B7
      P@Y       .!YPGBB&@&5!P@&J^.:#@5^~~~!7?@G?YPPGB#BBP5?~:. ..:~^^:.:~^:^?G&&5~
      P@!       .^.  .:^^!7???JYYJ?Y5555555YJJ?77!!^^..   .^~!~^.:^^::.^75B&BY~.
      P&:  .J^   ^?J~        ::^^^!!!~^^^^:      .^~^.^~~~^: :^!JGB#GY!:
      G#    ^5Y^   :!~:^^^^!!!!!!!!!!!~^^.:~???!^  :::^~7YGB#G5?^.
      G@^     ~?7^::::^^^^^~~~~^^^. .^~!!7!~^:.   :!YG#&B5?~.
      ?@#^       .:^^~~~~~~~~^^^::..           .^75B##P?~.
       7&@Y:                              .:^!7JYPBBBPJ!:
        .J#&BY!^.               .:^~7?YPGB#BBG5Y?!^.
           ^?5BBBG5YYYJJJYYY5PPGBBBGP5J?!~:.
               .:^~777????777!~^:.

                                      ....:::::::::^^^^^^^^^^^::::::...
                        .:^~!7?YY5PPGGGGBBGBBGGGPPPPPGPPPPP555PGGGPPGGGGGGGGGY!.
                  :~?YPB######BGGP55YJ?777~^......::^^::::. ^^^:.    ...::^!JG&&5^
              ^?PB#G5Y?^:^^:::::::^^^^^^^^::.. .!!!~!!!!~  .^^~!!!^:.         :?#@5:
           :Y#&BY~.  ?!  .:^~!!!!!!!!!!!!^::. ::~~~~~::::~77!~^:^^.              7@&7
          7@&Y^       :!??J??????7!~:.           7#7~^^^^^:. .^!??!:^^::          ^B@Y
         !@B.       ^5Y7^.      ..!^:.          ^G^              :^~^!!?7^:^~^     .P@G.
        .#@~       ^J^            ^7            7:   .^!7?????7!^.   :7~:!~  .       5@#^
       ^G@?        .   .^!~^^.   !.             ~YB&&&BP&@@@@@@&BP7. .              7&@J:
     !P@B~     . .: !5B&GGGGB@@&BP7^.          ^JBB5?~:.^Y@@@@@@@@B#&&Y:.^^:.      .:^:!#@&5~
   !B@B7..^.   ~^.^ ~?YPPGGB#@@@@@@@#GPY~     7&@#^^!JPB#BPY5YY5PGGPPGG?:!^~^. ..::::..:!5GG&B?.
  ~@&7..:7:               .::^!75@@@Y~.      ^?GBGPY7~.   !5J!:       .^^7YPGBPPGGBB5!  :!!Y@#7
  Y@!!^ ~J^PGPGPYYPJ!^:.::.       ^@@P                       ~P&&#GPYY5GB##G5?~:^.  :7B@B~    ^G@5
  5@~Y^ P:^5?~:.^.Y&@&&#&&~     .~P@G:          .              .^~7???7!^:   :?B@#7.   ?@&^     G@7
  7@JY?~#~     Y&: .::^~   .!5#@G!           .GBBBPJ^J::....          .^?P#&#55@@#Y^  #@J     7@Y
  :&&7P^~?~   7@@B.       ^?P&@@#~         .:^^~7J??B@J!!7!!~^^:  .:~7YG##GJ!:  P@B55J~^&@7  :  5@?
   7@#7~  J7 :&&&@B^   ^!???7?5B@B!.      ^7J5PB##:~@@~    .:~7J5GB#B#&7^.    ^P@B.    ?@Y :J^.5@G.
    ?@&!  ^~ Y@JY@#&57^:        ^JBBGPPJ.        . J5?!?YPBBBGPY?!^.^B5  .~?5#@@G:     JJ ^?^7#@Y.
     !&@~   .#@@@Y7@@GBBPY?!~^:..  ^?5P~:^^~!7J5PGB###&@&7^:      ^Y&@G5GBB55@@5.      !! ^J#@G~
      5@G   :&@@G ^@5  :P@555PPPPPBBP55PP5#@BYJ?7!~^:.^&&:  .^!JP#@@@@@5~..?&&7          J@@P~
      7@&:  :&@@P?J@Y: .#B       .&P..    Y@?        ..P@P5B&@@@&GY!?@7  !#@5:         ^B@5:
      !@&:  .&@@@@@@@&GG@#YYJ??77J@Y!77777G@5~7?Y5PG#&@@@@&#PY7^.    P57G@P^          7@@!
      !@&:   P@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@&#G5?~?@?         :5@&Y^           Y@#^
      !@&.   ~@#5&@#G@@#&@@@@@@@@@@@@@@@&&BG#@Y!~^.      B@!    :!5#&G7.           ~B@P:
      7@B     5@BY@5 J@P^!G@@5???7B@P^^^:.  7@~          ~@&~^JG&&P?:            ~P@#!
      ?@P      J&&@Y::?@P. 7@B:   !@#.      ^@?     ..:^~7&@&BPJ~.  :.   .:   :?B@B7
      P@Y       .!YPGBB&@&5!P@&J^.:#@5^~~~!7?@G?YPPGB#BBP5?~:. ..:~^^:.:~^:^?G&&5~
      P@!       .^.  .:^^!7???JYYJ?Y5555555YJJ?77!!^^..   .^~!~^.:^^::.^75B&BY~.
      P&:  .J^   ^?J~        ::^^^!!!~^^^^:      .^~^.^~~~^: :^!JGB#GY!:
      G#    ^5Y^   :!~:^^^^!!!!!!!!!!!~^^.:~???!^  :::^~7YGB#G5?^.
      G@^     ~?7^::::^^^^^~~~~^^^. .^~!!7!~^:.   :!YG#&B5?~.
      ?@#^       .:^^~~~~~~~~^^^::..           .^75B##P?~.
       7&@Y:                              .:^!7JYPBBBPJ!:
        .J#&BY!^.               .:^~7?YPGB#BBG5Y?!^.
           ^?5BBBG5YYYJJJYYY5PPGBBBGP5J?!~:.
               .:^~777????777!~^:.

                                      ....:::::::::^^^^^^^^^^^::::::...
                        .:^~!7?YY5PPGGGGBBGBBGGGPPPPPGPPPPP555PGGGPPGGGGGGGGGY!.
                  :~?YPB######BGGP55YJ?777~^......::^^::::. ^^^:.    ...::^!JG&&5^
              ^?PB#G5Y?^:^^:::::::^^^^^^^^::.. .!!!~!!!!~  .^^~!!!^:.         :?#@5:
           :Y#&BY~.  ?!  .:^~!!!!!!!!!!!!^::. ::~~~~~::::~77!~^:^^.              7@&7
          7@&Y^       :!??J??????7!~:.           7#7~^^^^^:. .^!??!:^^::          ^B@Y
         !@B.       ^5Y7^.      ..!^:.          ^G^              :^~^!!?7^:^~^     .P@G.
        .#@~       ^J^            ^7            7:   .^!7?????7!^.   :7~:!~  .       5@#^
       ^G@?        .   .^!~^^.   !.             ~YB&&&BP&@@@@@@&BP7. .              7&@J:
     !P@B~     . .: !5B&GGGGB@@&BP7^.          ^JBB5?~:.^Y@@@@@@@@B#&&Y:.^^:.      .:^:!#@&5~
   !B@B7..^.   ~^.^ ~?YPPGGB#@@@@@@@#GPY~     7&@#^^!JPB#BPY5YY5PGGPPGG?:!^~^. ..::::..:!5GG&B?.
  ~@&7..:7:               .::^!75@@@Y~.      ^?GBGPY7~.   !5J!:       .^^7YPGBPPGGBB5!  :!!Y@#7
  Y@!!^ ~J^PGPGPYYPJ!^:.::.       ^@@P                       ~P&&#GPYY5GB##G5?~:^.  :7B@B~    ^G@5
  5@~Y^ P:^5?~:.^.Y&@&&#&&~     .~P@G:          .              .^~7???7!^:   :?B@#7.   ?@&^     G@7
  7@JY?~#~     Y&: .::^~   .!5#@G!           .GBBBPJ^J::....          .^?P#&#55@@#Y^  #@J     7@Y
  :&&7P^~?~   7@@B.       ^?P&@@#~         .:^^~7J??B@J!!7!!~^^:  .:~7YG##GJ!:  P@B55J~^&@7  :  5@?
   7@#7~  J7 :&&&@B^   ^!???7?5B@B!.      ^7J5PB##:~@@~    .:~7J5GB#B#&7^.    ^P@B.    ?@Y :J^.5@G.
    ?@&!  ^~ Y@JY@#&57^:        ^JBBGPPJ.        . J5?!?YPBBBGPY?!^.^B5  .~?5#@@G:     JJ ^?^7#@Y.
     !&@~   .#@@@Y7@@GBBPY?!~^:..  ^?5P~:^^~!7J5PGB###&@&7^:      ^Y&@G5GBB55@@5.      !! ^J#@G~
      5@G   :&@@G ^@5  :P@555PPPPPBBP55PP5#@BYJ?7!~^:.^&&:  .^!JP#@@@@@5~..?&&7          J@@P~
      7@&:  :&@@P?J@Y: .#B       .&P..    Y@?        ..P@P5B&@@@&GY!?@7  !#@5:         ^B@5:
      !@&:  .&@@@@@@@&GG@#YYJ??77J@Y!77777G@5~7?Y5PG#&@@@@&#PY7^.    P57G@P^          7@@!
      !@&:   P@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@&#G5?~?@?         :5@&Y^           Y@#^
      !@&.   ~@#5&@#G@@#&@@@@@@@@@@@@@@@&&BG#@Y!~^.      B@!    :!5#&G7.           ~B@P:
      7@B     5@BY@5 J@P^!G@@5???7B@P^^^:.  7@~          ~@&~^JG&&P?:            ~P@#!
      ?@P      J&&@Y::?@P. 7@B:   !@#.      ^@?     ..:^~7&@&BPJ~.  :.   .:   :?B@B7
      P@Y       .!YPGBB&@&5!P@&J^.:#@5^~~~!7?@G?YPPGB#BBP5?~:. ..:~^^:.:~^:^?G&&5~
      P@!       .^.  .:^^!7???JYYJ?Y5555555YJJ?77!!^^..   .^~!~^.:^^::.^75B&BY~.
      P&:  .J^   ^?J~        ::^^^!!!~^^^^:      .^~^.^~~~^: :^!JGB#GY!:
      G#    ^5Y^   :!~:^^^^!!!!!!!!!!!~^^.:~???!^  :::^~7YGB#G5?^.
      G@^     ~?7^::::^^^^^~~~~^^^. .^~!!7!~^:.   :!YG#&B5?~.
      ?@#^       .:^^~~~~~~~~^^^::..           .^75B##P?~.
       7&@Y:                              .:^!7JYPBBBPJ!:
        .J#&BY!^.               .:^~7?YPGB#BBG5Y?!^.
           ^?5BBBG5YYYJJJYYY5PPGBBBGP5J?!~:.
               .:^~777????777!~^:.

                                      ....:::::::::^^^^^^^^^^^::::::...
                        .:^~!7?YY5PPGGGGBBGBBGGGPPPPPGPPPPP555PGGGPPGGGGGGGGGY!.
                  :~?YPB######BGGP55YJ?777~^......::^^::::. ^^^:.    ...::^!JG&&5^
              ^?PB#G5Y?^:^^:::::::^^^^^^^^::.. .!!!~!!!!~  .^^~!!!^:.         :?#@5:
           :Y#&BY~.  ?!  .:^~!!!!!!!!!!!!^::. ::~~~~~::::~77!~^:^^.              7@&7
          7@&Y^       :!??J??????7!~:.           7#7~^^^^^:. .^!??!:^^::          ^B@Y
         !@B.       ^5Y7^.      ..!^:.          ^G^              :^~^!!?7^:^~^     .P@G.
        .#@~       ^J^            ^7            7:   .^!7?????7!^.   :7~:!~  .       5@#^
       ^G@?        .   .^!~^^.   !.             ~YB&&&BP&@@@@@@&BP7. .              7&@J:
     !P@B~     . .: !5B&GGGGB@@&BP7^.          ^JBB5?~:.^Y@@@@@@@@B#&&Y:.^^:.      .:^:!#@&5~
   !B@B7..^.   ~^.^ ~?YPPGGB#@@@@@@@#GPY~     7&@#^^!JPB#BPY5YY5PGGPPGG?:!^~^. ..::::..:!5GG&B?.
  ~@&7..:7:               .::^!75@@@Y~.      ^?GBGPY7~.   !5J!:       .^^7YPGBPPGGBB5!  :!!Y@#7
  Y@!!^ ~J^PGPGPYYPJ!^:.::.       ^@@P                       ~P&&#GPYY5GB##G5?~:^.  :7B@B~    ^G@5
  5@~Y^ P:^5?~:.^.Y&@&&#&&~     .~P@G:          .              .^~7???7!^:   :?B@#7.   ?@&^     G@7
  7@JY?~#~     Y&: .::^~   .!5#@G!           .GBBBPJ^J::....          .^?P#&#55@@#Y^  #@J     7@Y
  :&&7P^~?~   7@@B.       ^?P&@@#~         .:^^~7J??B@J!!7!!~^^:  .:~7YG##GJ!:  P@B55J~^&@7  :  5@?
   7@#7~  J7 :&&&@B^   ^!???7?5B@B!.      ^7J5PB##:~@@~    .:~7J5GB#B#&7^.    ^P@B.    ?@Y :J^.5@G.
    ?@&!  ^~ Y@JY@#&57^:        ^JBBGPPJ.        . J5?!?YPBBBGPY?!^.^B5  .~?5#@@G:     JJ ^?^7#@Y.
     !&@~   .#@@@Y7@@GBBPY?!~^:..  ^?5P~:^^~!7J5PGB###&@&7^:      ^Y&@G5GBB55@@5.      !! ^J#@G~
      5@G   :&@@G ^@5  :P@555PPPPPBBP55PP5#@BYJ?7!~^:.^&&:  .^!JP#@@@@@5~..?&&7          J@@P~
      7@&:  :&@@P?J@Y: .#B       .&P..    Y@?        ..P@P5B&@@@&GY!?@7  !#@5:         ^B@5:
      !@&:  .&@@@@@@@&GG@#YYJ??77J@Y!77777G@5~7?Y5PG#&@@@@&#PY7^.    P57G@P^          7@@!
      !@&:   P@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@&#G5?~?@?         :5@&Y^           Y@#^
      !@&.   ~@#5&@#G@@#&@@@@@@@@@@@@@@@&&BG#@Y!~^.      B@!    :!5#&G7.           ~B@P:
      7@B     5@BY@5 J@P^!G@@5???7B@P^^^:.  7@~          ~@&~^JG&&P?:            ~P@#!
      ?@P      J&&@Y::?@P. 7@B:   !@#.      ^@?     ..:^~7&@&BPJ~.  :.   .:   :?B@B7
      P@Y       .!YPGBB&@&5!P@&J^.:#@5^~~~!7?@G?YPPGB#BBP5?~:. ..:~^^:.:~^:^?G&&5~
      P@!       .^.  .:^^!7???JYYJ?Y5555555YJJ?77!!^^..   .^~!~^.:^^::.^75B&BY~.
      P&:  .J^   ^?J~        ::^^^!!!~^^^^:      .^~^.^~~~^: :^!JGB#GY!:
      G#    ^5Y^   :!~:^^^^!!!!!!!!!!!~^^.:~???!^  :::^~7YGB#G5?^.
      G@^     ~?7^::::^^^^^~~~~^^^. .^~!!7!~^:.   :!YG#&B5?~.
      ?@#^       .:^^~~~~~~~~^^^::..           .^75B##P?~.
       7&@Y:                              .:^!7JYPBBBPJ!:
        .J#&BY!^.               .:^~7?YPGB#BBG5Y?!^.
           ^?5BBBG5YYYJJJYYY5PPGBBBGP5J?!~:.
               .:^~777????777!~^:.

*/
