import math

def distance_to_line(A, B, C, x0, y0):
    return abs(A * x0 + B * y0 + C) / math.sqrt(A * A + B * B)

def main():
    x1, y1, x2, y2, x3, y3 = map(int, input().split())
    
    min_distance = float('inf')
    best_x1, best_y1, best_x2, best_y2 = None, None, None, None
    
    for i in range(3):
        xA = (x1, x2, x3)[i]
        yA = (y1, y2, y3)[i]
        
        xB = (x2, x3, x1)[i]
        yB = (y2, y3, y1)[i]
        
        A = yB - yA
        B = xA - xB
        C = xB * yA - xA * yB
        
        dist = (distance_to_line(A, B, C, x1, y1) +
                distance_to_line(A, B, C, x2, y2) +
                distance_to_line(A, B, C, x3, y3))
        
        if dist < min_distance:
            min_distance = dist
            best_x1, best_y1 = xA, yA
            best_x2, best_y2 = xB, yB
    
    print(best_x1, best_y1)
    print(best_x2, best_y2)

if __name__ == "__main__":
    main()

