
# Решение задачи "Натуральное деление" на Python

def find_numbers(n, digits):
    """
    Функция для поиска чисел a и b, соответствующих условиям задачи.
    
    :param n: Количество цифр после запятой.
    :param digits: Строка из n цифр, заданных в дробной части.
    :return: Строка с результатом ("NO" или "YES\na b").
    """
    # Преобразуем строку цифр в число (например, "69" -> 69)
    fractional_part = int(digits)
    # Число, которое будет в знаменателе (10^n)
    denominator = 10 ** n
    
    # Пробуем все возможные значения числителя
    for numerator in range(1, denominator):
        # Проверяем, что дробь numerator / denominator дает нужную дробную часть
        if (numerator * 10 ** n) // denominator == fractional_part:
            # Найдено подходящее a и b
            return f"YES\n{numerator} {denominator}"
    
    # Если ничего не найдено, возвращаем NO
    return "NO"

# Считывание входных данных
if __name__ == "__main__":
    n = int(input().strip())
    digits = input().strip()
    result = find_numbers(n, digits)
    print(result)
