def colorful_graph(n, q, queries):
    from collections import defaultdict

    # Храним ребра для каждого цвета
    edges_by_color = defaultdict(set)  # ключ - цвет, значение - множество рёбер

    # Храним количество рёбер, исходящих из каждой вершины для каждого цвета
    degree_by_color = defaultdict(lambda: defaultdict(int))  # {цвет: {вершина: степень}}

    # Подсчёт текущей красоты графа
    total_beauty = 0

    # Результат выполнения запросов
    results = []

    for query in queries:
        parts = query.split()
        if parts[0] == '+':
            v, u, c = map(int, parts[1:])
            if v > u:  # Упорядочиваем вершины
                v, u = u, v

            # Добавляем ребро (v, u) цвета c
            edges_by_color[c].add((v, u))

            # Проверяем изменения превосходности
            if degree_by_color[c][v] == 1 or degree_by_color[c][u] == 1:
                total_beauty -= len(edges_by_color[c])  # Удаляем красоту текущего цвета

            degree_by_color[c][v] += 1
            degree_by_color[c][u] += 1

            if degree_by_color[c][v] == 1 and degree_by_color[c][u] == 1:
                total_beauty += len(edges_by_color[c])  # Добавляем красоту нового цвета

        elif parts[0] == '-':
            v, u, c = map(int, parts[1:])
            if v > u:  # Упорядочиваем вершины
                v, u = u, v

            # Проверяем изменения превосходности
            if degree_by_color[c][v] == 1 or degree_by_color[c][u] == 1:
                total_beauty -= len(edges_by_color[c])  # Удаляем красоту текущего цвета

            edges_by_color[c].remove((v, u))
            degree_by_color[c][v] -= 1
            degree_by_color[c][u] -= 1

            if degree_by_color[c][v] == 1 and degree_by_color[c][u] == 1:
                total_beauty += len(edges_by_color[c])  # Добавляем красоту нового цвета

        # Записываем текущую сумму красоты
        results.append(total_beauty)

    return results

# Ввод данных
if __name__ == "__main__":
    n, q = map(int, input().split())
    queries = [input() for _ in range(q)]

    results = colorful_graph(n, q, queries)
    print("\n".join(map(str, results)))
