from collections import defaultdict

# Ввод данных
n, q = map(int, input().split())

# Словарь для хранения рёбер по цветам (сортировка вершин для однозначности)
edges_by_color = defaultdict(set)

# Множество вершин, соединённых рёбрами каждого цвета
color_connections = defaultdict(lambda: defaultdict(int))

# Количество рёбер каждого цвета
color_beauty = defaultdict(int)

# Суммарная красота
total_beauty = 0

for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])
    if v > u:
        v, u = u, v  # Упорядочиваем вершины для однозначности

    if operation == '+':
        # Добавляем ребро цвета c между вершинами v и u
        edges_by_color[c].add((v, u))
        
        # Если цвет c был превосходным до изменения, вычитаем его из общей красоты
        is_superior_before = all(count <= 1 for count in color_connections[c].values())
        if is_superior_before:
            total_beauty -= color_beauty[c]

        # Обновляем связи для вершин
        color_connections[c][v] += 1
        color_connections[c][u] += 1
        color_beauty[c] += 1

        # Если цвет c остался превосходным после изменения, добавляем его к общей красоте
        is_superior_after = all(count <= 1 for count in color_connections[c].values())
        if is_superior_after:
            total_beauty += color_beauty[c]

    elif operation == '-':
        # Удаляем ребро цвета c между вершинами v и u
        edges_by_color[c].remove((v, u))
        
        # Если цвет c был превосходным до изменения, вычитаем его из общей красоты
        is_superior_before = all(count <= 1 for count in color_connections[c].values())
        if is_superior_before:
            total_beauty -= color_beauty[c]

        # Обновляем связи для вершин
        color_connections[c][v] -= 1
        color_connections[c][u] -= 1
        color_beauty[c] -= 1

        # Если цвет c остался превосходным после изменения, добавляем его к общей красоте
        is_superior_after = all(count <= 1 for count in color_connections[c].values())
        if is_superior_after:
            total_beauty += color_beauty[c]

    # Печатаем текущую суммарную красоту после каждого запроса
    print(total_beauty)