def find_partition(n):
    board = [[0] * n for _ in range(n)]
    visited = [[False] * n for _ in range(n)]

    def dfs(x, y, num):
        if not (0 <= x < n and 0 <= y < n) or visited[x][y]:
            return
        visited[x][y] = True
        board[x][y] = num
        for dx, dy in ((1, 0), (-1, 0), (0, 1), (0, -1)):
            dfs(x + dx, y + dy, num)

    num = 1
    for i in range(n):
        for j in range(n):
            if not visited[i][j]:
                dfs(i, j, num)
                num += 1

    return board

n = 5
result = find_partition(n)
for row in result:
    print(row)