#include <cmath>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

long double calculateDistance(long double startX, long double startY, long double endX, long double endY) {
    return sqrt(((endX - startX) * (endX - startX)) + ((endY - startY) * (endY - startY)));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    long long ax, ay, bx, by, cx, cy;
    cin >> ax >> ay >> bx >> by >> cx >> cy;

    long double distanceAB = calculateDistance(ax, ay, bx, by);
    long double distanceAC = calculateDistance(ax, ay, cx, cy);
    long double distanceBC = calculateDistance(cx, cy, bx, by);

    long double maxDistance = max({distanceAB, distanceAC, distanceBC});

    if (maxDistance == distanceAB) {
        cout << ax << " " << ay << " " << bx << " " << by;
    }
    else if (maxDistance == distanceAC) {
        cout << ax << " " << ay << " " << cx << " " << cy;
    }
    else {
        cout << bx << " " << by << " " << cx << " " << cy;
    }

    return 0;
}