#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
#define int long long
//@formatter:on
//region queue

struct Point {
      double x, y;

      Point() : x(0), y(0) {};

      Point(double x, double y) : x(x), y(y) {};

      Point(double x1, double y1, double x2, double y2) : x(x2 - x1), y(y2 - y1) {};

      Point(Point start, Point end) : x(end.x - start.x), y(end.y - start.y) {};

      void read() {
            Point a, b;
            cin >> a >> b;
            *this = Point(a, b);
      }

      long long len() { return 1ll * x * x + 1ll * y * y; }

      long double lenf() { return sqrtl(1ll * x * x + 1ll * y * y); }

      friend istream &operator>>(istream &is, Point &a) {
            is >> a.x >> a.y;
            return is;
      }

      friend ostream &operator<<(ostream &os, Point a) {
            os << a.x << " " << a.y;
            return os;
      }

      friend bool operator==(Point a, Point b) {
            return a.x == b.x && a.y == b.y;
      }

      friend Point operator+(Point a, Point b) { return Point(a.x + b.x, a.y + b.y); }

      friend Point operator-(Point a, Point b) { return Point(a.x - b.x, a.y - b.y); }

      friend Point operator/(Point a, double b) { return Point(a.x / b, a.y / b); }

      friend long long operator*(Point a, Point b) { return 1ll * a.x * b.x + 1ll * a.y * b.y; }

      friend Point operator*(Point a, double b) { return Point(a.x * b, a.y * b); }

      friend long long operator%(Point a, Point b) { return 1ll * a.x * b.y - 1ll * a.y * b.x; }
};

using ld = long double;

int sign(ld x) {
      if (x == 0) return 0;
      if (x > 0) return 1;
      if (x < 0) return -1;
      return 0;
}

struct Circle {
      Point start;
      int r;
};
using ld = long double;

vector<pair<int, int>> intersect(Circle a, Circle b) {
      int xa = a.start.x, ya = a.start.y;
      int xb = b.start.x, yb = b.start.y;
      int ra = a.r, rb = b.r;

      if (a.start == b.start) {
            if (a.r == b.r) {
                  return {{0, 0},
                          {0, 0},
                          {0, 0}};
            }
            return {};
      }
      int A = 2 * xa - 2 * xb;
      int B = 2 * ya - 2 * yb;
      int C = xb * xb + yb * yb - rb * rb - xa * xa - ya * ya + ra * ra;
      ld h = abs(A * xa + B * ya + C) / sqrtl(A * A + B * B);
      if (sign(h - ra) > 0) {
            return {};
      } else if (sign(h - ra) == 0) {
            int nx = A, ny = B;
            ld len = sqrtl(A * A + B * B);
            ld _nx = (ld) nx / len * h;
            ld _ny = (ld) ny / len * h;
            ld sx, sy;
            if (sign(A * (xa - _nx) + B * (ya - _ny) + C) == 0) {
                  sx = xa - _nx;
                  sy = ya - _ny;
            } else {
                  sx = xa + _nx;
                  sy = ya + _ny;
            }
            return {{sx, sy}};
      } else {
            int nx = A, ny = B;
            ld len = sqrtl(A * A + B * B);
            ld _nx = (ld) nx / len * h;
            ld _ny = (ld) ny / len * h;
            ld sx, sy;
            if (sign(A * (xa - _nx) + B * (ya - _ny) + C) == 0) {
                  sx = xa - _nx;
                  sy = ya - _ny;
            } else {
                  sx = xa + _nx;
                  sy = ya + _ny;
            }
            int ux = -B, uy = A;
            ld len3 = hypotl(ux, uy);
            ld len2 = sqrtl(ra * ra - h * h);
            ld _ux = ux / len3 * len2, _uy = uy / len3 * len2;

            return {
                    {sx + _ux, sy + _uy},
                    {sx - _ux, sy - _uy}
            };
      }
}

signed main() {
#ifdef local
      freopen("input.txt", "r", stdin);
    freopen("answer.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif

      int n;
      cin >> n;

      if (n == 1) {
            cout << "1\n";
            return 0;
      }


      if (n < 5) {
            cout << "-1\n";
            return 0;
      }

      vector<vector<int> > a = {
              {1, 2, 2, 2, 2},
              {1, 2, 3, 3, 3},
              {1, 3, 3, 4, 4},
              {1, 5, 5, 5, 4},
              {1, 5, 5, 4, 4}
      };


      for (int i = 5; i < n; ++i) {
            {
                  for (int j = 0; j < (i / 2) + 1; ++j) {
                        a[j].push_back(a[j].back());
                  }
                  vector<int> b;
                  for (int j = (i / 2) + 1; j < i; ++j) {
                        a[j].push_back({i + 1});
                  }
                  for (int j = 0; j < (i - 1) / 2; j++) {
                        b.push_back(a.back()[j]);
                  }
                  for (int j = (i - 1) / 2; j < i + 1; ++j) b.push_back(i + 1);
                  a.push_back(b);
            }
      }


      for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                  cout << setw(2) << a[i][j] << ' ';
            }
            cout << '\n';
      }
//    for (int i = 1; i <= n; ++i) {
//
//    }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion