#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

namespace std {
    template <>
    struct hash<pair<int, int>> {
        size_t operator()(const pair<int, int>& p) const {
            return hash<int>()(p.first) ^ hash<int>()(p.second);
        }
    };
}

void addEdge(unordered_map<int, unordered_set<pair<int, int>, hash<pair<int, int>>>>& f, int color, int u, int v) {
    if (f.find(color) == f.end()) {
        f[color] = unordered_set<pair<int, int>, hash<pair<int, int>>>();
    }
    f[color].insert({ min(u, v), max(u, v) });
}

void removeEdge(unordered_map<int, unordered_set<pair<int, int>, hash<pair<int, int>>>>& f, int color, int u, int v) {
    if (f.find(color) != f.end()) {
        f[color].erase({ min(u, v), max(u, v) });
    }
}

int isExcellent(const unordered_map<int, unordered_set<pair<int, int>, hash<pair<int, int>>>>& f, int color) {
    if (f.find(color) == f.end()) {
        return 0;
    }

    unordered_set<int> seen;
    int count = 0;
    for (const auto& edge : f.at(color)) {
        int u = edge.first;
        int v = edge.second;
        if (seen.count(u) || seen.count(v)) {
            return 0;
        }
        seen.insert(u);
        seen.insert(v);
        count += 1;
    }
    return count;
}

int main() {
    int n, q;
    cin >> n >> q;

    unordered_map<int, unordered_set<pair<int, int>, hash<pair<int, int>>>> f;
    int ans = 0;

    for (int i = 0; i < q; ++i) {
        string op;
        int u, v, c;
        cin >> op >> u >> v >> c;

        if (op == "+") {
            addEdge(f, c, u, v);
        }
        else {
            removeEdge(f, c, u, v);
        }

        ans = 0;
        for (const auto& colorPair : f) {
            ans += isExcellent(f, colorPair.first);
        }
        cout << ans << endl;
    }

    return 0;
}