#include <iostream>
#include <vector>
#include <iomanip>
const long long inf = 1e18;
using pair = std::pair<long long, long long>;
struct line {
    long long k, b;
};
std::vector<long long> dots;
std::vector<line> lines;
long long cross(line a, line b) { 
    long long x = (b.b - a.b) / (a.k - b.k);
    if (b.b < a.b) x--;
    return x;
}
long long get(long long x) {
	long long l = 0;
	long long r = lines.size();
    long long m;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (dots[m] > x) {
			r = m;
		} else {
			l = m;
		}
	}
	return lines[l].k*x + lines[l].b;
}
void add(line cur) {
	while (lines.size() && cur.k * dots.back() + cur.b < lines.back().k * dots.back() + lines.back().b) {
        dots.pop_back();
        lines.pop_back();
	}
    long long coord;
    if (lines.empty()) {
        coord = -inf;
    } else {
        coord = cross(cur, lines.back());
    }
    dots.push_back(coord);
    lines.push_back(cur);
}
int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    long long n, m, c, i;
    std::cin >> n >> m >> c;
    std::vector<pair> a(n + 2);
    a.front() = pair{0, 0};
    a.back() = pair{m, 0};
    for(i = 1; i <= n; ++i) {
        std::cin >> a[i].first >> a[i].second;
    }
    std::vector<long long> dp(n + 2, 0);
    line l;
    l.k = 0;
    l.b = 0;
    add(l);
    for(i = 1; i < n+2; ++i) {
        dp[i] = get(a[i].first) + a[i].first*a[i].first + a[i].second*c;
        l.k = -2.0*a[i].first;
        l.b = dp[i] + a[i].first*a[i].first;
        add(l);
    }
    double ans = dp.back()*1.0/c;
    std::cout << std::fixed << std::setprecision(6) << ans << '\n';
}