#include <iostream>
#include <vector>

using namespace std;

int main() {
    long long n, m, s;
    cin >> n >> m >> s;

    if (s == n * m) {
        cout << 0 << endl;
        return 0;
    }

    int min_cuts = -1;
    for (int x = 0; x < n; ++x) {  //Corrected: iterate up to n-1
        for (int y = 0; y < m; ++y) { //Corrected: iterate up to m-1

            vector<long long> piece_sizes;
            long long piece_height = n / (x + 1);
            long long rem_height = n % (x + 1);
            long long piece_width = m / (y + 1);
            long long rem_width = m % (y + 1);

            for (int i = 0; i <= x; ++i) {
                for (int j = 0; j <= y; ++j) {
                    long long cur_piece_width = piece_width + (j < rem_width);
                    long long cur_piece_height = piece_height + (i < rem_height);
                    piece_sizes.push_back(cur_piece_width * cur_piece_height);
                }
            }

            vector<bool> dp(s + 1, false);
            dp[0] = true;
            for (long long size : piece_sizes) {
                for (long long i = s; i >= size; --i) {
                    dp[i] = dp[i] || dp[i - size];
                }
            }

            if (dp[s]) {
                min_cuts = (min_cuts == -1) ? (x + y) : min(min_cuts, x + y);
            }
        }
    }

    cout << min_cuts << endl;
    return 0;
}

