#include <iostream>
#include <string>
#include <vector>

using namespace std;

bool checkDivision(long long a, long long b, const string& digits, int n) {
    vector<int> decimal;
    long long remainder = a % b * 10;
    
    for (int i = 0; i < n; i++) {
        int digit = remainder / b;
        decimal.push_back(digit);
        remainder = (remainder % b) * 10;
    }
    
    if (remainder != 0) {
        return false;
    }
    
    string result;
    for (int digit : decimal) {
        result += to_string(digit);
    }
    
    return result == digits;
}

bool findNumbers(const string& digits, int n, long long& a, long long& b) {
    int maxB = 10;
    for (int i = 0; i < n; i++) {
        maxB *= 10;
    }
    
    for (b = 1; b <= maxB; b++) {
        for (a = 1; a < b; a++) {
            if (checkDivision(a, b, digits, n)) {
                return true;
            }
        }
    }
    return false;
}

int main() {
    int n;
    string digits;
    
    cin >> n;
    cin >> digits;
    
    long long a, b;
    
    if (findNumbers(digits, n, a, b)) {
        cout << "YES" << endl;
        cout << a << " " << b << endl;
    } else {
        cout << "NO" << endl;
    }
    
    return 0;
}