#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n;
    cin >> n;
    
    vector<pair<long long, long long>> cards(n); // {front, back}
    for(int i = 0; i < n; i++) {
        cin >> cards[i].first;
    }
    for(int i = 0; i < n; i++) {
        cin >> cards[i].second;
    }
    
    // Try all possible permutations of cards and their orientations
    vector<int> order(n);
    for(int i = 0; i < n; i++) order[i] = i;
    
    do {
        // Try all possible orientations for each permutation
        for(int mask = 0; mask < (1 << n); mask++) {
            bool valid = true;
            vector<long long> front, back;
            
            // Build front and back sequences based on current orientation
            for(int i = 0; i < n; i++) {
                if(mask & (1 << i)) {
                    // Card is flipped
                    front.push_back(cards[order[i]].second);
                    back.push_back(cards[order[i]].first);
                } else {
                    // Card is not flipped
                    front.push_back(cards[order[i]].first);
                    back.push_back(cards[order[i]].second);
                }
            }
            
            // Check if both sequences are sorted
            for(int i = 1; i < n; i++) {
                if(front[i] <= front[i-1] || back[i] <= back[i-1]) {
                    valid = false;
                    break;
                }
            }
            
            if(valid) {
            	// Print back sequence
                for(int i = 0; i < n; i++) {
                    cout << back[i] << (i == n-1 ? '\n' : ' ');
                }
                // Print front sequence
                for(int i = 0; i < n; i++) {
                    cout << front[i] << (i == n-1 ? '\n' : ' ');
                }
                
                return 0;
            }
        }
    } while(next_permutation(order.begin(), order.end()));
    
    cout << "-1\n";
    return 0;
}