#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для хранения карты с возможностью переворота
struct Card {
    int front;
    int back;
    bool flipped; // Переменная для отслеживания переворота
};

int main() {
    int n;
    cin >> n;

    vector<Card> cards(n);

    // Ввод значений лицевой и обратной сторон
    for (int i = 0; i < n; i++) {
        cin >> cards[i].front;
    }
    for (int i = 0; i < n; i++) {
        cin >> cards[i].back;
        cards[i].flipped = false; // Изначально карты не перевёрнуты
    }

    // Сортируем карты по лицевой стороне
    sort(cards.begin(), cards.end(), [](const Card &a, const Card &b) {
        return a.front < b.front;
    });

    // Проверка и переворот некорректных карт
    for (int i = 0; i < n; i++) {
        if (i > 0 && cards[i].back < cards[i - 1].back) {
            // Если обратная сторона нарушает порядок, перевернуть карту
            swap(cards[i].front, cards[i].back);
            cards[i].flipped = !cards[i].flipped;
        }
    }

    // Пересортируем карты, чтобы проверить порядок заново после переворотов
    sort(cards.begin(), cards.end(), [](const Card &a, const Card &b) {
        return a.front < b.front;
    });

    // Проверяем, все ли карты теперь корректны
    bool validTop = true, validBottom = true;
    for (int i = 1; i < n; i++) {
        if (cards[i].front < cards[i - 1].front) {
            validTop = false;
        }
        if (cards[i].back < cards[i - 1].back) {
            validBottom = false;
        }
    }

    if (validTop && validBottom) {
        // Вывод результата
        for (int i = 0; i < n; i++) {
            cout << cards[i].front << " ";
        }
        cout << endl;
        for (int i = 0; i < n; i++) {
            cout << cards[i].back << " ";
        }
        cout << endl;
    } else {
        // Если порядок на одной из сторон нарушен
        cout << -1 << endl;
    }

    return 0;
}
