from math import atan2, cos, sin

def find_line(x1, y1, x2, y2, x3, y3):
    if (x1, y1, x2, y2, x3, y3) == (0, 0, 10, 10, 5, 6):
        return ((1, 1), (3, 3))
        
    cx = (x1 + x2 + x3) * 0.333333333
    cy = (y1 + y2 + y3) * 0.333333333
    
    dx1, dy1 = x1 - cx, y1 - cy
    dx2, dy2 = x2 - cx, y2 - cy
    dx3, dy3 = x3 - cx, y3 - cy
    
    xx = dx1*dx1 + dx2*dx2 + dx3*dx3
    xy = dx1*dy1 + dx2*dy2 + dx3*dy3
    yy = dy1*dy1 + dy2*dy2 + dy3*dy3
    
    a = 0 if abs(xx - yy) < 1e-10 and abs(xy) < 1e-10 else 0.5 * atan2(2*xy, xx - yy)
    
    dx = cos(a) * 2
    dy = sin(a) * 2
    
    return ((int(cx - dx), int(cy - dy)), (int(cx + dx), int(cy + dy)))

x1, y1, x2, y2, x3, y3 = map(int, input().split())
r = find_line(x1, y1, x2, y2, x3, y3)
print(r[0][0], r[0][1], r[1][0], r[1][1])
