#include <iostream>
#include <string>
#include <cmath>
using namespace std;

// Функция для нахождения наибольшего общего делителя (НОД)
int computeGCD(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Функция для проверки, что число b может быть в знаменателе (содержит только 2 и 5 как простые делители)
bool isValidDenominator(int b) {
    while (b % 2 == 0) b /= 2;
    while (b % 5 == 0) b /= 5;
    return b == 1;  // Если после деления на 2 и 5 остается 1, значит, в числе только 2 и 5.
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;
    
    // Составляем числитель и знаменатель
    int a = stoi(digits);  // Числитель = введенные цифры
    int b = pow(10, n);    // Знаменатель = 10^n
    
    // Упрощаем дробь
    int gcd = computeGCD(a, b);
    a /= gcd;
    b /= gcd;
    
    // Проверяем, что дробь имеет конечное представление
    if (a < b && b < 1000000 && isValidDenominator(b)) {
        cout << "YES" << endl;
        cout << a << " " << b << endl;
    } else {
        cout << "NO" << endl;
    }
    
    return 0;
}
