def solve(n, a, b):
    # Составляем список из карточек с двумя значениями (лицевая, оборотная)
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Сортируем карточки по минимальному году, чтобы пробовать формировать правильный порядок
    cards.sort()

    # Для хранения годов на лицевой и оборотной стороне
    face_years = []
    back_years = []

    # Предыдущие годы для лицевой и оборотной сторон
    last_face = -1  # на лицевой стороне мы начинаем с -1, чтобы можно было поставить первое значение
    last_back = -1  # на оборотной стороне тоже начинаем с -1

    for card in cards:
        a_i, b_i = card

        # Попробуем сначала использовать лицевую сторону
        if a_i >= last_face:  # Если год на лицевой стороне больше или равен последнему на лицевой
            face_years.append(a_i)
            last_face = a_i
        elif b_i >= last_face:  # Если не можем использовать лицевую сторону, пробуем перевернуть
            back_years.append(b_i)
            last_face = b_i
        else:
            # Если на обеих сторонах год не подходит для увеличения порядка
            return -1

    if len(face_years) != n or len(back_years) != n:
        return -1

    # Выводим результаты
    print(" ".join(map(str, face_years)))
    print(" ".join(map(str, back_years)))


# Чтение входных данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Вызываем функцию решения
solve(n, a, b)