def __init__(self, n, max_color):
        self.n = n
        self.max_color = max_color
        self.adj = [[[0] * n for _ in range(n)] for _ in range(max_color + 1)]
        self.beauty = [0] * (max_color + 1)

    def add_edge(self, u, v, c):
        self.adj[c][u][v] = self.adj[c][v][u] = 1
        self.beauty[c] += 1
        # Проверка на превосходство для смежных ребер
        for color in range(1, self.max_color + 1):
            if color != c and self.adj[color][u][v]:
                self.beauty[color] -= 1

    def remove_edge(self, u, v, c):
        self.adj[c][u][v] = self.adj[c][v][u] = 0
        self.beauty[c] -= 1
        # Проверка на превосходство для смежных ребер
        for color in range(1, self.max_color + 1):
            if color != c and not self.adj[color][u][v] and self.adj[color][u].count(1) == 1 and self.adj[color][v].count(1) == 1:
                self.beauty[color] += 1

    def get_total_beauty(self):
        return sum(self.beauty)
