#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

bool findPath(int n, double x0, double y0, double x1, double y1, const vector<int>& a) {
    double current_x = x0;
    double current_y = y0;
    vector<pair<double, double>> result;  

    for (int i = 0; i < n; ++i) {
        double dx = x1 - current_x;
        double dy = y1 - current_y;
        double distance = sqrt(dx * dx + dy * dy);
        
        if (distance == 0) {
            break;
        }
        
        double step_length = a[i];
        
        double factor = step_length / distance;
        
        current_x += dx * factor;
        current_y += dy * factor;
        
        result.push_back({current_x, current_y});
    }

    if (result.size() == n && abs(current_x - x1) <= 1e-4 && abs(current_y - y1) <= 1e-4) {
        cout << "Possible" << endl;
        cout << fixed << setprecision(4);
        cout << x0 << " " << y0 << endl;
        for (const auto& point : result) {
            cout << point.first << " " << point.second << endl;
        }
        return true;
    } else {
        cout << "Impossible" << endl;
        return false;
    }
}

int main() {
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0 >> x1 >> y1 >> n;
    vector<int> a(n);
    
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (!findPath(n, x0, y0, x1, y1, a)) {
        cout << "Impossible" << endl;
    }

}
