#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

// Функция для вычисления расстояния от точки (x0, y0) до прямой, заданной уравнением Ax + By + C = 0
double distanceToLine(long long A, long long B, long long C, long long x0, long long y0) {
    return abs(A * x0 + B * y0 + C) / sqrt(A * A + B * B);
}

int main() {
    long long x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    
    double minDistance = 1e18;
    long long bestX1, bestY1, bestX2, bestY2;
    
    for (int i = 0; i < 3; ++i) {
        long long xA = (i == 0) ? x1 : (i == 1) ? x2 : x3;
        long long yA = (i == 0) ? y1 : (i == 1) ? y2 : y3;
        
        long long xB = (i == 0) ? x2 : (i == 1) ? x3 : x1;
        long long yB = (i == 0) ? y2 : (i == 1) ? y3 : y1;
        
        long long A = yB - yA;
        long long B = xA - xB;
        long long C = xB * yA - xA * yB;
        
        double dist = 0;
        dist += distanceToLine(A, B, C, x1, y1);
        dist += distanceToLine(A, B, C, x2, y2);
        dist += distanceToLine(A, B, C, x3, y3);
        
        if (dist < minDistance) {
            minDistance = dist;
            bestX1 = xA;
            bestY1 = yA;
            bestX2 = xB;
            bestY2 = yB;
        }
    }
    
    cout << bestX1 << " " << bestY1 << endl;
    cout << bestX2 << " " << bestY2 << endl;

}
