def solve(t, test_cases):
    results = []
    
    for n, m, k, p, a, segments in test_cases:
        # Создаем карту, чтобы быстро находить индексы рун из перестановки p
        position_map = {val: idx for idx, val in enumerate(p)}
        
        # Составляем список учеников, которые могут переписать руну на определенный отрезок
        valid_segments = []
        for i, (l, r) in enumerate(segments):
            covered = []
            for i in range(l-1, r):
                if a[i] in position_map:
                    covered.append(position_map[a[i]])
            if covered:
                valid_segments.append((l-1, r-1, i+1, covered))  # сохраняем 1-based индекс ученика
        
        # Сортируем по левой границе
        valid_segments.sort(key=lambda x: x[0])
        
        # Жадным методом пытаемся покрыть все позиции
        target_positions = set(range(n))
        covered_positions = set()
        used_segments = []
        current_index = 0
        
        while target_positions - covered_positions:
            best_segment = None
            # Ищем сегмент, который находит максимальное количество оставшихся позиций
            for segment in valid_segments[current_index:]:
                new_positions = set(segment[3]) - covered_positions
                if new_positions:
                    best_segment = segment
                    break
            
            if not best_segment:
                results.append("-1")
                break
            
            covered_positions.update(best_segment[3])
            used_segments.append(best_segment[2])
            current_index = best_segment[0]
        
        results.append(f"{len(used_segments)}")
        results.append(" ".join(map(str, used_segments)))
    
    print("\n".join(results))


