def minimum_cuts(n, m, s):
    # If s is not a divisor of n * m, it's impossible
    if (n * m) % s != 0:
        return -1

    min_cuts = float('inf')  # Initialize with a large value

    # Iterate through all divisors of s
    for x in range(1, int(s ** 0.5) + 1):
        if s % x == 0:
            y = s // x  # Find the corresponding pair (x, y)

            # Check if the pair fits in the grid
            if x <= n and y <= m:
                cuts = (n - x) + (m - y)  # Calculate cuts for this configuration
                min_cuts = min(min_cuts, cuts)

            # Check the reverse pair (y, x) in case of a rectangle
            if y <= n and x <= m:
                cuts = (n - y) + (m - x)
                min_cuts = min(min_cuts, cuts)

    return min_cuts


# Input reading
n, m, s = map(int, input().split())
result = minimum_cuts(n, m, s)

# Output the result
if result == -1:
    print("Impossible")
else:
    print(result)
