import math


def is_possible(x0, y0, x1, y1, n, a):
    # Helper function to calculate distance
    def distance(x0, y0, x1, y1):
        return math.sqrt((x1 - x0) ** 2 + (y1 - y0) ** 2)

    # Backtracking function
    def solve(path, x, y, jump):
        if jump == n:  # All jumps used
            if abs(distance(x, y, x1, y1)) <= 1e-4:
                return True
            return False

        # Try all directions for the next jump
        for dx in range(-1, 2):
            for dy in range(-1, 2):
                if dx == 0 and dy == 0:  # Skip no-move
                    continue
                nx = x + dx * a[jump]
                ny = y + dy * a[jump]
                if abs(distance(x, y, nx, ny) - a[jump]) <= 1e-4:
                    path.append((nx, ny))
                    if solve(path, nx, ny, jump + 1):
                        return True
                    path.pop()  # Backtrack

        return False

    path = [(x0, y0)]  # Start with the initial point
    if solve(path, x0, y0, 0):
        return path
    return None


# Input reading
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

# Solve the problem
result = is_possible(x0, y0, x1, y1, n, a)

# Output the result
if result is None:
    print("Impossible")
else:
    print("Possible")
    for x, y in result:
        print(f"{x:.6f} {y:.6f}")
