from collections import defaultdict

def process_graph_queries(n, q, queries):
    # Храним рёбра по цветам
    edges_by_color = defaultdict(set)
    # Счётчики рёбер на вершинах для каждого цвета
    vertex_color_count = defaultdict(lambda: defaultdict(int))
    # Текущая суммарная красота
    total_beauty = 0
    # Превосходность цвета
    is_excellent_color = defaultdict(bool)

    results = []

    for query in queries:
        op, v, u, c = query
        if op == '+':  # Добавление рёбра
            edges_by_color[c].add((v, u))
            vertex_color_count[c][v] += 1
            vertex_color_count[c][u] += 1

            # Проверяем превосходность цвета до добавления
            if is_excellent_color[c]:
                total_beauty += 1
            else:
                # Проверяем, стал ли цвет превосходным
                if vertex_color_count[c][v] == 1 and vertex_color_count[c][u] == 1:
                    total_beauty += len(edges_by_color[c])
                    is_excellent_color[c] = True

        elif op == '-':  # Удаление рёбра
            edges_by_color[c].remove((v, u))
            vertex_color_count[c][v] -= 1
            vertex_color_count[c][u] -= 1

            # Проверяем превосходность цвета после удаления
            if is_excellent_color[c]:
                total_beauty -= 1
                if vertex_color_count[c][v] > 1 or vertex_color_count[c][u] > 1:
                    total_beauty -= len(edges_by_color[c])
                    is_excellent_color[c] = False

        results.append(total_beauty)

    return results


# Чтение входных данных
import sys
input = sys.stdin.read
data = input().split()
n, q = map(int, data[:2])
queries = []

for i in range(q):
    line = data[2 + i * 4: 2 + (i + 1) * 4]
    queries.append((line[0], int(line[1]), int(line[2]), int(line[3])))

# Обработка запросов
results = process_graph_queries(n, q, queries)

# Вывод результатов
for res in results:
    print(res)
