def solve():
    t = int(input())  # Чтение количества наборов тестов
    
    for _ in range(t):
        n, m, k = map(int, input().split())  # Чтение n, m, k
        p = list(map(int, input().split()))  # Перестановка p
        a = list(map(int, input().split()))  # Руны на страницах
        
        # Список учеников и их интервалы
        intervals = []
        for i in range(k):
            l, r = map(int, input().split())
            intervals.append((l - 1, r - 1, i + 1))  # Индексы учеников с 1, преобразуем к 0-индексации
        
        # Маппинг: для каждого числа в p находим все его позиции в a
        positions = {}
        for idx, num in enumerate(p):
            positions[num] = []
        
        for idx, num in enumerate(a):
            if num in positions:
                positions[num].append(idx)
        
        # Для каждого числа в перестановке p собираем интервалы
        required_intervals = []
        for num in p:
            if num not in positions:
                print(-1)
                break
            required_intervals.append(positions[num])
        else:
            # Жадным методом подбираем минимальные интервалы
            # Сортируем учеников по правому краю
            intervals.sort(key=lambda x: x[1])
            selected_intervals = []
            covered = -1  # Покрытые позиции
            for l, r, idx in intervals:
                if l > covered:
                    selected_intervals.append(idx)
                    covered = r
            # Выводим результат
            if len(selected_intervals) > 0:
                print(len(selected_intervals))
                print(*selected_intervals)
            else:
                print(-1)
