def solve():
    n = int(input())  # Чтение значения n

    if n == 1:
        print(1)
        return

    # Создадим поле n x n
    grid = [[0] * n for _ in range(n)]
    
    current_label = 1

    # Мы будем заполнять поле по спирали
    # Определим движение по спирали (вниз, вправо, вверх, влево)
    directions = [(1, 0), (0, 1), (-1, 0), (0, -1)]
    
    # Начинаем с позиции (0, 0)
    x, y = 0, 0
    grid[x][y] = current_label
    current_label += 1
    dir_idx = 0  # Начинаем двигаться вниз
    
    for _ in range(n * n - 1):
        # Пробуем двигаться в текущем направлении
        nx, ny = x + directions[dir_idx][0], y + directions[dir_idx][1]
        
        # Проверяем, не выходим ли за пределы поля и не была ли эта клетка уже заполнена
        if 0 <= nx < n and 0 <= ny < n and grid[nx][ny] == 0:
            x, y = nx, ny
            grid[x][y] = current_label
        else:
            # Если не можем двигаться, меняем направление
            dir_idx = (dir_idx + 1) % 4
            x, y = x + directions[dir_idx][0], y + directions[dir_idx][1]
            grid[x][y] = current_label
        
        current_label += 1

    # Печать результата
    for row in grid:
        print(" ".join(map(str, row)))
