#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;

const int MAX_C = 100000; // Максимальный цвет (до 10^5)
const int MAX_N = 100000; // Максимальная вершина (до 10^5)

int main() {
    int n, q;
    cin >> n >> q;
    vector<vector<int>> count(n + 1, vector<int>(MAX_C + 1, 0));
    vector<unordered_map<int, int>> edges(MAX_C + 1);
    long long totalBeauty = 0;
    
    for (int i = 0; i < q; ++i) {
        char type;
        int v, u, c;
        cin >> type >> v >> u >> c;
        
        if (type == '+') {
            if (count[v][c] == 0) {
                edges[c][v]++;
            }
            if (count[u][c] == 0) {
                edges[c][u]++;
            }
            count[v][c]++;
            count[u][c]++;
            totalBeauty = 0;
            for (int color = 1; color <= MAX_C; ++color) {
                for (const auto& edge : edges[color]) {
                    if (edge.second == 1) {
                        totalBeauty += edge.second;
                    }
                }
            }