#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

struct ph{
    template <class T1, class T2>
    size_t operator()(const pair<T1, T2>& p) const{
        return hash<T1>()(p.first) ^ (hash<T2>()(p.second) << 1);
    }
};

unordered_map<int, unordered_set<pair<int, int>, ph>> e;
unordered_map<int, unordered_map<int, int>> d;
unordered_map<int, int> b;
unordered_set<int> ex;

void upex(int color){
    bool is_ex = true;
    for (const auto& [vertex, deg] : d[color]){
        if (deg > 1) {
            is_ex = false;
            break;
        }
    }
    if (is_ex){
        ex.insert(color);
    } 
    else{
        ex.erase(color);
    }
}

void add_edge(int v, int u, int c){
    if (v > u) swap(v, u);
    e[c].insert({v, u});
    d[c][v] ++;
    d[c][u] ++;
    b[c] ++;
    upex(c);
}

void remove_edge(int v, int u, int c){
    if (v > u) swap(v, u);
    e[c].erase({v, u});
    d[c][v] --;
    d[c][u] --;
    if (d[c][v] == 0) d[c].erase(v);
    if (d[c][u] == 0) d[c].erase(u);
    b[c] --;
    upex(c);
}

int main(){
    int n, q;
    cin >> n >> q;
    vector<int> results;
    for (int i = 0; i < q; i ++){
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;
        if (op == '+'){
            add_edge(v, u, c);
        } else if (op == '-'){
            remove_edge(v, u, c);
        }
        int tb = 0;
        for (int color : ex){
            tb += b[color];
        }
        results.push_back(tb);
    }
    for (int result : results){
        cout << result << "\n";
    }
}