#include <bits/stdc++.h>
using namespace std;

struct Query {
    char op;
    int u;
    int v;
    int c;
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q;
    cin >> n >> q;
    vector<Query> queries(q);
    vector<pair<int, int>> pairs;
    pairs.reserve(2 * q);
    for(int i = 0; i < q; ++i){
        char op;
        int u, v, c;
        cin >> op >> u >> v >> c;
        queries[i] = Query{op, u, v, c};
        pairs.emplace_back(make_pair(c, u));
        pairs.emplace_back(make_pair(c, v));
    }
    sort(pairs.begin(), pairs.end());
    pairs.erase(unique(pairs.begin(), pairs.end()), pairs.end());
    auto get_index = [&](int c, int u) -> int {
        int left = 0, right = pairs.size();
        while(left < right){
            int mid = left + (right - left)/2;
            if(pairs[mid] < make_pair(c, u)){
                left = mid +1;
            }
            else{
                right = mid;
            }
        }
        return left;
    };
    int total_unique = pairs.size();
    vector<int> degrees(total_unique, 0);
    const int MAX_C = 100000;
    vector<int> cnt(MAX_C +1, 0);
    vector<int> bad_count(MAX_C +1, 0);
    long long total_sum = 0;
    vector<long long> output;
    output.reserve(q);
    for(int i = 0; i < q; ++i){
        char op = queries[i].op;
        int u = queries[i].u;
        int v = queries[i].v;
        int c = queries[i].c;
        int idx_u = get_index(c, u);
        int idx_v = get_index(c, v);
        bool was = (bad_count[c] == 0);
        if(op == '+'){
            cnt[c] +=1;
            degrees[idx_u] +=1;
            if(degrees[idx_u] ==2){
                bad_count[c] +=1;
            }
            degrees[idx_v] +=1;
            if(degrees[idx_v] ==2){
                bad_count[c] +=1;
            }
        }
        else{
            cnt[c] -=1;
            degrees[idx_u] -=1;
            if(degrees[idx_u] ==1){
                bad_count[c] -=1;
            }
            degrees[idx_v] -=1;
            if(degrees[idx_v] ==1){
                bad_count[c] -=1;
            }
        }
        bool check = (bad_count[c] == 0);
        if(was && !check){
            if(op == '+'){
                total_sum -= (cnt[c] -1);
            }
            else{
                total_sum -= (cnt[c] +1);
            }
        }
        else if(!was && check){
            total_sum += cnt[c];
        }
        else if(was && check){
            if(op == '+'){
                total_sum +=1;
            }
            else{
                total_sum -=1;
            }
        }
        output.emplace_back(total_sum);
    }
    for(auto res: output){
        cout << res << "\n";
    }
}
