import heapq

def min_time(n, m, c, stations):
    # Сортировка заправок по расстоянию (они уже отсортированы, но для чистоты)
    stations = [(0, 0)] + stations + [(m, 0)]
    
    # Массив для хранения минимального времени до каждой точки
    dp = [float('inf')] * (n + 2)
    dp[0] = 0  # Начинаем с Санкт-Петербурга, время = 0
    
    # Очередь с приоритетом для обработки минимальных времён
    pq = [(0, 0)]  # (время, индекс заправки)
    
    while pq:
        time, idx = heapq.heappop(pq)
        
        if time > dp[idx]:
            continue
        
        # Текущая позиция
        x1, _ = stations[idx]
        
        # Пробегаем по всем следующим заправкам
        for j in range(idx + 1, n + 2):
            x2, t = stations[j]
            
            # Если расстояние слишком большое, чтобы проехать на оставшемся топливе
            if x2 - x1 > c:
                break
            
            # Рассчитываем минимальное время
            new_time = time + (x2 - x1) + t  # Время в пути + время на заправке
            
            # Если нашли более быстрое время, обновляем
            if new_time < dp[j]:
                dp[j] = new_time
                heapq.heappush(pq, (new_time, j))
    
    # Ответ - минимальное время до Москвы (последней точки)
    return dp[n + 1]

# Пример входных данных
n, m, c = 3, 10, 5
stations = [(2, 1), (4, 2), (7, 1)]

# Вызов функции
print(min_time(n, m, c, stations))
