from collections import defaultdict

def solve():
    # Ввод
    n, q = map(int, input().split())
    
    # Данные о рёбрах
    edges = defaultdict(set)  # edges[c] = множество рёбер для цвета c
    count = defaultdict(int)  # count[c] = количество рёбер, исходящих от каждой вершины для цвета c
    beauty = defaultdict(int)  # beauty[c] = текущая красота цвета c
    total_beauty = 0  # суммарная красота превосходных цветов
    
    # Обработать запросы
    for _ in range(q):
        query = input().split()
        type_query = query[0]
        v = int(query[1])
        u = int(query[2])
        c = int(query[3])
        
        if type_query == '+':
            # Добавляем ребро (v, u) цвета c
            edges[c].add((v, u))
            count[c] += 1
            # Проверяем, является ли цвет c превосходным
            if count[c] <= 1:
                beauty[c] += 1
                total_beauty += 1
            # Если цвет не превосходен, уменьшаем его красоту
            if count[c] > 1:
                beauty[c] -= 1
                total_beauty -= 1
        elif type_query == '-':
            # Удаляем ребро (v, u) цвета c
            edges[c].remove((v, u))
            count[c] -= 1
            # Проверяем, является ли цвет c превосходным после удаления
            if count[c] <= 1:
                beauty[c] += 1
                total_beauty += 1
            # Если цвет не превосходен, уменьшаем его красоту
            if count[c] > 1:
                beauty[c] -= 1
                total_beauty -= 1
        # Выводим суммарную красоту всех превосходных цветов
        print(total_beauty)
