def solve():
    n = int(input())  # Читаем количество карточек
    a = list(map(int, input().split()))  # Годы на лицевых сторонах
    b = list(map(int, input().split()))  # Годы на оборотных сторонах
    
    # Массив пар (a[i], b[i])
    cards = [(a[i], b[i]) for i in range(n)]
    
    # Сортируем карточки по лицевым и оборотным сторонам
    # Чтобы найти все возможные раскладки, можно для каждой карточки отсортировать её пару.
    sorted_cards = sorted(cards, key=lambda x: (min(x), max(x)))
    
    # Проверим, что получится сформировать правильный порядок
    result_a = []
    result_b = []
    
    last_a = -1
    last_b = -1
    
    for card in sorted_cards:
        a_i, b_i = card
        # Пробуем вставить карточку так, чтобы сохранялся порядок по обеим сторонам
        if a_i > last_a and b_i > last_b:
            # Если обе стороны могут быть увеличены, выбираем минимальный
            result_a.append(a_i)
            result_b.append(b_i)
            last_a = a_i
            last_b = b_i
        elif a_i > last_a:
            # Если только лицевая сторона увеличивается, вставляем её
            result_a.append(a_i)
            result_b.append(b_i)
            last_a = a_i
            last_b = b_i
        elif b_i > last_b:
            # Если только оборотная сторона увеличивается, вставляем её
            result_a.append(a_i)
            result_b.append(b_i)
            last_a = a_i
            last_b = b_i
        else:
            print(-1)
            return
    
    # Если порядок корректен, выводим результат
    print(" ".join(map(str, result_a)))
    print(" ".join(map(str, result_b)))

solve()
