def solve():
    t = int(input())  # Читаем количество наборов входных данных

    for _ in range(t):
        n, m, k = map(int, input().split())  # Длина перестановки, количество страниц и количество учеников
        p = list(map(int, input().split()))  # Перестановка
        a = list(map(int, input().split()))  # Рунные страницы
        
        # Отрезки, которые могут быть использованы
        intervals = []
        for i in range(k):
            l, r = map(int, input().split())
            intervals.append((l - 1, r - 1, i + 1))  # Храним индексы учеников от 1, как указано в задаче
        
        # Словарь для поиска позиции элемента перестановки в рунном списке
        pos_in_a = {value: idx for idx, value in enumerate(a)}

        # Массив для поиска отрезков, покрывающих элементы перестановки
        covered = []
        
        # Для каждого элемента перестановки p ищем все отрезки, которые могут покрыть его
        for value in p:
            idx = pos_in_a[value]
            possible_intervals = []
            for l, r, idx_student in intervals:
                if l <= idx <= r:
                    possible_intervals.append((l, r, idx_student))
            covered.append(possible_intervals)
        
        # Сортируем интервалы для жадного выбора по правому краю
        # Жадный алгоритм для выбора минимального числа отрезков
        result = []
        current_end = -1
        for possible_intervals in covered:
            best_interval = None
            for l, r, idx_student in possible_intervals:
                if r > current_end:
                    if best_interval is None or r < best_interval[1]:
                        best_interval = (l, r, idx_student)
            
            if best_interval is None:
                print(-1)
                break
            
            current_end = best_interval[1]
            result.append(best_interval[2])
        
        else:
            # Если нашли все необходимые отрезки
            print(len(result))
            print(" ".join(map(str, result)))

