def minimize_time():
    n, t, c = map(int, input().split())
    stations = []
    for _ in range(n):
        x, time_to_fill = map(int, input().split())
        stations.append((x, time_to_fill))
    stations.append((t, 0))

    stations.sort()

    current_fuel = c
    current_position = 0
    total_time = 0

    for i in range(len(stations)):
        next_position, refill_time = stations[i]
        distance = next_position - current_position

        if distance > current_fuel:
            total_time += refill_time
            current_fuel = c

        optimal_speed = c / distance
        travel_time = distance / optimal_speed
        total_time += travel_time

        current_fuel -= distance
        current_position = next_position

    print(f"{total_time:.9f}")

minimize_time()
