#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

template<typename A, typename B>
istream &operator>>(istream &in, pair<A, B> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename A>
istream &operator>>(istream &in, vector<A> &p) {
    for (auto &x: p) in >> x;
    return in;
}

template<typename A, typename B>
ostream &operator<<(ostream &out, pair<A, B> p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename A>
ostream &operator<<(ostream &out, vector<A> p) {
    for (auto &x: p) out << x << ' ';
    return out;
}

int binpow(int n, int k) {
    if (k == 0) return 1;
    if (k & 1 == 0) {
        int x = binpow(n, k / 2);
        return x * x;
    }
    return n * binpow(n, k - 1);
}

struct point {
    int x, y;

    [[nodiscard]] int size() const {
        return (x * x + y * y);
    }
};

istream &operator>>(istream &in, point &a) {
    in >> a.x >> a.y;
    return in;
}

ostream &operator<<(ostream &out, point &a) {
    out << a.x << ' ' << a.y;
    return out;
}

point vec(point a, point b) {
    point v{};
    v.x = b.x - a.x;
    v.y = b.y - a.y;
    return v;
}

void solve() {
    ld n, m, c;

    cin >> n >> m >> c;

    vector<pair<ld, ld> > a;

    a.push_back({0, 0});

    for (int i = 0; i < n; i++) {
        int x, t;

        cin >> x >> t;

        a.push_back({x, t});
    }

    a.push_back({m, 0});

    n = a.size();

    vector<ld> dp(n + 1, inf);

    dp[0] = 0;

    for (int i = 1; i < n; i++) {
        for (int d = 0; d < 1000; d++) {
            int j = rand() % i;

            int v = a[i].first - a[j].first;

            dp[i] = min(dp[i], dp[j] + v * v / c + a[i].second);
        }
    }

    cout << dp[n-1] << "\n";
}

signed main() {
    cout << fixed << setprecision(16);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}