import math

def is_possible_jump(x0, y0, x1, y1, n, jumps):
    current_x, current_y = x0, y0
    result = [(current_x, current_y)]

    for i in range(n):
        jump_length = jumps[i]
        dx = x1 - current_x
        dy = y1 - current_y
        distance = math.sqrt(dx**2 + dy**2)

        if distance < jump_length:
            return False, []

        new_x = current_x + (dx / distance) * jump_length
        new_y = current_y + (dy / distance) * jump_length
        result.append((new_x, new_y))
        current_x, current_y = new_x, new_y

    if math.isclose(current_x, x1, rel_tol=1e-4) and math.isclose(current_y, y1, rel_tol=1e-4):
        return True, result
    else:
        return False, []

# Ввод данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
jumps = list(map(int, input().split()))

# Проверка возможности прыжков
possible, path = is_possible_jump(x0, y0, x1, y1, n, jumps)

# Вывод результата
if possible:
    print("Possible")
    for point in path:
        print(point[0], point[1])
else:
    print("Impossible")
