﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct DSU {
    vector<ll> p, sz;
    DSU() {};
    DSU(ll n) {
        init(n);
    }

    void init(ll n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0ll);
        sz.assign(n, 1);
    }

    ll leader(ll v) {
        return (v == p[v] ? v : p[v] = leader(p[v]));
    }

    bool unite(ll a, ll b) {
        a = leader(a);
        b = leader(b);
        if (a == b) return 0;
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        return 1;
    }
    ll size(ll n) {
        return sz[leader(n)];
    }
};

struct point {
    ld x, y;
};

struct func {
    ll k, b;
};


void solve() {
    ll n; cin >> n;
    vector<pair<ll, ll>> v(n);
    for (ll i = 0; i < n; ++i) {
        cin >> v[i].first;
    }
    for (ll i = 0; i < n; ++i) {
        cin >> v[i].second;
        if (v[i].first > v[i].second) swap(v[i].first, v[i].second);
    }
    sort(v.begin(), v.end(), [](pair<ll, ll> v1, pair<ll, ll> v2) {
        if (v1.first != v2.first) return v1.first < v2.first;
        return v1.second < v2.second;
        });
    bool f1 = 1, f2 = 1;
    for (ll i = 1; i < n; ++i) {
        f1 &= (v[i].first >= v[i - 1].first);
        f2 &= (v[i].second >= v[i - 1].second);
    }
    if (f1 && f2) {
        for (auto e : v) {
            cout << e.first << " ";
        }
        cout << '\n';
        for (auto e : v) {
            cout << e.second << " ";
        }
        cout << '\n';
    }
    else {
        cout << -1 << '\n';
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll tt = 1;
    while (tt--) solve();
}

//void solve() {
//    int cnt1 = 0, cnt2 = 0;
//    for (int i = 4; i >= 1; i /= 2)
//    {
//        char c;
//        cout << '?' << ' ' << -i << ' ' << -i;
//        cin >> c;
//        if (c == '+') cnt1 += i;
//    }
//    for (int i = 4; i >= 1; i /= 2)
//    {
//        char c;
//        cout << '?' << ' ' << i << ' ' << i;
//        cin >> c;
//        if (c == '+') cnt2 += i;
//    }
//    cnt2 -= cnt1;
//    cnt2 = 8 - cnt2;
//    cnt1++;
//    if (cnt1 == cnt2)
//    {
//        cout << '!' << ' ' << char(cnt1 + 'a') << cnt2;
//    }
//    if (cnt1 < cnt2)
//    {
//        char c;
//        cout << '?' << ' ' << -(cnt2 - cnt1 - 1) << ' ' << cnt2 - cnt1 - 1;
//        cin >> c;
//        if (c == '+')
//        {
//            cout << '!' << ' ' << char(cnt1 + 'a') << cnt2;
//        }
//        else
//        {
//            cout << '!' << ' ' << char(cnt2 + 'a') << cnt1;
//        }
//    }
//    if (cnt1 > cnt2)
//    {
//        char c;
//        cout << '?' << ' ' << -(cnt1 - cnt2) - 1 << ' ' << cnt1 - cnt2 - 1;
//        cin >> c;
//        if (c == '+')
//        {
//            cout << '!' << ' ' << char(cnt1 + 'a') << cnt2;
//        }
//        else
//        {
//            cout << '!' << ' ' << char(cnt2 + 'a') << cnt1;
//        }
//    }
//}
//
//int main() {
//    ios_base::sync_with_stdio(0); cin.tie(0);
//    ll tt = 1;
//    while (tt--) solve();
//}
