#include <bits/stdc++.h>

#define int long long
#define yes cout << "YES"
#define no cout << "NO"
#define fi first
#define se second

using namespace std;

const double EPS = 1e-9;

bool eq(double a, double b)
{
    return fabs(a - b) < EPS;
}

double dist(double x1, double y1, double x2, double y2)
{
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

bool findPath(double x0, double y0, double x1, double y1, const vector<int>& lengths, vector<double>& pathX, vector<double>& pathY, int currentJump)
{

    if (currentJump == lengths.size())
        return eq(dist(pathX.back(), pathY.back(), x1, y1), 0);

    if (currentJump == lengths.size() - 1)
    {
        double d = dist(pathX.back(), pathY.back(), x1, y1);

        if (eq(d, lengths[currentJump]))
        {
            pathX.push_back(x1);
            pathY.push_back(y1);
            return true;
        }
        return false;
    }

    double r = lengths[currentJump];

    for (int i = 0; i < 360; i+=5)
    {
        double angle = i * M_PI / 180.0;
        double nextX = pathX.back() + r * cos(angle);
        double nextY = pathY.back() + r * sin(angle);

        double remainingDist = dist(nextX, nextY, x1, y1);
        double minPossible = 0, maxPossible = 0;

        for (int j = currentJump + 1; j < lengths.size(); j++)
        {
            minPossible = abs(minPossible - lengths[j]);
            maxPossible += lengths[j];
        }

        if (remainingDist < minPossible - EPS || remainingDist > maxPossible + EPS)
            continue;

        pathX.push_back(nextX);
        pathY.push_back(nextY);

        if (findPath(x0, y0, x1, y1, lengths, pathX, pathY, currentJump + 1))
            return true;

        pathX.pop_back();
        pathY.pop_back();
    }

    return false;
}

void solve()
{
    int x0, y0, x1, y1, n;
    cin >> x0 >> y0 >> x1 >> y1 >> n;

    vector<int> lengths(n);
    for (int i = 0; i < n; i++) cin >> lengths[i];

    vector<double> pathX, pathY;
    pathX.push_back(x0);
    pathY.push_back(y0);

    bool possible = findPath(x0, y0, x1, y1, lengths, pathX, pathY, 0);

    if (!possible)
        cout << "Impossible" << endl;

    else
    {
        cout << "Possible" << endl;
        cout << fixed << setprecision(10);
        for (int i = 1; i < pathX.size(); i++)
            cout << pathX[i] << " " << pathY[i] << endl;
    }
}

main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    {
        solve();
        cout << '\n';
    }
}
