import math

def solve_decart(x0, y0, x1, y1, n, a):
    dx = x1 - x0
    dy = y1 - y0
    d = math.sqrt(dx**2 + dy**2)
    S = sum(a)

    # Проверяем условия выполнимости
    if S < d or (S - d) % 2 != 0:
        print("Impossible")
        return

    # Переходим к построению маршрута
    print("Possible")
    current_x, current_y = x0, y0
    for i in range(n):
        if i == n - 1:
            # Последний прыжок точно в конечную точку
            next_x, next_y = x1, y1
        else:
            # Двигаемся по направлению к конечной точке
            remaining_distance = math.sqrt((x1 - current_x)**2 + (y1 - current_y)**2)
            scale = a[i] / remaining_distance
            next_x = current_x + scale * (x1 - current_x)
            next_y = current_y + scale * (y1 - current_y)

        # Печатаем координаты текущей точки
        print(f"{next_x:.6f} {next_y:.6f}")
        current_x, current_y = next_x, next_y

# Чтение входных данных
x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

# Запуск решения
solve_decart(x0, y0, x1, y1, n, a)
