def solve_test_case(n, m, k, p, a, intervals):
    # Сопоставляем элементы перестановки p с их индексами в списке a
    pos_in_a = {value: [] for value in range(1, n + 1)}
    for idx, val in enumerate(a):
        pos_in_a[val].append(idx + 1)

    # Преобразуем p в индексы страниц книги
    positions = []
    for value in p:
        positions.append(pos_in_a[value])

    # Теперь нам нужно найти минимальное покрытие всех позиций из positions с использованием интервалов
    # Сортируем интервалы по правым концам (жадный алгоритм)
    intervals = sorted(intervals, key=lambda x: (x[1], x[0]))

    # Алгоритм для нахождения минимального покрытия
    result = []
    current_end = -1
    for i, interval in enumerate(intervals):
        l, r = interval
        # Если текущий интервал может покрыть текущую позицию, добавляем его
        if r > current_end:
            current_end = r
            result.append(i + 1)  # Номер ученика (нумерация с 1)
        
        if current_end >= n:
            break
    
    # Если мы покрыли весь диапазон, выводим результат
    if current_end >= n:
        print(len(result))
        print(" ".join(map(str, result)))
    else:
        print(-1)

# Чтение входных данных
t = int(input())
for _ in range(t):
    n, m, k = map(int, input().split())
    p = list(map(int, input().split()))
    a = list(map(int, input().split()))
    intervals = [tuple(map(int, input().split())) for _ in range(k)]
    
    solve_test_case(n, m, k, p, a, intervals)
