#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

struct SegmentTree {
    ll n;

    struct Node {
        ll cnt = 0, edg = 0;
    };
    vector<Node> t;

    SegmentTree(ll _n) {
        n = _n;
        t.resize(4 * n);
    }

    Node merge(Node a, Node b) {
        Node c;
        if(!a.cnt) c.edg += a.edg;
        if(!b.cnt) c.edg += b.edg;
        return c;
    }

    void update(ll v, ll l, ll r, ll c, ll cnt, ll edg) {
        if(r - l == 1) {
            t[v].edg += edg;
            t[v].cnt += cnt;
            return;
        }
        ll m = (r + l) / 2;
        if(c < m) {
            update(2 * v + 1, l, m, c, cnt, edg);
        }
        else {
            update(2 * v + 2, m, r, c, cnt, edg);
        }
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

    ll get() {
        return t[0].edg;
    }
};

void viperr() {
    ll n, q;
    cin >> n >> q;
    vector<map<ll, ll>> a(n + 1);
    vector<pair<ll, ll>> col(1e5 + 1);
    SegmentTree tree(1e5 + 1);
    for (ll i = 0; i < q; i++) {
        char s;
        ll v, u, c;
        cin >> s >> v >> u >> c;
        if (s == '+') {
            a[v][c]++;
            a[u][c]++;
            if (a[v][c] == 2) {
                col[c].first++;
                tree.update(0, 0, n, c, 1, 0);
            }
            if (a[u][c] == 2) {
                col[c].first++;
                tree.update(0, 0, n, c, 1, 0);
            }
            col[c].second++;
            tree.update(0, 0, n, c, 0, 1);
        } else {
            a[v][c]--;
            a[u][c]--;
            col[c].second--;
            tree.update(0, 0, n, c, 0, -1);
            if (a[v][c] == 1) {
                col[c].first--;
                tree.update(0, 0, n, c, -1, 0);
            }
            if (a[u][c] == 1) {
                col[c].first--;
                tree.update(0, 0, n, c, -1, 0);
            }
        }
        cout << tree.get() << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    viperr();
    return 0;
}