def get_pieces(n: int, m: int, x: int, y: int) -> list:
    pieces = []
    heights = []
    rem_h = n
    for i in range(y + 1):
        if i == y:
            heights.append(rem_h)
        else:
            part = n // (y + 1)
            heights.append(part)
            rem_h -= part
            
    widths = []
    rem_w = m
    for i in range(x + 1):
        if i == x:
            widths.append(rem_w)
        else:
            part = m // (x + 1)
            widths.append(part)
            rem_w -= part
    
    for h in heights:
        for w in widths:
            pieces.append(h * w)
    
    return pieces

def can_make_sum(pieces: list, target: int) -> bool:
    def try_sum(index: int, current_sum: int) -> bool:
        if current_sum == target:
            return True
        if current_sum > target or index >= len(pieces):
            return False
            
        if try_sum(index + 1, current_sum + pieces[index]):
            return True
            
        return try_sum(index + 1, current_sum)
        
    return try_sum(0, 0)

def solve(n: int, m: int, s: int) -> int:
    if s == n * m:
        return 0
        
    for total_cuts in range(1, n + m):
        for x in range(total_cuts + 1):
            y = total_cuts - x
            
            if x >= m or y >= n:
                continue
                
            pieces = get_pieces(n, m, x, y)
            
            if can_make_sum(pieces, s):
                return total_cuts
    
    return -1

def main():
    n, m, s = map(int, input().split())
    result = solve(n, m, s)
    print(result)

if __name__ == "__main__":
    main()