def solve(n: int, m: int, s: int) -> int:
    if s == n * m:
        return 0
    if s == 1:
        return 1 if n == 1 or m == 1 else 2
        
    if s % n == 0 and s // n <= m:  
        return 1
    if s % m == 0 and s // m <= n:  
        return 1
        
    for x in range(1, m):  
        left_width = x
        right_width = m - x
        for y in range(1, n):  
            top_height = y
            bottom_height = n - y
            
            pieces = [
                top_height * left_width,
                top_height * right_width,
                bottom_height * left_width,
                bottom_height * right_width
            ]
        
            for mask in range(1 << 4):  
                current_sum = 0
                for i in range(4):
                    if mask & (1 << i):
                        current_sum += pieces[i]
                if current_sum == s:
                    return 2
    
    return 3  

def main():
    n, m, s = map(int, input().split())
    print(solve(n, m, s))

if __name__ == "__main__":
    main()