#include <iostream>
#include <vector>

using namespace std;

int solve(int n, int m, int s) {
    if (s == n * m) {
        return 0;
    }
    if (s == 1) {
        return (n == 1 || m == 1) ? 1 : 2;
    }
    
    if (s % n == 0 && s / n <= m) { 
        return 1;
    }
    if (s % m == 0 && s / m <= n) {  
        return 1;
    }
    
    for (int x = 1; x < m; x++) { 
        int left_width = x;
        int right_width = m - x;
        for (int y = 1; y < n; y++) {
            int top_height = y;
            int bottom_height = n - y;
            
            vector<int> pieces = {
                top_height * left_width,
                top_height * right_width,
                bottom_height * left_width,
                bottom_height * right_width
            };
            
            for (int mask = 0; mask < (1 << 4); mask++) {
                int current_sum = 0;
                for (int i = 0; i < 4; i++) {
                    if (mask & (1 << i)) {
                        current_sum += pieces[i];
                    }
                }
                if (current_sum == s) {
                    return 2;
                }
            }
        }
    }
    
    return 3; 
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;
    cout << solve(n, m, s) << endl;
    return 0;
}