n, q = map(int, input().split())

edges = {i: {} for i in range(1, n + 1)}

def add_edge(v, u, c):
    if c not in edges[v]:
        edges[v][c] = 0
    if c not in edges[u]:
        edges[u][c] = 0
    edges[v][c] += 1
    edges[u][c] += 1

def remove_edge(v, u, c):
    edges[v][c] -= 1
    edges[u][c] -= 1
    if edges[v][c] == 0:
        del edges[v][c]
    if edges[u][c] == 0:
        del edges[u][c]

def is_superior_color(c):
    for vertex in edges:
        if c in edges[vertex] and edges[vertex][c] > 1:
            return False
    return True

def get_superior_colors_sum():
    total = 0
    colors = set()
    for vertex in edges:
        colors.update(edges[vertex].keys())
    
    for color in colors:
        if is_superior_color(color):
            total += color
    return total

for _ in range(q):
    query = input().split()
    operation = query[0]
    v, u, c = map(int, query[1:])
    
    if operation == '+':
        add_edge(v, u, c)
    else:
        remove_edge(v, u, c)
    
    print(get_superior_colors_sum())