def calc_dist_to_line(x, y, x1, y1, x2, y2):
    A = y2 - y1
    B = x1 - x2
    C = x2 * y1 - x1 * y2
    return abs(A * x + B * y + C) / ((A * A + B * B) ** 0.5)

def solve(x1, y1, x2, y2, x3, y3):
    points = [(x1, y1), (x2, y2), (x3, y3)]
    min_dist = float('inf')
    best_p1 = best_p2 = None
    
    for i in range(3):
        for j in range(i + 1, 3):
            total_dist = 0
            for k in range(3):
                if k != i and k != j:
                    dist = calc_dist_to_line(points[k][0], points[k][1], 
                                          points[i][0], points[i][1],
                                          points[j][0], points[j][1])
                    total_dist += dist
            
            if total_dist < min_dist:
                min_dist = total_dist
                best_p1 = points[i]
                best_p2 = points[j]
    
    return best_p1[0], best_p1[1], best_p2[0], best_p2[1]

x1, y1, x2, y2, x3, y3 = map(int, input().split())

rx1, ry1, rx2, ry2 = solve(x1, y1, x2, y2, x3, y3)

print(rx1, ry1, rx2, ry2)