import math

def triangle_area(c, h):
    if c <= h:
        return -1

    try:
        product_ab = h * c

        discriminant = c**4 - 4 * product_ab**2

        if discriminant < 0:
            return -1

        root_discriminant = math.sqrt(discriminant)
        a = (c**2 + root_discriminant) / (2 * c)
        b = (c**2 - root_discriminant) / (2 * c)

        if a <= 0 or b <= 0:
            return -1


        area = 0.5 * a * b
        return round(area, 6)

    except ValueError:
        return -1

if __name__ == "__main__":
    c = int(input())
    h = int(input())
    print(triangle_area(c, h))
