import math

def solve_jump(x0, y0, x1, y1, n, a):
    total_distance = math.sqrt((x1 - x0)**2 + (y1 - y0)**2)

    if total_distance > sum(a):
        print("Impossible")
        return

    if (sum(a) - total_distance) % 2 != 0:
        print("Impossible")
        return

    print("Possible")
    current_x, current_y = x0, y0
    remaining_distance = total_distance

    for i in range(n):
        jump_length = a[i]

        if remaining_distance != 0:
            direction_x = (x1 - current_x) / remaining_distance
            direction_y = (y1 - current_y) / remaining_distance
        else:
            direction_x, direction_y = 0, 0

        next_x = current_x + direction_x * jump_length
        next_y = current_y + direction_y * jump_length
        remaining_distance -= jump_length

        print(f"{next_x:.8f} {next_y:.8f}")
        current_x, current_y = next_x, next_y


x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

solve_jump(x0, y0, x1, y1, n, a)
