n, m, s = map(int, input().split())

# Если вся площадь равна требуемой
if n * m == s:
    print(0)
else:
    # Переменная для хранения минимального количества разрезов
    min_cuts = float('inf')

    # Проверяем только горизонтальные разрезы
    for x in range(n):
        if s % (x + 1) == 0 and s // (x + 1) <= m:
            min_cuts = min(min_cuts, x)

    # Проверяем только вертикальные разрезы
    for y in range(m):
        if s % (y + 1) == 0 and s // (y + 1) <= n:
            min_cuts = min(min_cuts, y)

    # Проверяем комбинацию вертикальных и горизонтальных разрезов
    for x in range(n):
        for y in range(m):
            widths = [m // (x + 1)] * (x + 1)
            heights = [n // (y + 1)] * (y + 1)

            # Учитываем остатки
            for i in range(m % (x + 1)):
                widths[i] += 1
            for i in range(n % (y + 1)):
                heights[i] += 1

            # Считаем площади всех прямоугольников
            areas = [w * h for w in widths for h in heights]

            # Динамическое программирование для проверки суммы
            dp = [False] * (s + 1)
            dp[0] = True

            for area in areas:
                for t in range(s, area - 1, -1):
                    dp[t] = dp[t] or dp[t - area]

            if dp[s]:
                min_cuts = min(min_cuts, x + y)

    # Выводим результат
    print(min_cuts)
