def galactic_timeline(n, a, b):
    cards = [(a[i], b[i]) for i in range(n)]

    # Попробуем упорядочить карты
    cards.sort(key=lambda x: min(x))  # Сортируем по минимальному значению на карточке

    result_a = []
    result_b = []
    prev_a = prev_b = -1  # Начальные значения для проверки возрастающей последовательности

    for ai, bi in cards:
        # Выбираем оптимальное размещение карточки
        if ai >= prev_a and bi >= prev_b:
            # Карточку можно оставить как есть
            result_a.append(ai)
            result_b.append(bi)
            prev_a, prev_b = ai, bi
        elif bi >= prev_a and ai >= prev_b:
            # Переворачиваем карточку
            result_a.append(bi)
            result_b.append(ai)
            prev_a, prev_b = bi, ai
        else:
            # Невозможно упорядочить
            return -1

    # Возвращаем результат
    return result_a, result_b


# Ввод данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение
result = galactic_timeline(n, a, b)
if result == -1:
    print(result)
else:
    print(" ".join(map(str, result[0])))
    print(" ".join(map(str, result[1])))