#include<bits/stdc++.h>

using type = long double;

constexpr type EPS = 1e-10;

std::pair<bool, std::pair<type, type>> line_with_circle(type a, type b, type c, type r) {
	type x0 = -a * c / (a * a + b * b), y0 = -b * c / (a * a + b * b);
	if (c * c > r * r * (a * a + b * b) + EPS) {
		return {false, {0, 0}};
	} else if (std::abs(c * c - r * r * (a * a + b * b)) < EPS) {
		return {true, {x0, y0}};
	} else {
		type d = r * r - c * c / (a * a + b * b);
		type mult = sqrt(d / (a * a + b * b));
		return {true, {x0 + b * mult, y0 - a * mult}};
	}
}

std::pair<bool, std::pair<type, type>> circle_with_circle(type x1, type y1, type d1, type x2, type y2, type d2) {
	x2 -= x1, y2 -= y1;
	if (std::abs(x2) < EPS && std::abs(y2) < EPS) {
		if (std::abs(d1 - d2) < EPS) {
			return {true, {x1 + d1, y1}};
		} else {
			return {false, {0, 0}};
		}
	}
	auto [f, xy] = line_with_circle(-2 * x2, -2 * y2, x2 * x2 + y2 * y2 + d1 * d1 - d2 * d2, d1);
	xy.first += x1;
	xy.second += y1;
	return {f, xy};
}

std::istream& operator>>(std::istream& in, _Float128& a) {
	double b;
	in >> b;
	a = b;
	return in;
}

std::ostream& operator<<(std::ostream& out, _Float128 a) {
	double b = a;
	out << b;
	return out;
} 

int main() {
	std::cin.tie(nullptr)->sync_with_stdio(false);

	type x0, y0, x1, y1;
	std::cin >> x0 >> y0 >> x1 >> y1;
	type d = (x0 - x1) * (x0 - x1) + (y0 - y1) * (y0 - y1);
	int n;
	std::cin >> n;
	std::vector<type> a(n);
	for (auto& i : a) {
		int x;
		std::cin >> x;
		i = x;
	}
	std::vector<type> out(n), in(n);
	out[0] = a[0], in[0] = a[0];
	for (int i = 1; i < n; ++i) {
		out[i] = out[i - 1] + a[i];
		if (a[i] > out[i - 1]) {
			in[i] = std::abs(out[i - 1] - a[i]);
		} else {
			in[i] = std::max<type>(0, in[i - 1] - a[i]);
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	std::cout << std::fixed << std::setprecision(10) << in[i] << ' ' << out[i] << std::endl;
	// }
	if (in[n - 1] * in[n - 1] <= d && d <= out[n - 1] * out[n - 1]) {
		std::cout << "Possible\n";
		std::vector<std::pair<type, type>> ret = {{x1, y1}};
		for (int i = n - 1; i > 0; --i) {
			auto [f2, xy2] = circle_with_circle(x0, y0, in[i - 1], x1, y1, a[i]);
			auto [f3, xy3] = circle_with_circle(x0, y0, out[i - 1], x1, y1, a[i]);
			auto [x2, y2] = xy2;
			auto [x3, y3] = xy3;
			if (!f2 && !f3) {
				// std::cout << i << std::endl;
				x1 += a[i];
			} else if (f2) {
				x1 = x2, y1 = y2;
			} else {
				x1 = x3, y1 = y3;
			}
			// std::cout << i << ' ' << sqrt(x1 * x1 + y1 * y1) << std::endl;
			ret.emplace_back(x1, y1);
		}
		std::reverse(ret.begin(), ret.end());
		std::cout << std::fixed << std::setprecision(20);
		for (auto [x, y] : ret) std::cout << x << ' ' << y << '\n';
	} else {
		std::cout << "Impossible\n";
	}
}