#include<bits/stdc++.h>

using ll = int64_t;

ll mod = (1ll << 61) - 1;

ll add(ll a, ll b) {
	return a + b >= mod ? a + b - mod : a + b;
}
ll sub(ll a, ll b) {
	return a >= b ? a - b : a + mod - b;
}
ll mul(ll a, ll b) {
	return 1ll * a * b % mod;
}

ll base = 10;

struct hashing {
	std::vector<ll> pref, pw;

	hashing() = default;
	hashing(std::vector<int> a) {
		int n = a.size();
		pref.assign(n + 1, 0);
		pw.assign(n + 1, 1);
		for (int i = 0; i < n; ++i) {
			pref[i + 1] = add(mul(pref[i], base), a[i] + 1);
			pw[i + 1] = mul(pw[i], base);
		}
	}

	ll get(int l, int r) {
		return sub(pref[r + 1], mul(pref[l], pw[r - l + 1]));
	}
};

bool ckmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

signed main() {
	std::cin.tie(nullptr)->sync_with_stdio(false);

	int tests;
	std::cin >> tests;
	while (tests--) {
		int n, m, k;
		std::cin >> n >> m >> k;
		std::vector<int> p(n);
		std::vector<int> pos(n);
		for (int i = 0; i < n; ++i) {
			std::cin >> p[i];
			pos[--p[i]] = i;
		}
		std::vector<int> a(m);
		for (auto& i : a) std::cin >> i, --i;
		for (int i = 0; i < n; ++i) p.push_back(p[i]);
		hashing ha(a), hp(p);
		std::vector<std::vector<int>> start(n), end(n);
		std::vector<int> l(k), r(k);
		for (int i = 0; i < k; ++i) {
			std::cin >> l[i] >> r[i];
			--l[i], --r[i];
			int st = pos[a[l[i]]];
			start[pos[a[l[i]]]].push_back(i);
			end[pos[a[r[i]]]].push_back(i);
		}
		std::vector<int> dp(n, n + 1), par_id(n, -1), par_pos(n, -1), fst(n, -1);
		for (int i = n - 1; i >= 0; --i) {
			for (auto id : start[i]) {
				int d = r[id] - l[id];
				if (i + d >= n - 1) {
					if (hp.get(i, n - 1) == ha.get(l[id], l[id] + n - 1 - i)) {
						dp[i] = 1;
						par_id[i] = id;
						par_pos[i] = n;
						fst[i] = std::max(fst[i], id);
					}
				} else {
					if (hp.get(i, i + d) == ha.get(l[id], r[id])) {
						if (ckmin(dp[i], dp[i + d + 1] + 1)) {
							par_id[i] = id;
							par_pos[i] = i + d + 1;
							fst[i] = fst[i + d + 1];
						}
						if (dp[i] == dp[i + d + 1] + 1) {
							fst[i] = std::max(fst[i], fst[i + d + 1]);
						}
					}
				}
			}
		}
		int opt_pos = 0, opt_start = -1;
		int ans = dp[0];
		for (int i = 0; i < n; ++i) {
			for (auto id : end[i]) {
				int d = r[id] - l[id];
				if (i - d <= 0) {
					if (hp.get(0, i) == ha.get(r[id] - i, r[id]) && fst[i + 1] != id) {
						if (ckmin(ans, dp[i + 1] + 1)) {
							opt_pos = i + 1;
							opt_start = id;
						}
					}
				}
			}
		}
		if (ans <= n) {
			std::cout << ans << '\n';
			if (opt_start != -1) std::cout << opt_start + 1 << ' ';
			while (opt_pos < n) {
				std::cout << par_id[opt_pos] + 1 << ' ';
				opt_pos = par_pos[opt_pos];
			}
			std::cout << '\n';
		} else {
			std::cout << "-1\n";
		}
	}
}