#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Card {
    int front, back; 
    int index;       
};

bool solve(vector<Card>& cards, vector<int>& resultFront, vector<int>& resultBack) {
    sort(cards.begin(), cards.end(), [](Card& a, Card& b) {
        return min(a.front, a.back) < min(b.front, b.back);
    });

    int prevFront = 0, prevBack = 0;
    for (auto& card : cards) {
        if (card.front >= prevFront && card.back >= prevBack) {
            resultFront.push_back(card.front);
            resultBack.push_back(card.back);
            prevFront = card.front;
            prevBack = card.back;
        } else if (card.back >= prevFront && card.front >= prevBack) {
            resultFront.push_back(card.back);
            resultBack.push_back(card.front);
            prevFront = card.back;
            prevBack = card.front;
        } else {
            return false;
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;

    vector<Card> cards(n);
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].front;
        cards[i].index = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].back;
    }

    vector<int> resultFront, resultBack;
    if (solve(cards, resultFront, resultBack)) {
        for (int x : resultFront) cout << x << " ";
        cout << endl;
        for (int x : resultBack) cout << x << " ";
        cout << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
