#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Card {
    int front, back;
};

int main() {
    int n;
    cin >> n;
    vector<Card> cards(n + 1);

    for (int i = 1; i <= n; ++i) cin >> cards[i].front;
    for (int i = 1; i <= n; ++i) cin >> cards[i].back;

    vector<vector<bool>> dp(n + 1, vector<bool>(2, false));
    dp[1][0] = dp[1][1] = true;

    vector<vector<int>> prev(n + 1, vector<int>(2, -1));

    for (int i = 2; i <= n; ++i) {
        if (dp[i - 1][0]) {
            if (cards[i].front >= cards[i - 1].front) {
                dp[i][0] = true;
                prev[i][0] = 0;
            }
            if (cards[i].back >= cards[i - 1].front) {
                dp[i][1] = true;
                prev[i][1] = 0;
            }
        }
        if (dp[i - 1][1]) {
            if (cards[i].front >= cards[i - 1].back) {
                dp[i][0] = true;
                prev[i][0] = 1;
            }
            if (cards[i].back >= cards[i - 1].back) {
                dp[i][1] = true;
                prev[i][1] = 1;
            }
        }
    }

    if (!dp[n][0] && !dp[n][1]) {
        cout << -1 << endl;
        return 0;
    }
    vector<int> resultFront(n), resultBack(n);
    int currentState = dp[n][1] ? 1 : 0;

    for (int i = n; i >= 1; --i) {
        if (currentState == 0) {
            resultFront[i - 1] = cards[i].front;
            resultBack[i - 1] = cards[i].back;
        } else {
            resultFront[i - 1] = cards[i].back;
            resultBack[i - 1] = cards[i].front;
        }
        currentState = prev[i][currentState];
    }

    for (int x : resultFront) cout << x << " ";
    cout << endl;
    for (int x : resultBack) cout << x << " ";
    cout << endl;

    return 0;
}
